<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2003 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

error_reporting(E_ALL^E_NOTICE);

if (!eregi("admin.php", $PHP_SELF)) { die ("Access Denied"); }

define('AUTOTHEME_ADMIN_LOADED', true);
define('MOD_NAME', 'AutoTheme');

if (!defined('AUTOTHEME_API_LOADED')) {
	include("modules/AutoTheme/includes/atAPI.php");
}

$atdir = "modules/AutoTheme/";
atAdminInit($atdir);

/* Main autotheme selection form */
function AutoTheme_admin_main($var)
{
    $themelist = list_themes();

    if ($multibase = get_multisite_base()) {
        $multilist = list_multisite_themes($multibase);
        $themelist = array_merge($themelist, $multilist);
    }
    extract($var);

    AutoThemeHeader();
    OpenTable();
    echo "<b>"._ACTIVEAUTOTHEMES."</b><br />";

    foreach ($themelist as $key => $themedir) {
        echo "<a href=\"admin.php?module=".MOD_NAME."&op=modmain&themedir=$themedir\">$themedir</a><br />";
    }

    CloseTable();
    AutoThemeFooter();
}

/* Main autotheme configuration selection form */
function AutoTheme_admin_modmain($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    if (isset($import)) {
        $var = compact("themedir");
        AutoTheme_admin_import($var);
        return AutoTheme_admin_modmain($var);
    }
    AutoThemeHeader($themedir);
    OpenTable();
    
    if (ereg($GLOBALS['thename'], $themedir) && !isset($edit)) {
        echo "<b>"._NOTICE.":</b> "._ACTIVETHEMEMSG."<br /><br />"
        ."[ <a href=\"admin.php?module=".MOD_NAME."&op=modmain&themedir=$themedir&edit=1\">"._CONTINUE."</a> ]"
        ."  [ <a href=\"admin.php?module=".MOD_NAME."&op=main\"><b>"._CANCEL."</b></a> ]";

        CloseTable();
        AutoThemeFooter();

        return;
    }
    if (isset($strip_head) || is_array($block_display) || is_array($miscellaneous)) {
        echo "<b>"._NOTICE.":</b> "._OLDTHEMEMSG."<br /><br />"
        ."[ <a href=\"admin.php?module=".MOD_NAME."&op=modmain&themedir=$themedir&import=1\">"._IMPORT."</a> ]"
        ."  [ <a href=\"admin.php?module=".MOD_NAME."&op=main\"><b>"._CANCEL."</b></a> ]";
            
        CloseTable();
        AutoThemeFooter();
            
        return;
    }
    echo "<a href=\"admin.php?module=".MOD_NAME."&op=general&themedir=$themedir\"><b>"._GENERAL."</b></a><br /><br />"
    ."<b>"._CUSTMODULES."</b><br />";

    ksort($template);
	foreach ($template as $thememod => $innerarray) {
		switch ($thememod) {
                case "pnAdmin":
                case "nukeAdmin":
                case "*AdminPages":
                $thememod = "*AdminPages";
                break;

                case "pnHome":
                case "nukeHome":
                case "*HomePage":
                $thememod = "*HomePage";
                break;

                case "pnUser":
                case "nukeUser":
				case "*UserPages":
                $thememod = "*UserPages";
                break;
        }
		if ($thememod != "default") {
			echo "<a href=\"admin.php?module=".MOD_NAME."&op=general&themedir=$themedir&thememod=$thememod\">$thememod</a>"
			." [ <a href=\"admin.php?module=".MOD_NAME."&op=delmod&themedir=$themedir&thememod=$thememod\">"._REMOVE."</a> ]<br />";
		}
    }
    echo "<form method=\"POST\" action=\"admin.php\">\n"
	."<input type=\"hidden\" name=\"op\" value=\"addmod\">\n"
    ."<input type=\"hidden\" name=\"module\" value=\"". MOD_NAME."\">\n"
    ."<input type=\"hidden\" name=\"themedir\" value=\"$themedir\">\n"
    ."<input type=\"text\" name=\"thememod\" size=\"20\">\n"
	."<input type=\"submit\" value=\""._ADD."\" name=\"B1\">\n"
    ."</form>\n";
    CloseTable();
    OpenTable();

    echo "<br /><b>"._CUSTBLOCKS."</b><br />"
	."<form method=\"POST\" action=\"admin.php\">\n"
    ."  <input type=\"hidden\" name=\"op\" value=\"updateblock\">\n"
    ."  <input type=\"hidden\" name=\"module\" value=\"". MOD_NAME."\">\n"
    ."  <input type=\"hidden\" name=\"themedir\" value=\"$themedir\">\n";

    if ($blocktemplate){
        ksort($blocktemplate);
        foreach ($blocktemplate as $themeblock => $filename){
            $blockvar = strtolower(preg_replace("^\W|_^", "", $themeblock));
            $varval = htmlentities(urlencode($themeblock));
            echo "<input type=\"text\" name=\"$blockvar"."file\" value=\"$filename\" size=\"20\"> $themeblock\n"
            ." [ <a href=\"admin.php?module=".MOD_NAME."&op=delblock&themedir=$themedir&themeblock=$themeblock\">"._REMOVE."</a> ]<br />";
        }
        echo "<input type=\"submit\" value=\""._SAVE."\" name=\"B1\">\n"
        ."</form><br />\n";
    }
    echo "<form method=\"POST\" action=\"admin.php\">\n"
	."<input type=\"hidden\" name=\"op\" value=\"addblock\">\n"
    ."<input type=\"hidden\" name=\"module\" value=\"". MOD_NAME."\">\n"
    ."<input type=\"hidden\" name=\"themedir\" value=\"$themedir\">\n"
    ."<input type=\"text\" name=\"themeblock\" size=\"20\">\n"
	."<input type=\"submit\" value=\""._ADD."\" name=\"B1\">\n"
    ."</form>\n";

    CloseTable();
    AutoThemeFooter();
}

/* Add a module */
function AutoTheme_admin_addmod($var)
{
    extract($var);

   	if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
   	}
   	elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
   	}
   	if (!isset($template[$thememod]['default'])) {
    	$template[$thememod]['default'] = $template['default'];
   		$blockdisplay[$thememod]['default'] = $blockdisplay['default'];
   		$style[$thememod]['default'] = $style['default'];
		$var = compact("template", "blockdisplay", "style");
    	SaveThemeConfig($themedir, $var);
    }
   	Header("Location: admin.php?module=". MOD_NAME."&op=general&themedir=".htmlentities(urlencode($themedir))."&thememod=".htmlentities(urlencode($thememod)));
}

/* Delete a module */
function AutoTheme_admin_delmod($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    unset($template[$thememod], $blockdisplay[$thememod], $style[$thememod]);

	$var = compact("template", "blockdisplay", "style");
    SaveThemeConfig($themedir, $var);
    
    Header("Location: admin.php?module=". MOD_NAME."&op=modmain&themedir=".htmlentities(urlencode($themedir)));
}

/* Add a block */
function AutoTheme_admin_addblock($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    if ($themeblock && !$blocktemplate[$themeblock]) {
        $blocktemplate[stripslashes($themeblock)] = "";
    	$var = compact("blocktemplate");
    	SaveThemeConfig($themedir, $var);
    }
    Header("Location: admin.php?module=". MOD_NAME."&op=modmain&themedir=".htmlentities(urlencode($themedir)));
}

/* Delete a block */
function AutoTheme_admin_delblock($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
	    include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    $themeblock = stripslashes(stripslashes($themeblock));
    unset($blocktemplate[$themeblock]);

    $var = compact("blocktemplate");
    SaveThemeConfig($themedir, $var);

    Header("Location: admin.php?module=". MOD_NAME."&op=modmain&themedir=".htmlentities(urlencode($themedir)));
}

/* Update a block */
function AutoTheme_admin_updateblock($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    foreach ($blocktemplate as $themeblock => $filename){
        $blockvar = strtolower(preg_replace("^\W|_^", "", $themeblock));
        $tempblock[$themeblock] = ${$blockvar."file"};
    }
    $blocktemplate = $tempblock;

    $var = compact("blocktemplate");
    SaveThemeConfig($themedir, $var);

    Header("Location: admin.php?module=". MOD_NAME."&op=modmain&themedir=".htmlentities(urlencode($themedir)));
}

/* General theme settings */
function AutoTheme_admin_general($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
    }
    if (!isset($thememod)) {
    	$config = array_merge($template['default'], $blockdisplay['default'], $style['default']);
    	$temps = $template['default'];
    	$thiscfg = "General";
    }
    else {
		$config = array_merge($template[$thememod]['default'], $blockdisplay[$thememod]['default'], $style[$thememod]['default']);
		$temps = $template[$thememod]['default'];
		$thiscfg = $thememod;
	}
    $formvars = compact("temps", "config");

	AutoThemeHeader($themedir." > ".$thiscfg);
    AutoTheme_admin_generalform($var, $formvars);
    AutoThemeFooter();
}

/* Update general theme settings */
function AutoTheme_admin_updategeneral($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
            include("$themedir/theme.cfg");
    }
    if (!isset($thememod)) {
		$template['default'] = compact("main", "summary", "summary1", "summary2",
    		"article", "altsummary", "leftblock", "centerblock", "rightblock", "table1", "table2");
    	$blockdisplay['default'] = compact("left", "center", "right");
    	$style['default'] = compact("stylesheet", "logoimg", "color1", "color2", "color3",
    		"color4", "color5", "color6", "color7", "color8", "color9", "color10", "striphead", "head");

		for ($i = 1; $i <= 9; $i++) {
            $template['default']["Area".$i."block"] = ${"Area".$i."block"};
            $blockdisplay['default']["Area".$i] = ${"Area".$i};
    	}
    }
    else {
    	$template[$thememod]['default'] = compact("main", "summary", "summary1", "summary2",
    		"article", "altsummary", "leftblock", "centerblock", "rightblock", "table1", "table2");
    	$blockdisplay[$thememod]['default'] = compact("left", "center", "right");
    	$style[$thememod]['default'] = compact("stylesheet", "logoimg", "color1", "color2", "color3",
    		"color4", "color5", "color6", "color7", "color8", "color9", "color10", "striphead", "head");

		for ($i = 1; $i <= 9; $i++) {
            $template[$thememod]['default']["Area".$i."block"] = ${"Area".$i."block"};
            $blockdisplay[$thememod]['default']["Area".$i] = ${"Area".$i};
    	}
    }
	$var = compact("altsummary", "template", "blockdisplay", "style");
    SaveThemeConfig($themedir, $var);

    Header("Location: admin.php?module=". MOD_NAME."&op=modmain&themedir=".htmlentities(urlencode($themedir)));
}

/* Import an autotheme */
function AutoTheme_admin_import($var)
{
    extract($var);

    if (@file_exists("themes/$themedir/theme.cfg")) {
        include("themes/$themedir/theme.cfg");
        @copy("themes/$themedir/theme.cfg", "themes/$themedir/theme.cfg.bak");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        include("$themedir/theme.cfg");
        copy("$themedir/theme.cfg", "$themedir/theme.cfg.bak");
    }
    foreach ($template as $name => $value) {
        $key = str_replace("area", "Area", $name);
        $temp[$key] = $value;
    }
    foreach ($block_display as $name => $value) {
        $key = str_replace("area", "Area", $name);
        $block[$key] = (string)(int)$value;
    }
    unset($template);

    $template['default'] = $temp;
    $template['default']['altsummary'] = (string)(int)$alternate_summary;
    $blockdisplay['default'] = $block;

    extract($miscellaneous);
    $color1 = $bgcolor1;
    $color2 = $bgcolor2;
    $color3 = $bgcolor3;
    $color4 = $bgcolor4;
    $color5 = $textcolor1;
    $color6 = $textcolor2;
    $logoimg = $logo;
    $striphead = (int)$strip_head;
    $style['default'] = compact("stylesheet", "logoimg", "color1", "color2", "color3", "color4", "color5", "color6", "striphead");

    for ($index = 0; $index <= 1; $index++) {
        if ($custom_module) {
            foreach ($custom_module as $thememod => $innerarray) {
				if (is_array($thememod)) {
					foreach ($thememod as $name => $value) {
                    	$key = str_replace("area", "Area", $name);

                    	if (eregi("block", $key)) {
                        	$temp[$key] = $value;
                    	}
                    	elseif (eregi("Area", $key)) {
                        	$block[$key] = (string)(int)$value;
                    	}
                	}
                }
                if ($index == 1) {
                    $thememod = "*HomePage";
                }
                $template[$thememod]['default'] = $temp;
                $blockdisplay[$thememod]['default'] = $block;

                $template[$thememod]['default'] = array_merge($template['default'], $template[$thememod]['default']);
                $blockdisplay[$thememod]['default'] = array_merge($blockdisplay['default'], $blockdisplay[$thememod]['default']);

                extract($custom_module);
                $color1 = $bgcolor1;
                $color2 = $bgcolor2;
                $color3 = $bgcolor3;
                $color4 = $bgcolor4;
                $color5 = $textcolor1;
                $color6 = $textcolor2;
                $logoimg = $logo;
                $style[$thememod]['default'] = compact("stylesheet", "logoimg", "color1", "color2", "color3", "color4", "color5", "color6", "striphead");
                $style[$thememod]['default'] = array_merge($style['default'], $style[$thememod]['default']);
            }
        }
    }
    $blocktemplate = $custom_block;

    $var = compact("template", "blockdisplay", "style", "blocktemplate");
    SaveThemeConfig($themedir, $var);
}

/* Main configuration settings form */
function AutoTheme_admin_generalform($var, $formvars)
{
    extract($var);
    extract($formvars);
    extract($config);

echo "<form name=\"general\" method=\"POST\" action=\"admin.php\">\n";
if (isset($thememod)) {
    echo "  <input type=\"hidden\" name=\"thememod\" value=\"$thememod\">\n";
}
OpenTable();
echo "<b>"._TEMPLATES."</b><br />"
."  <input type=\"text\" name=\"main\" value=\"$main\"> "._MAIN."<br />\n"
."  <input type=\"text\" name=\"table1\" value=\"$table1\"> "._TBL." 1<br />\n"
."  <input type=\"text\" name=\"table2\" value=\"$table2\"> "._TBL." 2<br />\n";
if (!isset($thememod)  ||  $thememod == "*HomePage" || $thememod == "News") {
echo "  <input type=\"text\" name=\"summary\" value=\"$summary\"> "._SUMMARY."<br />\n"
."  <input type=\"text\" name=\"altsummary\" value=\"$altsummary\" size=\"1\"> "._ALTSUMMARY."<br />\n"
."  <input type=\"text\" name=\"summary1\" value=\"$summary1\"> "._SUMMARY." 1<br />\n"
."  <input type=\"text\" name=\"summary2\" value=\"$summary2\"> "._SUMMARY." 2<br />\n"
."  <input type=\"text\" name=\"article\" value=\"$article\"> "._ARTICLE."<br />\n";
}
CloseTable();
Opentable();
echo "<b>"._BLOCK." "._TEMPLATES."</b><br />"
."  <input type=\"text\" name=\"leftblock\" value=\"$leftblock\"> "._LEFT." "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"centerblock\" value=\"$centerblock\"> "._CENTER." "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"rightblock\" value=\"$rightblock\"> "._RIGHT." "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area1block\" value=\"$Area1block\"> Area1 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area2block\" value=\"$Area2block\"> Area2 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area3block\" value=\"$Area3block\"> Area3 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area4block\" value=\"$Area4block\"> Area4 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area5block\" value=\"$Area5block\"> Area5 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area6block\" value=\"$Area6block\"> Area6 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area7block\" value=\"$Area7block\"> Area7 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area8block\" value=\"$Area8block\"> Area8 "._BLOCK."<br />\n"
."  <input type=\"text\" name=\"Area9block\" value=\"$Area9block\"> Area9 "._BLOCK."<br />\n"
."</td><td valign=\"top\">"
."<b>"._BLOCK." "._DISPLAY."</b><br />"
."  <input type=\"text\" name=\"left\" value=\"$left\" size=\"1\"> "._LEFT."<br />\n"
."  <input type=\"text\" name=\"center\" value=\"$center\" size=\"1\"> "._CENTER."<br />\n"
."  <input type=\"text\" name=\"right\" value=\"$right\" size=\"1\"> "._RIGHT."<br />\n"
."  <input type=\"text\" name=\"Area1\" value=\"$Area1\" size=\"1\"> Area1<br />\n"
."  <input type=\"text\" name=\"Area2\" value=\"$Area2\" size=\"1\"> Area2<br />\n"
."  <input type=\"text\" name=\"Area3\" value=\"$Area3\" size=\"1\"> Area3<br />\n"
."  <input type=\"text\" name=\"Area4\" value=\"$Area4\" size=\"1\"> Area4<br />\n"
."  <input type=\"text\" name=\"Area5\" value=\"$Area5\" size=\"1\"> Area5<br />\n"
."  <input type=\"text\" name=\"Area6\" value=\"$Area6\" size=\"1\"> Area6<br />\n"
."  <input type=\"text\" name=\"Area7\" value=\"$Area7\" size=\"1\"> Area7<br />\n"
."  <input type=\"text\" name=\"Area8\" value=\"$Area8\" size=\"1\"> Area8<br />\n"
."  <input type=\"text\" name=\"Area9\" value=\"$Area9\" size=\"1\"> Area9<br />\n";
CloseTable();
OpenTable();
echo "<b>"._STYLE."</b><br />"
."  <input type=\"text\" name=\"color1\" value=\"$color1\" size=\"7\"> "._BG." "._COLOR."1<br />\n"
."  <input type=\"text\" name=\"color2\" value=\"$color2\" size=\"7\"> "._BG." "._COLOR."2<br />\n"
."  <input type=\"text\" name=\"color3\" value=\"$color3\" size=\"7\"> "._BG." "._COLOR."3<br />\n"
."  <input type=\"text\" name=\"color4\" value=\"$color4\" size=\"7\"> "._BG." "._COLOR."4<br />\n"
."  <input type=\"text\" name=\"color5\" value=\"$color5\" size=\"7\"> "._TXT." "._COLOR."1<br />\n"
."  <input type=\"text\" name=\"color6\" value=\"$color6\" size=\"7\"> "._TXT." "._COLOR."2<br />\n"
."  <input type=\"text\" name=\"color7\" value=\"$color7\" size=\"7\"> "._TBL." "._BORDER." "._COLOR."1<br />\n"
."  <input type=\"text\" name=\"color8\" value=\"$color8\" size=\"7\"> "._TBL." "._BG." "._COLOR."1<br />\n"
."  <input type=\"text\" name=\"color9\" value=\"$color9\" size=\"7\"> "._TBL." "._BORDER." "._COLOR."2<br />\n"
."  <input type=\"text\" name=\"color10\" value=\"$color10\" size=\"7\"> "._TBL." "._BG." "._COLOR."2<br />\n"
."  <input type=\"text\" name=\"logoimg\" value=\"$logoimg\"> "._LOGO." "._IMG."<br />\n"
."  <input type=\"text\" name=\"stylesheet\" value=\"$stylesheet\"> "._STYLESHEET."<br />\n"
."  <input type=\"text\" name=\"striphead\" value=\"$striphead\" size=\"1\"> "._STRIPTOHEAD."<br />\n"
."  <textarea name=\"head\" >$head</textarea> "._HEAD."<br />\n"
."  <input type=\"hidden\" name=\"module\" value=\"".MOD_NAME."\">\n"
."  <input type=\"hidden\" name=\"op\" value=\"updategeneral\">\n"
."  <input type=\"hidden\" name=\"themedir\" value=\"$themedir\">\n"
."  <input type=\"submit\" value=\""._SAVE."\" name=\"B1\"></td>\n"
."</form>\n";
CloseTable();
}

/* Write theme.cfg */
function SaveThemeConfig($themedir, $var)
{
    if (@file_exists("themes/$themedir/theme.cfg")) {
        $thecfg = "themes/$themedir/theme.cfg";
		include("themes/$themedir/theme.cfg");
    }
    elseif (@file_exists("$themedir/theme.cfg")) {
        $thecfg = "$themedir/theme.cfg";
		include("$themedir/theme.cfg");
    }
    extract($var);

    if (array_key_exists("pnHome", $template)) {
        $template['*HomePage'] = $template['pnHome'];
        $blockdisplay['*HomePage'] = $blockdisplay['pnHome'];
        $style['*HomePage'] = $style['pnHome'];
        unset($template['pnHome'], $blockdisplay['pnHome'], $style['pnHome']);
    }
    if (array_key_exists("pnAdmin", $template)) {
        $template['*AdminPages'] = $template['pnAdmin'];
        $blockdisplay['*AdminPages'] = $blockdisplay['pnAdmin'];
        $style['*AdminPages'] = $style['pnAdmin'];
        unset($template['pnAdmin'], $blockdisplay['pnAdmin'], $style['pnAdmin']);
    }
    if (array_key_exists("pnUser", $template)) {
        $template['*UserPages'] = $template['pnUser'];
        $blockdisplay['*UserPages'] = $blockdisplay['pnUser'];
        $style['*UserPages'] = $style['pnUser'];
        unset($template['pnUser'], $blockdisplay['pnUser'], $style['pnUser']);
    }
    if (array_key_exists("nukeHome", $template)) {
        $template['*HomePage'] = $template['nukeHome'];
        $blockdisplay['*HomePage'] = $blockdisplay['nukeHome'];
        $style['*HomePage'] = $style['nukeHome'];
        unset($template['nukeHome'], $blockdisplay['nukeHome'], $style['nukeHome']);
    }
    if (array_key_exists("nukeAdmin", $template)) {
        $template['*AdminPages'] = $template['nukeAdmin'];
        $blockdisplay['*AdminPages'] = $blockdisplay['nukeAdmin'];
        $style['*AdminPages'] = $style['nukeAdmin'];
        unset($template['nukeAdmin'], $blockdisplay['nukeAdmin'], $style['nukeAdmin']);
    }
    if (array_key_exists("nukeUser", $template)) {
        $template['*UserPages'] = $template['nukeUser'];
        $blockdisplay['*UserPages'] = $blockdisplay['nukeUser'];
        $style['*UserPages'] = $style['nukeUser'];
        unset($template['nukeUser'], $blockdisplay['nukeUser'], $style['nukeUser']);
    }
    if ($blocktemplate) {
        foreach ($blocktemplate as $key => $fn){
            $themeblock = addslashes($key);
            unset($blocktemplate[$key]);
            $blocktemplate[$themeblock] = $fn;
        }
    }
    else {
        $blocktemplate = array();
    }
    if ($themeversion) {
        foreach ($themeversion as $key => $val){
            $themeversion[$key] = stripslashes($val);
        }
    }
    else {
        $themeversion = array();
    }
    if (!$template) { $template = array(); }
    if (!$blockdisplay) { $blockdisplay = array(); }

    $content = STARTPHP."\n"
    .'$template = '
    .var_export($template, TRUE)
    .";\n"
    .'$blockdisplay = '
    .var_export($blockdisplay, TRUE)
    .";\n"
    .'$style = '
    .var_export($style, TRUE)
    .";\n"
    .'$blocktemplate = '
    .var_export($blocktemplate, TRUE)
    .";\n"
    .'$themeversion = '
    .var_export($themeversion, TRUE)
    .";\n".ENDPHP;

    $handle = fopen("$thecfg", "w");
	fwrite($handle, $content);
	fclose($handle);
}

function list_themes($dir="themes")
{
    if ($handle = @opendir($dir)) {
        while (false !== ($subdir = @readdir($handle))) {
            if (@is_dir("$dir/$subdir") &&
                $subdir !== '.' &&
                $subdir !== '..' &&
                @file_exists("$dir/$subdir/theme.cfg"))
            {
                $themelist[] = $subdir;
            }
        }
        closedir($handle);
    }
    return $themelist;
}

function list_multisite_themes($dir="parameters")
{
    $themelist = array();

    if ($handle = @opendir($dir)) {
        while (false !== ($subdir = @readdir($handle))) {
            if (@is_dir("$dir/$subdir/themes") &&
                $subdir !== '.' &&
                $subdir !== '..')
            {
                $multilist[$subdir] = list_themes("$dir/$subdir/themes");
            }
        }
        closedir($handle);
    }
    foreach ($multilist as $multidir => $list) {
        foreach ($list as $themedir) {
            $themelist[] = "$dir/$multidir/themes/$themedir";
        }
    }
    return $themelist;
}

function get_multisite_base()
{
    if (defined('WHERE_IS_PERSO')) {
        array_pop($pathparts = explode("/", WHERE_IS_PERSO));
        array_pop($pathparts);
        $multibase = implode("/", $pathparts);

        return $multibase;
    }
    else {
        return false;
    }
}

/* Admin header */
function AutoThemeHeader($title="")
{
    include("header.php");
    echo "<div align=\"center\"><b><a href=\"admin.php?module=".MOD_NAME."&op=main\">"._ATADMIN."</a></b><br />$title</div>";
}

/* Admin footer */
function AutoThemeFooter()
{
    include("footer.php");
}

function atAdminInit($atdir)
{
    $incdir = $atdir."includes/";
    $platform = atGetPlatform();
    $platformdir = $incdir."$platform/";

    include_once($incdir."phpFuncs.php");
    include_once($platformdir."atAPI.php");
    include_once($platformdir."atAdmin.php");

    atModLangLoad('admin');
}

?>
