<?php // $Id: bk-functions.php,v 1.1.1.1 2004/05/06 03:54:09 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

function vote_func($mquery,$totalvotesDB) {

//This function returns an array of six values:
//retval[0]=$finalresult, [1]=$anonvotes, [2]=$regvotes, [3]=$truecomments
//                [4]=$avgRU  [5]=$avgAu

$anonweight=pnModGetVar('books','anonweight');
$retval=array(0,0,0,0,0,0); 
$anonvotes = 0;
$regvotes = 0;
$anonvoteval = 0;
$regvoteval = 0;
$avgRU = 0;
$avgAU = 0;
$truecomments = $totalvotesDB;

while(list($ratingDB, $ratinguserDB, $ratingcommentsDB) = mysql_fetch_row($mquery)) {

    if ($ratingcommentsDB == "") {
        --$truecomments;
    }

    if ($ratinguserDB == "") {
        $anonvotes++;
        $anonvoteval += $ratingDB;
    } else {
        $regvoteval += $ratingDB;
    }
}

$regvotes = $totalvotesDB - $anonvotes;

if ($totalvotesDB == 0) {
    $finalrating = 0;
    $retval[0]= $finalrating;
    $retval[1]= $anonvotes;
    $retval[2]= $regvotes;
    $retval[3]= $truecomments;
    $retval[4]= $avgRU;
    $retval[5]= $avgAU;
    return $retval;
   }
elseif ($regvotes == 0) {
    /* Figure Anon Only Vote */
    $finalrating = $anonvoteval / $anonvotes;
    $finalrating = number_format($finalrating, 4);
    $retval[0]= $finalrating;
    $retval[1]= $anonvotes;
    $retval[2]= $regvotes;
    $retval[3]= $truecomments;
    $retval[4]= $avgRU;
    $retval[5]= $avgAU;
    return $retval;
   } 
elseif ($anonvotes == 0) {
    /* Figure Reg Only Vote */
    $finalrating = $regvoteval / $regvotes;
    $finalrating = number_format($finalrating, 4);
    $retval[0]= $finalrating;
    $retval[1]= $anonvotes;
    $retval[2]= $regvotes;
    $retval[3]= $truecomments;
    $retval[4]= $avgRU;
    $retval[5]= $avgAU;
    return $retval;
} 
else {
    /* Registered User vs. Anonymous User Weight Calculations */
    $impact = $anonweight;

    if ($regvotes == 0) {
        $regvotes = 0;
    } else {
        $avgRU = $regvoteval / $regvotes;
    }

    if ($anonvotes == 0) {
        $avgAU = 0;
    } else {
        $avgAU = $anonvoteval / $anonvotes;
    }

    $impactRU = $regvotes;
    $impactAU = $anonvotes / $impact;
    $finalrating = (($avgRU * $impactRU) + ($avgAU * $impactAU)) / ($impactRU + $impactAU);
   $finalrating = number_format($finalrating, 4);
    $retval[0]= $finalrating;
    $retval[1]= $anonvotes;
    $retval[2]= $regvotes;
    $retval[3]= $truecomments;
    $retval[4]= $avgRU;
    $retval[5]= $avgAU;
    return $retval;
}
}


/*--------------------------------------------------------------------------
 * function  ConvertOrderByIN
 *--------------------------------------------------------------------------
 * purpose   convert "order by" to SQL representation
 * input     $orderby
 * output    $orderby
 * changes   -
 *--------------------------------------------------------------------------*/
function ConvertOrderByIN($orderby) {
    if ($orderby == "titleA")   $orderby = "title ASC";
    if ($orderby == "dateA")    $orderby = "date ASC";
    if ($orderby == "hitsA")    $orderby = "hits ASC";
    if ($orderby == "ratingA")  $orderby = "bookratingsummary ASC";
    if ($orderby == "titleD")   $orderby = "title DESC";
    if ($orderby == "dateD")    $orderby = "date DESC";
    if ($orderby == "hitsD")    $orderby = "hits DESC";
    if ($orderby == "ratingD")  $orderby = "bookratingsummary DESC";
    return $orderby;
}

/*--------------------------------------------------------------------------
 * function  ConvertOrderByTRANS
 *--------------------------------------------------------------------------
 * purpose   translate a "order by" clause
 * input     $orderby
 * output    $orderbyTrans
 * changes   -
 *--------------------------------------------------------------------------*/
function ConvertOrderByTRANS($orderby) {
    if ($orderby == "hits ASC")         $orderbyTrans = ""._POPULARITY1."";
    if ($orderby == "hits DESC")        $orderbyTrans = ""._POPULARITY2."";
    if ($orderby == "title ASC")        $orderbyTrans = ""._TITLEAZ."";
    if ($orderby == "title DESC")       $orderbyTrans = ""._TITLEZA."";
    if ($orderby == "date ASC")         $orderbyTrans = ""._DATE1."";
    if ($orderby == "date DESC")        $orderbyTrans = ""._DATE2."";
    if ($orderby == "bookratingsummary ASC")    $orderbyTrans = ""._RATING1."";
    if ($orderby == "bookratingsummary DESC")   $orderbyTrans = ""._RATING2."";
    return $orderbyTrans;
}

/*--------------------------------------------------------------------------
 * function  ConvertOrderByOUT
 *--------------------------------------------------------------------------
 * purpose   convert a SQL statement to a "order by" which can be used in URL
 * input     $orderby
 * output    $orderby
 * changes   -
 *--------------------------------------------------------------------------*/
function ConvertOrderByOUT($orderby) {
    if ($orderby == "title ASC")        $orderby = "titleA";
    if ($orderby == "date ASC")         $orderby = "dateA";
    if ($orderby == "hits ASC")         $orderby = "hitsA";
    if ($orderby == "bookratingsummary ASC")    $orderby = "ratingA";
    if ($orderby == "title DESC")       $orderby = "titleD";
    if ($orderby == "date DESC")        $orderby = "dateD";
    if ($orderby == "hits DESC")        $orderby = "hitsD";
    if ($orderby == "bookratingsummary DESC")   $orderby = "ratingD";
    return $orderby;
}

/*--------------------------------------------------------------------------
 * function  FormatDate
 *--------------------------------------------------------------------------
 * purpose   format a date for output
 * input     $aformat   : date time formatstring for strfdat()
 *           $adatetime : datetimestring to format
 * output    formatted datetime string
 * changes   2001-09-24 [MS] introduced this service function
 *--------------------------------------------------------------------------*/
function FormatDateTime($aformat, $adatetime) {
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $adatetime, $tmpdate);
    ereg ("([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $adatetime, $tmptime);
    return strftime($aformat, mktime($tmptime[1],$tmptime[2],$tmptime[3],$tmpdate[2],$tmpdate[3],$tmpdate[1]));
}

/*--------------------------------------------------------------------------
 * function  imgNewGraphic
 *--------------------------------------------------------------------------
 * purpose   Show a "new" image, when $adate is less than 7 days
 * input     $adate     a date
 *           $atyp      adate format: 0 - yyyy-mm-dd
                                      1 - dd. mmm yyyy - hh:mm
 * output    -
 * changes   2002-01-22 [MS] taken from books-module
 *--------------------------------------------------------------------------*/
function imgNewGraphic($adate,$atyp=0) {
    global $modset;
    setlocale ("LC_TIME", "$locale");
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $adate, $tmpdate);
    $thisdate = date("d-M-Y",mktime(0,0,0,$tmpdate[2],$tmpdate[3],$tmpdate[1]));
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
    $daysold = date("d-M-Y", $startdate);
        if ("$daysold" == "$thisdate") {
            if ($count<=1) {
        echo "&nbsp;<img src=\"images/common/newred.gif\" alt=\""._NEWTODAY."\" border=\"0\">&nbsp;";
        }
            if ($count<=3 && $count>1) {
        echo "&nbsp;<img src=\"images/common/newgreen.gif\" alt=\""._LAST3DAYS."\" border=\"0\">&nbsp;";
        }
            if ($count<=7 && $count>3) {
        echo "&nbsp;<img src=\"images/common/newblue.gif\" alt=\""._THISWEEK."\" border=\"0\">&nbsp;";
        }
    }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
} // end imgNewGraphic

/*--------------------------------------------------------------------------
 * function  visit
 *--------------------------------------------------------------------------
 * purpose   go to given url of $abkid
 * input     $bkid    :  a book id
 *           $orderid : a order id, 1 if none is given
 * output    -
 * changes   2001-09-21 [MS] user order1, ..2, ..3
 *--------------------------------------------------------------------------*/
function visit($abkid, $orderid = 1) {
    global $pntable, $modset;
    mysql_query("update $pntable[books_books] set hits=hits+1 where bkid=$abkid");
    $result = mysql_query("select order$orderid from $pntable[books_books] where bkid=$abkid");
    list($url) = mysql_fetch_row($result);
    Header("Location: $url");
}

?>
