<?php // $Id: pninit.php,v 1.1.1.1 2004/05/06 03:54:13 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

function books_initmodvars()
{

    // Set up an initial value for a module variable.  

    pnModSetVar('books', 'booksperpage', 5);
    pnModSetVar('books', 'booksresults', 10);
    pnModSetVar('books', 'anonweight', 4);
    pnModSetVar('books', 'popular', 8);
    pnModSetVar('books', 'anonwaitdays', 5);
    pnModSetVar('books', 'bookvotemin', 5);
    pnModSetVar('books', 'detmult', 20);
    pnModSetVar('books', 'emptyimage', 'nopicture.gif');
    pnModSetVar('books', 'urlinsert', 'modules.php?op=modload&amp;name=books&amp;file=index');
    pnModSetVar('books', 'urlinsfunc', 'modules.php?op=modload&amp;name=books&amp;file=index&amp;req');
    pnModSetVar('books','booksdir', 'modules/books/images/books');
    pnModSetVar('books','imagesdir', 'modules/books/images');
    pnModSetVar('books','showsubcat', 1);
    pnModSetVar('books','isbn_check', 1);
    // Set tablecolor to null means that background matches theme
    pnModSetVar('books','tablecolor', '');
    pnModSetVar('books','barcolor', '#A5D30C');
    pnModSetVar('books','showlastbooks', 1);
    pnModSetVar('books','books_showed', 3);

return true;
}

function books_delmodvars()
{

    // Delete any module variables

    pnModDelVar('books', 'booksperpage');
    pnModDelVar('books', 'booksresults');
    pnModDelVar('books', 'anonweight');
    pnModDelVar('books', 'popular');
    pnModDelVar('books', 'anonwaitdays');
    pnModDelVar('books', 'bookvotemin');
    pnModDelVar('books', 'detmult');
    pnModDelVar('books', 'emptyimage');
    pnModDelVar('books', 'urlinsert');
    pnModDelVar('books', 'urlinsfunc');
    pnModDelVar('books', 'booksdir');
    pnModDelVar('books', 'imagesdir');
    pnModDelVar('books','showsubcat');
    pnModDelVar('books','isbn_check');
    pnModDelVar('books','tablecolor');
    pnModDelVar('books','barcolor');
    pnModDelVar('books','showlastbooks');
    pnModDelVar('books','books_showed');

return true;
}


/**
 * initialise the template module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function books_init()
{


    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

$templatecolumn = &$pntable['books_categories_column'];

 $sql = "CREATE TABLE $pntable[books_categories] (
       $templatecolumn[cid] int(11) DEFAULT '0' NOT NULL auto_increment, 
       $templatecolumn[title] varchar(50) NOT NULL, 
       $templatecolumn[cdescription] text NOT NULL, 
       $templatecolumn[language] varchar(3),
       PRIMARY KEY (cid) )";

    $dbconn->Execute($sql);

//Just in case the user screws things up, we need to check here
//and figure out if the books database already exists, and if
//it does, which version exists.

       if (mysql_errno() == 1050) {

         $newresult = mysql_query("select language from $pntable[books_books]");
   
         if ($newresult) {
          pnSessionSetVar('errormsg','You already have a books .72x database installed -- skipping books table creation and initializing the books module');
          books_initmodvars();
          return true;
         } else {
         pnSessionSetVar('errormsg','You already have a Books .714 database installed -- you need to read the installation instructions and run the upgrade.php script. Exiting now without starting books module');
          return false;
         }
       }

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table1 Creation Failed');
        return false;
    }

$templatecolumn = &$pntable['books_subcategories_column'];

    $sql = "
    CREATE TABLE $pntable[books_subcategories] (
        $templatecolumn[sid] int(11) DEFAULT '0' NOT NULL auto_increment,
        $templatecolumn[cid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[title] varchar(50) NOT NULL,
        $templatecolumn[language] varchar(3),
        PRIMARY KEY (sid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table2 Creation Failed');
        return false;
    }


$templatecolumn = &$pntable['books_editorials_column'];

    $sql = "
    CREATE TABLE $pntable[books_editorials] (
        $templatecolumn[bookid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[adminid] varchar(60) NOT NULL,
        $templatecolumn[editorialtimestamp] datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
        $templatecolumn[editorialtext] text NOT NULL,
        $templatecolumn[editorialtitle] varchar(100) NOT NULL,
        $templatecolumn[language] varchar(3),
        PRIMARY KEY (bookid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table3 Creation Failed');
        return false;
    }

$templatecolumn = &$pntable['books_books_column'];

$sql = "
    CREATE TABLE $pntable[books_books] (
        $templatecolumn[bkid] int(11) DEFAULT '0' NOT NULL auto_increment,
        $templatecolumn[cid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[sid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[isbn] varchar(12) DEFAULT '0' NOT NULL,
        $templatecolumn[title] varchar(100) NOT NULL,
        $templatecolumn[author] varchar(100) NOT NULL,
        $templatecolumn[description] text NOT NULL,
        $templatecolumn[date] datetime,
        $templatecolumn[order1] varchar(150),
        $templatecolumn[order2] varchar(150),
        $templatecolumn[order3] varchar(150),
        $templatecolumn[order4] varchar(150),
        $templatecolumn[order5] varchar(150),
        $templatecolumn[order6] varchar(150),
        $templatecolumn[cover] varchar(100),
        $templatecolumn[hits] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[submitter] varchar(60) NOT NULL,
        $templatecolumn[bookratingsummary] double(6,4) DEFAULT '0.0000' NOT NULL,
        $templatecolumn[totalvotes] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[totalcomments] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[language] varchar(3),
        PRIMARY KEY (bkid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table4 Creation Failed');
        return false;
    }


$templatecolumn = &$pntable['books_modrequest_column'];

$sql = "
    CREATE TABLE $pntable[books_modrequest] (
        $templatecolumn[requestid] int(11) DEFAULT '0' NOT NULL auto_increment,
        $templatecolumn[bkid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[cid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[sid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[title] varchar(100) NOT NULL,
        $templatecolumn[author] varchar(100) NOT NULL,
        $templatecolumn[description] text NOT NULL,
        $templatecolumn[modifysubmitter] varchar(60) NOT NULL,
        $templatecolumn[brokenlink] int(3) DEFAULT '0' NOT NULL,
        PRIMARY KEY (requestid),
        UNIQUE requestid (requestid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table5 Creation Failed');
        return false;
    }

$templatecolumn = &$pntable['books_newbook_column'];

$sql = "
    CREATE TABLE $pntable[books_newbook] (
        $templatecolumn[bkid] int(11) DEFAULT '0' NOT NULL auto_increment,
        $templatecolumn[cid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[sid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[isbn] varchar(12) DEFAULT '0' NOT NULL,
        $templatecolumn[title] varchar(100) NOT NULL,
        $templatecolumn[author] varchar(100) NOT NULL,
        $templatecolumn[description] text NOT NULL,
        $templatecolumn[name] varchar(100) NOT NULL,
        $templatecolumn[email] varchar(100) NOT NULL,
        $templatecolumn[submitter] varchar(60) NOT NULL,
        PRIMARY KEY (bkid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table6 Creation Failed');
        return false;
    }

$templatecolumn = &$pntable['books_votedata_column'];

  $sql = "
    CREATE TABLE $pntable[books_votedata] (
        $templatecolumn[ratingdbid] int(11) DEFAULT '0' NOT NULL auto_increment,
        $templatecolumn[ratingbkid] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[ratinguser] varchar(60) NOT NULL,
        $templatecolumn[rating] int(11) DEFAULT '0' NOT NULL,
        $templatecolumn[ratinghostname] varchar(60) NOT NULL,
        $templatecolumn[ratingcomments] text NOT NULL,
        $templatecolumn[ratingtimestamp] datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
        PRIMARY KEY (ratingdbid)
    )";


    $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'books Module Table7 Creation Failed');
        return false;
    }


    // Set up an initial value for a module variable.  Note that all module
    // variables should be initialised with some value in this way rather
    // than just left blank, this helps the user-side code and means that
    // there doesn't need to be a check to see if the variable is set in
    // the rest of the code as it always will be

    books_initmodvars();

    // Initialisation successful
    return true;
}

/**
 * upgrade the template module from an old version
 * This function can be called multiple times
 */
function books_upgrade($oldversion)
{

    pnSessionSetVar('errormsg', 'Run upgrade.php in your books directory to upgrade your books database tables to the latest version.');

// Upgrade dependent on old version number
    switch($oldversion) {
        case '0.714beta':
// Since several versions of Postnuke don't do this correctly,
// we're just going to leave it blank. Follow the installation
// instructions in doc/install.txt and run the upgrade script
// to upgrade your books database.
            break;
    }

// Update successful
    return true;
}

/**
 * delete the template module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function books_delete()
{

    books_delmodvars();

    pnSessionSetVar('errormsg', 'Run delete.php in your books directory to delete the books database tables from your database.');

    return true;
}

?>
