<?php // $Id: pntables.php,v 1.1.1.1 2004/05/06 03:54:13 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

/**
 * This function is called internally by the core whenever the module is
 * loaded.  It adds in the information
 */
function books_pntables()
{
    // Initialise table array
    $pntable = array();

    // Get the name for the template item table.  This is not necessary
    // but helps in the following statements and keeps them readable
    $template = pnConfigGetVar('prefix') . '_books';

    // Set the table names

    $pntable['books_categories'] = $template.'_categories';
    $pntable['books_subcategories'] = $template.'_subcategories';
    $pntable['books_editorials'] = $template.'_editorials';
    $pntable['books_books'] = $template.'_books';
    $pntable['books_modrequest'] = $template.'_modrequest';
    $pntable['books_newbook'] = $template.'_newbook';
    $pntable['books_votedata'] = $template.'_votedata';

    // Set the column names.  Note that the array has been formatted
    // on-screen to be very easy to read by a user.

    $pntable['books_categories_column'] = 
     array('cid'    => $template . '_categories.cid',
           'title'   => $template . '_categories.title',
           'cdescription' => $template . '_categories.cdescription',
           'language' => $template . '_books.language');


    $pntable['books_subcategories_column'] = 
     array('sid'    => $template . '_subcategories.sid',
           'cid'   => $template . '_subcategories.cid',
           'title' => $template . '_subcategories.title',
           'language' => $template . '_books.language');


    $pntable['books_editorials_column'] = 
     array('bookid'    => $template . '_editorials.bookid',
           'adminid'   => $template . '_editorials.adminid',
           'editorialtimestamp' => $template . '_editorials.editorialtimestamp',
           'editorialtext'   => $template . '_editorials.editorialtext',
           'editorialtitle'   => $template . '_editorials.editorialtitle',
         'language' => $template . '_books.language');


    $pntable['books_books_column'] = 
     array('bkid'    => $template . '_books.bkid',
           'cid'   => $template . '_books.cid',
           'sid'   => $template . '_books.sid',
           'isbn'   => $template . '_books.isbn',
           'title'   => $template . '_books.title',
           'author'   => $template . '_books.author',
           'description'   => $template . '_books.description',
           'date'   => $template . '_books.date',
           'order1' => $template . '_books.order1',
           'order2' => $template . '_books.order2',
           'order3' => $template . '_books.order3',
           'order4' => $template . '_books.order4',
           'order5' => $template . '_books.order5',
           'order6' => $template . '_books.order6',
           'cover' => $template . '_books.cover',
           'hits' => $template . '_books.hits',
           'submitter' => $template . '_books.submitter',
           'bookratingsummary' => $template . '_books.bookratingsummary',
           'totalvotes' => $template . '_books.totalvotes',
           'totalcomments' => $template . '_books.totalcomments',
           'language' => $template . '_books.language');

    $pntable['books_modrequest_column'] = 
     array('requestid'    => $template . '_modrequest.requestid',
           'bkid'   => $template . '_modrequest.bkid',
           'cid'   => $template . '_modrequest.cid',
           'sid'   => $template . '_modrequest.sid',
           'title'   => $template . '_modrequest.title',
           'author'   => $template . '_modrequest.author',
           'description'   => $template . '_modrequest.description',
           'modifysubmitter'   => $template . '_modrequest.modifysubmitter',
           'brokenlink' => $template . '_modrequest.brokenlink');

    $pntable['books_newbook_column'] = 
     array('bkid'    => $template . '_newbook.bkid',
           'cid'   => $template . '_newbook.cid',
           'sid'   => $template . '_newbook.sid',
           'isbn'   => $template . '_newbook.isbn',
           'title'   => $template . '_newbook.title',
           'author'   => $template . '_newbook.author',
           'description'   => $template . '_newbook.description',
           'name'   => $template . '_newbook.name',
           'email'   => $template . '_newbook.email',
           'submitter'   => $template . '_newbook.submitter');


    $pntable['books_votedata_column'] = 
     array('ratingdbid'    => $template . '_votedata.ratingdbid',
           'ratingbkid'   => $template . '_votedata.ratingbkid',
           'ratinguser'   => $template . '_votedata.ratinguser',
           'rating'   => $template . '_votedata.rating',
           'ratinghostname'   => $template . '_votedata.ratinghostname',
           'ratingcomments'   => $template . '_votedata.ratingcomments',
           'ratingtimestamp'   => $template . '_votedata.ratingtimestamp');

    // Return the table information
    return $pntable;
}

?>
