<?php
// $Id: pnadmin.php,v 1.3 2004/05/14 18:43:22 dyksjare Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file:  Template administration display functions
// ----------------------------------------------------------------------

/**
 * the main administration function
 * This function is the default function, and is called whenever the
 * module is initiated without defining arguments.  As such it can
 * be used for a number of things, but most commonly it either just
 * shows the module menu and returns or calls whatever the module
 * designer feels should be the default function (often this is the
 * view() function)
 */

function cwiab_settings_admin_main()
{
    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);


    // Check Permissions
    if (!(pnSecAuthAction(0, 'cwiab_settings::', '::', ACCESS_ADMIN))) {
        $output->Text(_SETTINGSNOAUTH);
        return $output->GetOutput();
    }

    // Definition of Settings Fields. Add/reorder as required.
    $fields = array('cwiab_name'       => _CWIABNAME,
                    'cwiab_slogan'     => _CWIABSLOGAN,
                    'cwiab_address1'   => _CWIABADDR1,
                    'cwiab_address2'   => _CWIABADDR2,
                    'cwiab_address3'   => _CWIABADDR3,
                    'cwiab_city'       => _CWIABCITY,
                    'cwiab_state'      => _CWIABSTATE,
                    'cwiab_country'    => _CWIABCOUNTRY,
                    'cwiab_zip'        => _CWIABZIP,
                    'cwiab_phone'      => _CWIABPHONE,
                    'cwiab_fax'        => _CWIABFAX,
                    'cwiab_times'      => _CWIABTIMES,                    
                    'cwiab_info'       => _CWIABINFO,
                    'cwiab_webmaster'  => _CWIABWEBMASTER,
                    'cwiab_denom'      => _CWIABDENOM,
                    'cwiab_denom_site' => _CWIABDENOMURL,
                    'cwiab_denom_logo' => _CWIABDENOMLOGOURL,
                    'cwiab_copyright'  => _CWIABCOPYRIGHT);

    // Save changes if settings just were changed
    $save = pnVarCleanFromInput("Save");
    if ($save) {
        $output = cwiab_settings_admin_save($output, $fields);
    }

    // Display Current Settings
    $output = cwiab_settings_admin_display($output, $fields);

    return $output->GetOutput();
}


// Read and display the current Settings
function cwiab_settings_admin_display($output, $fields)
{
    $output->Text("<p align=center><font size=4 class=pn-pagetitle>".pnVarPrepForDisplay(_CWIABSETTINGSTITLE)."</font></p>");
    $output->Text("<p>"._CWIABSETTINGSDESCR."</p>");
    $output->FormStart();
    $output->TableStart(); 
    foreach ($fields as $field => $description) {
        $value = unserialize(pnModGetVar('cwiab_settings', $field));
        $output->TableRowStart();
        $output->TableColStart(1, "right");
        $output->Text(pnVarPrepForDisplay($description).": ");
        $output->TableColEnd();
        $output->TableColStart(1, "left");
        $output->FormText($field, $value, 40, 512);
        $output->TableColEnd();
        $output->TableRowEnd();
    }
    $output->TableRowStart();
    $output->TableColStart(2, "right");
    $output->LineBreak();
    $output->Text(pnVarPrepForDisplay(_CWIABREGENINFO)."&nbsp;");
    $output->FormCheckbox("cwiab_regenerateInfo", false);
    $output->TableColEnd();
    $output->TableRowEnd();
    $output->TableRowStart();
    $output->TableColStart(2, "right");
    $output->Text(pnVarPrepForDisplay(_CWIABREGENDENOM)."&nbsp;");
    $output->FormCheckbox("cwiab_regenerateDenom", false);
    $output->TableColEnd();
    $output->TableRowEnd();
    $output->TableRowStart();
    $output->TableColStart(2);
    $output->LineBreak(2);
    $output->FormHidden("Save", "1");
    $output->FormSubmit(pnVarPrepForDisplay(_CWIABUPDATE));
    $output->TableColEnd();
    $output->TableRowEnd();
    $output->TableEnd();
    $output->FormEnd();

    return $output;
}


// Save the Info Everywhere it needs to be within CWIAB
function cwiab_settings_admin_save($output, $fields)
{
    // Block ID of the Information and Denomination Blocks
    $info_bid  = 20;
    $denom_bid = 21;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Save the serialized info via pnModSetVar
    foreach ($fields as $field => $description) {
        $value = pnVarCleanFromInput($field);
        pnModSetVar('cwiab_settings', $field, serialize($value));
    }

    /////////////////////////////////////////////////////////////////////
    //////// Propagate information to various tables in CWIAB ///////////
    /////////////////////////////////////////////////////////////////////
    
    // Site Name
    $value = pnVarCleanFromInput('cwiab_name');
    pnModSetVar('/PNConfig','sitename', serialize($value));
    $sql = "UPDATE phpbb_config SET config_value='".$value."' WHERE config_name='sitename'";
    $result = $dbconn->Execute($sql);

    // Site Slogan
    $value = pnVarCleanFromInput('cwiab_slogan');
    pnModSetVar('/PNConfig','slogan', serialize($value));
    $sql = "UPDATE phpbb_config SET config_value='".$value."' WHERE config_name='site_desc'";
    $result = $dbconn->Execute($sql);

    // Webmaster email
    $value = pnVarCleanFromInput('cwiab_webmaster');
    pnModSetVar('/PNConfig','notify_email', serialize($value));
    pnModSetVar('/PNConfig','notify_from', serialize($value));
    pnModSetVar('/PNConfig','reg_notifyEmail', serialize($value));
    $sql = "UPDATE phpbb_config SET config_value='".$value."' WHERE config_name='board_email'";
    $result = $dbconn->Execute($sql);

    // Info email -- Use as email on administrator's account
    $value = pnVarCleanFromInput('cwiab_info');
    pnModSetVar('/PNConfig','adminmail', serialize($value));
    pnModSetVar('PostCalendar','pcNotifyEmail', $value);
    $sql = "UPDATE phpbb_users SET user_email='".$value."' WHERE username='admin'";
    $result = $dbconn->Execute($sql);
    $sql = "UPDATE nuke_users SET pn_email='".$value."' WHERE pn_uid=2";
    $result = $dbconn->Execute($sql);

    // Rebuild Contact Info [Address, Phone, Fax & email]
    if (pnVarCleanFromInput('cwiab_regenerateInfo')) {
        $info = new pnHTML();
        $info->SetInputMode(_PNH_VERBATIMINPUT);
        $info->Text(pnVarPrepForDisplay(_CWIABTIMES).":\n");
        $info->Text("<ul><li>".pnVarCleanFromInput('cwiab_times')."</li></ul>\n");
        $info->Text(pnVarPrepForDisplay(_CWIABADDRESS).":\n");
        $info->Text("<ul><li>".pnVarCleanFromInput('cwiab_address1')."<br />\n");
        $address2 = pnVarCleanFromInput('cwiab_address2');
        if ($address2 != "") {
            $info->Text($address2."<br />\n");
        }
        $address3 = pnVarCleanFromInput('cwiab_address3');
        if ($address3 != "") {
            $info->Text($address3."<br />\n");
        }
        $info->Text(pnVarCleanFromInput('cwiab_city').", ".pnVarCleanFromInput('cwiab_state')."<br />\n");
        $info->Text(pnVarCleanFromInput('cwiab_country')."<br />\n");
        $info->Text(pnVarCleanFromInput('cwiab_zip')."</li></ul>\n");
        $info->Text(pnVarPrepForDisplay(_CWIABCONTACT).":<ul>\n");
        $info->Text("<li>".pnVarPrepForDisplay(_CWIABPHONE)."<br />".pnVarCleanFromInput('cwiab_phone')."</li>\n");
        $fax = pnVarCleanFromInput('cwiab_fax');
        if ($fax != "") {
            $info->Text("<li>"._CWIABFAX."<br />".$fax."</li>\n");
        }
        $info->Text("<li><a href=\"mailto:".pnVarCleanFromInput('cwiab_info')."\">".pnVarPrepForDisplay(_CWIABEMAIL)."</a></li></ul>\n");
        $sql = "UPDATE nuke_blocks SET pn_content='".pnVarPrepForStore($info->GetOutput())."' WHERE pn_bid=".$info_bid;
        $result = $dbconn->Execute($sql);
    }

    // Rebuild Denominational Block
    if (pnVarCleanFromInput('cwiab_regenerateDenom')) {
        $denom = new pnHTML();
        $denom->SetInputMode(_PNH_VERBATIMINPUT);
        $denom->Text("<p align=center><a href=\"".pnVarCleanFromInput('cwiab_denom_site')."\" target=_blank>\n"
                     ."<img align=center border=0 height=110 width=80 alt=\"".pnVarCleanFromInput('cwiab_denom')."\"\n"
                     ." src=\"".pnVarCleanFromInput('cwiab_denom_logo')."\">\n"
                     ."</a></p>\n");
        $sql = "UPDATE nuke_blocks SET pn_content='".pnVarPrepForStore($denom->GetOutput())."', pn_title='".pnVarPrepForStore(pnVarCleanFromInput('cwiab_denom'))."' WHERE pn_bid=".$denom_bid;
        $result = $dbconn->Execute($sql);
    }

    // Copyright
    $value = pnVarCleanFromInput('cwiab_copyright');
    pnModSetVar('/PNConfig','foot1', serialize($value));

    return $output;
}


?>
