<?php // $Id: pnadmin.php,v 1.1.1.1 2004/05/06 03:54:25 dyksjare Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Filename: modules/ew_filemanager/pnadmin.php
// Original Author: Jaroslaw Gilewski (http://www.yagi.com.pl)
// Rewriten for pnAPI and converted to module by EasyWeb Team (EWT)
// Support:	Russian - http://www.postnuke.ru
//			English - http://home.postnuke.ru
// Purpose of file: ew_filemanager module's admin functions
// ----------------------------------------------------------------------

//main admin function
function ew_filemanager_admin_main() {
	$output = new pnHTML();
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	 
     if(!pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_EDIT))   {   
        
          $output->Text(_NOAUTH);    
          return $output->GetOutput();    
     }    

	$output->Text(ew_filemanager_admin_header());
	return $output->GetOutput();
}

// ----------------------------------------------------------------------
//ew_filemanager main admin page header function
function ew_filemanager_admin_header() {   

    if (!pnModAPILoad('ew_filemanager', 'admin')) {  
        return _LOADFAILED; 
    } 

	$html_output = "";

	$html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tablestart'); 
	
	$html_output.="<center><a class=\"pn-title\" href=\""
		.pnModURL('ew_filemanager','admin', 'main')."\"><b>"
		._EWFM_MODULEADMIN."</b></a></center><br>"; 

		$html_output.="<center>";
		
    if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_ADMIN)){
        $html_output.="|&nbsp;<a href=\"".pnModURL('ew_filemanager','admin', 'modifyconfig')."\">"._EWFM_MODIFYCONFIG."</a>&nbsp;";
    }

		$html_output.="|&nbsp;";

	if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_EDIT)) {
        $html_output.="<a href=\""
			.pnModURL('ew_filemanager','admin', 'manager')
			."\">"._EWFM_FILEMANAGER."</a>&nbsp;|&nbsp;";
    }
	if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_EDIT)) {
        $html_output.="<a href=\"".pnGetBaseURL()."modules/ew_filemanager/pnlang/".pnUserGetLang()."/manual.html\" target=\"_blank\">"._EWFM_ONLINEMANUAL."</a>&nbsp;|";
    }

	$html_output.="</center><hr>";
    $html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tableend');

    return $html_output;  
}

// ----------------------------------------------------------------------
function ew_filemanager_admin_manager() {

	list($edit, $view, $save, $mkdir, $upload, $delete, $pathext, $content) = 
		pnVarCleanFromInput('edit', 'view', 'save', 'mkdir', 'upload', 'delete', 'pathext', 'content');


	$dir_chmod="0775";
	$file_chmod="0644";

    $output = new pnHTML();  
    $output->SetInputMode(_PNH_VERBATIMINPUT);  

	if(!pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_EDIT)) {
		$output->Text(_NOAUTH); 
		return $output->GetOutput(); 
	} 


	if ((!empty($pathext))&&(substr($pathext,-1)!="/")) $pathext.="/";


	if (!pnModAPILoad('ew_filemanager', 'admin')) {  
        $output->Text(_LOADFAILED); 
        return $output->GetOutput(); 
	}

	// Get database setup
	pnModDBInfoLoad('ew_filemanager'); 
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ew_filemanager_column = $pntable['ew_filemanager_column'];

    $sql = "SELECT ". $ew_filemanager_column['path']
		. " FROM " . $pntable['ew_filemanager']
		. " WHERE " . $ew_filemanager_column['uid'] . "=" . pnUserGetVar('uid');
    $result=$dbconn->Execute($sql);

    // Check for an error, and if so set an appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: " . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg() . $sql);
        return false;
    }

	if (!$result->EOF) list($pagespath) = $result->fields;
	else $pagespath = pnModGetVar('ew_filemanager','pagespath'); //full path for /files folder

	$result->Close();


	if (!is_dir($pagespath.$pathext)) {  
        $output->Text(ew_filemanager_admin_header()."<b>".$pagespath.$pathext."</b><br>"._EWFM_FAILEDPATH); 
        return $output->GetOutput(); 
	}


	$maxfilesize = pnModGetVar('ew_filemanager','maxfilesize'); // max file size in bytes
	$hddspace = pnModGetVar('ew_filemanager','hddspace'); // max total size of all files in directory
	$hidden_files = strtr(pnModGetVar('ew_filemanager','hiddenfiles')," ",","); // add any file names to this array which should remain invisible
	$hidden_dirs = strtr(pnModGetVar('ew_filemanager','hiddendirs')," ",","); // add any file names to this array which should remain invisible
	$editextensions = strtr(pnModGetVar('ew_filemanager','editextensions')," ",","); // add the extensions of file types that you would like to be able to edit
	$imageextensions = strtr(pnModGetVar('ew_filemanager','imageextensions')," ",","); // add the extensions of image file type

    $html_output=""; 

	$i=0;
	$hd_dirs=strtok($hidden_dirs,",");
	while ($hd_dirs) {
		$hiddendirs[$i]=$hd_dirs;
		$hd_dirs=strtok(",");
		$i++;
	}

	$i=0;
	$hd_files=strtok($hidden_files,",");
	while ($hd_files) {
		$hiddenfiles[$i]=$hd_files;
		$hd_files=strtok(",");
		$i++;
	}

    $html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tablestart'); 

//=================

if($view) { // if an edit link was clicked

    $file = $pagespath.$pathext.$view;
	$fp = fopen($file, "r");
    $content = fread($fp, filesize($file));
    fclose($fp);

	$b_ing=0;
	$dotpos = strrpos($file, ".");
	$viewimage=strtok($imageextensions,",");
	while ($viewimage) {
        $ext = substr($file, ($dotpos+1));
        if(strcmp($ext, $viewimage) == 0) {
			$b_ing=1;
            $content = "<center><img src=\"$pagespath$pathext".basename($file)."\"></center>";
		}
		$viewimage=strtok(",");
    }
    
	if (!$b_ing) $content = "<pre>".pnVarPrepForDisplay($content)."</pre>";

    $html_output .=  "<center><font class=\"pn-title\"><b>"._EWFM_VIEWFILECONTENT."</b></font><br><br>"
        ."<font class=\"pn-normal\"><b>$pathext$view</b></font></center><br><br>"
        ."<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\"><tr><td>\n"
        ."<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\"><tr><td>\n"
        .$content
        ."</td></tr></table></td></tr></table><br>\n"
        .""._EWFM_BACKTOFM;
}
elseif($edit) { // if an edit link was clicked
	$file=$pagespath.$pathext.$edit;
	$fp = fopen($file, "r");
    $content = fread($fp, filesize($file));
    fclose($fp);

	$html_output .=  "<center><font class=\"pn-title\"><b>"._EWFM_EDITFILECONTENT."</b></font><br><br>"
        ."<font class=\"pn-normal\"><b>$pathext$edit</b></font></center><br><br>"
        ."<form name=\"contentform\" method=\"post\" action=\""
		.pnModURL('ew_filemanager','admin','manager')
		."\">"
        ."<b>"._EWFM_FILECONTENT."</b><br>"
		
		. pnModAPIFunc('ew_filemanager','admin','wysiwygcheckstart',
			array('title'=>_EWFM_EDITFILECONTENT,
				'editform'=>"contentform",
				'editcontrol'=>"content"))
        ."<textarea name=\"content\" cols=\"".pnModGetVar('ew_filemanager','textareawidth')
			."\" rows=\"".pnModGetVar('ew_filemanager','textareaheight')."\" >$content</textarea>"
		. pnModAPIFunc('ew_filemanager','admin','wysiwygcheckent');
		
    $html_output .=  "<br><br><input type=\"submit\" value=\""._EWFM_SAVEFILECONTENT."\"><br>"
        ."<input type=\"hidden\" name=\"save\" value=\"$edit\">"
        ."<input type=\"hidden\" name=\"pathext\" value=\"$pathext\">"
        ."</form><br>"
        .""._EWFM_BACKTOFM;
}
else {
    if($save){ // if the save button was pressed on the edit screen
        $content = stripslashes($content);
        $fp = fopen($pagespath.$pathext.$save, "w");
        fwrite($fp, $content);
        fclose($fp);
    }

    $hddtotal = dirsize($pagespath); // get the total size of all files in the directory including any sub directorys
    
	if(!pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_ADD)) {
		$msg = "<font color=\"red\">"._NOAUTH."</font><br>"; 
	} elseif(!empty($mkdir)) {
        $result = @mkdir($pagespath.$pathext.$mkdir/*, $dir_chmod*/);
        if($result == 0)
            $msg = "<font color=\"red\">"._EWFM_FOLDERCOULDNOTBECREATED."</font><br>";
    } elseif(!empty($upload)) { // if the upload button was pressed

		// In PHP > 4.1.0 $_FILES, < 4.1.0 $HTTP_POST_FILES
		$file_name = $_FILES['upload']['name'];
		$file_tmp  = $_FILES['upload']['tmp_name'];
		$file_type = $_FILES['upload']['type'];
		$file_size = $_FILES['upload']['size'];

        if($file_name){ // if a file was actually uploaded 
            $file_name = str_replace("%","",$file_name);  // remove any % signs from the file name
            // if the file size is within allowed limits
            if($file_size > 0 && $file_size < $maxfilesize){
                // if adding the file will not exceed the maximum allowed total
                if(($HDDTotal + $file_size) < $hddspace){
                    // put the file in the directory
                    move_uploaded_file($file_tmp, $pagespath.$pathext.$file_name);
                    // set the file permissions
//                    chmod($pagespath.$pathext.$file_name,$file_chmod);
                }    
                else
                    $msg = "<font color=\"red\">"._EWFM_NOFREESPACEERROR."</font><br>";
            }else{
                $MaxKB = $maxfilesize/1000; // show the max file size in Kb
                $msg =  "<font color=\"red\">"._EWFM_FILEGREATERTHANMAX1.$MaxKB._EWFM_FILEGREATERTHANMAX2."</font><br>";
            }
        }else
            $msg =  "<font color=\"red\">"._EWFM_PRESSBROWSEBEFOREUPLOAD."</font><br>";
    }elseif($delete){ // if the delete button was pressed
        // delete the file or directory
		if(!pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_DELETE)) {
			$msg = "<font color=\"red\">"._NOAUTH."</font><br>"; 
		} else
        if(is_dir($pagespath.$pathext.$delete)){
            $result = @rmdir($pagespath.$pathext.$delete);
            if($result == 0) 
                $msg = "<font color=\"red\">"._EWFM_FOLDERCOULDNOTBEDELETED."</font><br>";
        }else{
            $result = unlink($pagespath.$pathext.$delete);
            if($result == 0)
                $msg = "<font color=\"red\">"._EWFM_FILECOULDNOTBEDELETED."</font><br>";
        }
	}
    $freespace = number_format((float) (($hddspace - $hddtotal)/1000), 2, '.', ' '); // type cast as an int
    $hddtotal = number_format((float) ($hddtotal/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int
    $hddspace = number_format((float) ($hddspace/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int
    $maxfilesizekb = number_format((float) ($maxfilesize/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int

    // build the html that makes up the file manager
    // the $filemanager variable holds the first part of the html
    // including the form tags and the top 2 heading rows of the table which
    // dont display files
	$html_output.=ew_filemanager_admin_header();
    $html_output .=  "<center><font class=\"pn-title\"><b>"._EWFM_FILEMANAGER."</b></font><br>"
        ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"20\">"
        ."<tr><td align=\"center\">$msg<br>";

	if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_ADD)) {
		$html_output .= "<form method=\"post\" action=\""
			.pnModURL('ew_filemanager','admin','manager')
			."\">"
			."<b>"._EWFM_NEWDIR."</b>&nbsp;<input type=\"text\" name=\"mkdir\" size=\"25\">&nbsp;<input type=\"submit\" value=\""._EWFM_MAKEDIR."\">"
			."<input type=\"hidden\" name=\"upload\" value=\"\">"
			."<input type=\"hidden\" name=\"pathext\" value=\"$pathext\">"
			."</form><form method=\"post\" action=\""
			.pnModURL('ew_filemanager','admin','manager')
			."\" enctype=\"multipart/form-data\">"
			."<input type=\"hidden\" name=\"mkdir\" value=\"\">"
			."<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$maxfilesize\">"
			."<b>"._EWFM_NEWFILE."</b>&nbsp;<input type=\"file\" name=\"upload\" size=\"25\">&nbsp;"
			."<input type=\"submit\" value=\""._EWFM_UPLOADFILE."\">"
			."<input type=\"hidden\" name=\"pathext\" value=\"$pathext\">"
			."</form>";
	}

    $html_output .= "<table border=\"1\" cellspacing=\"0\" cellpadding=\"4\" align=\"center\">"
        ."<tr>"; 
    if($pathext != "")
        $html_output .=  "<th colspan=\"4\">$pathext</th>"
            ."</tr><tr>" 
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."</tr><tr>";
    $html_output .=  "<th></th>"
        ."<th><b>&nbsp;"._EWFM_FILENAME."&nbsp;</b></th>"
        ."<th><b>&nbsp;"._EWFM_FILESIZE."&nbsp;</b></th>"
        ."<th><b>&nbsp;"._EWFM_FUNCTIONS."&nbsp;</b></th>"
        ."</tr><tr>"
        ."<td height=\"1\"></td>"
        ."<td height=\"1\"></td>"
        ."<td height=\"1\"></td>"
        ."<td height=\"1\"></td>"
        ."</tr>";

    // if the current directory is a sub directory show a back link to get back to the previous directory
    if($pathext)
    {
        $prevpathext = substr($pathext, 0, -1);
        $slashpos = strrpos($prevpathext, "/");
        if($slashpos == 0)
            $prevpathext = "";    
        else
            $prevpathext = substr($prevpathext, 0, ($slashpos+1));
    
        $html_output .=  "<tr>"
            ."<td align=\"center\">&nbsp;<img src=\"modules/ew_filemanager/pnimages/arrowicon.gif\">&nbsp;</td>"
            ."<td>&nbsp;<a href=\""
			.pnModURL('ew_filemanager','admin','manager', array('pathext'=>"$prevpathext"))
			."\">[..]</a>&nbsp;</td>"
            ."<td></td>"
            ."<td>&nbsp;</td>"
            ."</tr>"
            ."<tr>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."</tr>";    
    }

    // build the table rows which contain the file information
    $newpath = substr($pagespath.$pathext, 0, -1);   // remove the forward or backwards slash from the path

    $dir = @opendir($newpath); // open the directory
	if ($dir!=false) {
    while($file = readdir($dir)) // loop once for each dir in the directory
    {
        // if the name is not a '.' or '..' and is directory
        if($file != "." && $file != ".." && is_dir($pagespath.$pathext.$file))
        {
            $match = 0;
			if (!empty($hiddendirs))
            foreach($hiddendirs as $name) // for each value in the hidden dirs array
            {
                if($file == $name) // check the name is not the same as the hidden dir name
                    $match = 1;     // set a flag if this name is supposed to be hidden
            }    
            if(!$match) // if there were no matches the dir should not be hidden
            {    
                    $filedata = stat($pagespath.$pathext.$file); // get some info about the dir
                    
                    // create some html for a link to delete dir 
					if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_DELETE))
						$deletelink = "<a href=\""
							.pnModURL('ew_filemanager','admin','manager', 
								array('pathext'=>"$pathext",
									'delete'=>"$file"))
							."\"><img src=\"modules/ew_filemanager/pnimages/del.gif\" "
							."border=0 alt=\""._EWFM_DELETEFILE."\"></a>";
					else $deletelink ="";

                    $filename = "<a href=\""
					.pnModURL('ew_filemanager','admin','manager',array('pathext'=>"$pathext$file"))
					."\">$file</a>";
                    $fileicon = "&nbsp;<img src=\"modules/ew_filemanager/pnimages/foldericon.gif\">&nbsp;";
                    
                    $html_output .=  "<tr>"
                        ."<td align=\"center\">$fileicon</td>"
                        ."<td>&nbsp;$filename&nbsp;</td>"
                        ."<td align=\"right\">&nbsp;</td>"
                        ."<td>$deletelink</td>"
                        ."</tr>"
                        ."<tr>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."</tr>";
            }
        }
    }
    closedir($dir); // now that all the rows have been built close the directory
	}
    $dir = @opendir($newpath); // open the directory
	if ($dir!=false) {
    while($file = readdir($dir)) // loop once for each name in the directory
    {
        // if the name is not a directory
        if($file != "." && $file != ".." && !is_dir($pagespath.$pathext.$file))
        {
            $match = 0;
			if (!empty($hiddenfiles))
            foreach($hiddenfiles as $name) // for each value in the hidden files array
            {
                if($file == $name) // check the name is not the same as the hidden file name
                    $match = 1;     // set a flag if this name is supposed to be hidden
            }    
            if(!$match) // if there were no matches the file should not be hidden
            {    
                    $filedata = stat($pagespath.$pathext.$file); // get some info about the file
                    
                    // find out if the file is one that can be edited
                    $editlink = "";
                    $viewlink = "";

                    $dotpos = strrpos($file, ".");
					$editext=strtok($editextensions,",");
					while ($editext) {
						$ext = substr($file, ($dotpos+1));
                        if(strcmp($ext, $editext) == 0){
                            $editlink = "&nbsp;<a href=\""
							.pnModURL('ew_filemanager','admin','manager', 
								array('pathext'=>"$pathext",
									'edit'=>"$file"))
								."\"><img src=\"modules/ew_filemanager/pnimages/edit.gif\" border=0 alt=\""._EWFM_EDITFILE."\"></a>&nbsp;";
                            $viewlink = "&nbsp;<a href=\""
							.pnModURL('ew_filemanager','admin','manager', 
								array('pathext'=>"$pathext",
									'view'=>"$file"))
							."\"><img src=\"modules/ew_filemanager/pnimages/view.gif\" border=0 alt=\""._EWFM_VIEWFILE."\"></a>&nbsp;";
                        }                                
						$editext=strtok(",");
                    }

					$imgext=strtok($imageextensions,",");
					while ($imgext) { 
                        $ext = substr($file, ($dotpos+1));
						if(strcmp($ext, $imgext) == 0)
                            $viewlink = "&nbsp;<a href=\""
							.pnModURL('ew_filemanager','admin','manager', 
								array('pathext'=>"$pathext",
									'view'=>"$file"))
							."\"><img src=\"modules/ew_filemanager/pnimages/view.gif\" border=0 alt=\""._EWFM_VIEWFILE."\"></a>&nbsp;";
						$imgext=strtok(",");
					}
                    
                    // create some html for a link to delete files 
					if(pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_DELETE))
						$deletelink = "<a href=\""
							.pnModURL('ew_filemanager','admin','manager', 
									array('pathext'=>"$pathext",
										'delete'=>"$file"))
							."\"><img src=\"modules/ew_filemanager/pnimages/del.gif\" "
							."border=0 alt=\""._EWFM_DELETEFILE."\"></a>";
					else $deletelink = "";
                    $filename = $file;
                    $fileicon = "&nbsp;<img src=\"modules/ew_filemanager/pnimages/fileicon.gif\">&nbsp;";
                    
                    $html_output .=  "<tr>"
                        ."<td align=\"center\">$fileicon</td>"
                        ."<td>&nbsp;$filename&nbsp;</td>"
                        ."<td>&nbsp;$filedata[7]&nbsp;</td>"
                        ."<td>$deletelink";
                    if($editlink != "")
                        $html_output .=  "  $editlink";
                    if($viewlink != "")
                        $html_output .=  "  $viewlink";
                    $html_output .=  "</td></tr><tr>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."<td height=\"1\"></td>"
                        ."</tr>";
            }
        }
    }
    closedir($dir); // now that all the rows have been built close the directory
	}
    $html_output .=  "</table><br>"
        ."<b>"._EWFM_TOTALSPACE.":</b> $hddspace Kb<br><b>"._EWFM_MAXFILESIZE.":</b> $maxfilesizekb Kb<br>"
        ."<b>"._EWFM_FREESPACE.":</b> $freespace Kb<br><b>"._EWFM_USEDSPACE.":</b> $hddtotal Kb<br>";
    $html_output .=  "</td></tr></table></center>"; // add some closing tags to the $content variable
//=================
}
    $html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tableend');
    $output->Text($html_output);  
    return $output->GetOutput();  
}
// ----------------------------------------------------------------------
function dirsize($dir) 
// calculate the size of files in $dir
{
    $dh = opendir($dir);
    $size = 0;
    while (($file = readdir($dh)) !== false)
        if ($file != "." and $file != "..") 
        {
            $pagespath = $dir."/".$file;
            if (is_dir($pagespath))
                $size += dirsize("$pagespath/");
            elseif (is_file($pagespath))
                $size += filesize($pagespath);
        }
    closedir($dh);
    return $size;
}
// ----------------------------------------------------------------------
// set module vars 
function ew_filemanager_admin_updateconfig() {

	list ($actiontype,
		$wysiwygeditor,
		$maxfilesize,
		$hddspace,
		$hiddenfiles,
		$hiddendirs,
		$editextensions,
		$imageextensions,
		$adduser,
		$addpath,
		$num_redefines,
		$redif_path,
		$redif_del,
		$redif_uid,
		$textareawidth,
		$textareaheight,
		$pagespath) = pnVarCleanFromInput('actiontype',
										'wysiwygeditor',
										'maxfilesize',
										'hddspace',
										'hiddenfiles',
										'hiddendirs',
										'editextensions',
										'imageextensions',
										'adduser',
										'addpath',
										'num_redefines',
										'redif_path',
										'redif_del',
										'redif_uid',
										'textareawidth',
										'textareaheight',
										'pagespath');

	if ($actiontype=="Save") {
		// set the module vars
		pnModSetVar('ew_filemanager', 'wysiwygeditor', $wysiwygeditor);
		pnModSetVar('ew_filemanager', 'maxfilesize', $maxfilesize);
		pnModSetVar('ew_filemanager', 'hddspace', $hddspace);
		pnModSetVar('ew_filemanager', 'hiddenfiles', $hiddenfiles);
		pnModSetVar('ew_filemanager', 'hiddendirs', $hiddendirs);
		pnModSetVar('ew_filemanager', 'editextensions', $editextensions);
		pnModSetVar('ew_filemanager', 'imageextensions', $imageextensions);
		pnModSetVar('ew_filemanager', 'pagespath', $pagespath);
		pnModSetVar('ew_filemanager', 'textareawidth', $textareawidth);
		pnModSetVar('ew_filemanager', 'textareaheight', $textareaheight);
	}

	if ($actiontype=="RestoreDefaults") {
		// set the defaults
		pnModSetVar('ew_filemanager', 'wysiwygeditor', 0);
		pnModSetVar('ew_filemanager', 'maxfilesize', 100000000);
		pnModSetVar('ew_filemanager', 'hddspace', 1000000000);
		pnModSetVar('ew_filemanager', 'hiddenfiles', '.htaccess');
		pnModSetVar('ew_filemanager', 'hiddendirs', '');
		pnModSetVar('ew_filemanager', 'editextensions', 'htm,html,txt');
		pnModSetVar('ew_filemanager', 'imageextensions', 'jpg,jpeg,png,bmp,gif');
		pnModSetVar('ew_filemanager', 'pagespath', '/absolute/path/to/your/files/store/');
		pnModSetVar('ew_filemanager', 'textareawidth', 80);
		pnModSetVar('ew_filemanager', 'textareaheight', 20);

	}

	pnModDBInfoLoad('ew_filemanager'); 
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();
	$ew_filemanager_column = $pntable['ew_filemanager_column'];

	if ( (!empty($adduser)) && (!empty($addpath)) ) {
		$sql = "INSERT INTO " . $pntable['ew_filemanager']
			. " VALUES(".$adduser.",'".$addpath."')";
		$dbconn->Execute($sql);
	}

	for ($i=1; $i<=$num_redefines; $i++) {
		if ($redif_del[$i]=='1') {
			$sql = "DELETE FROM " . $pntable['ew_filemanager']
				. " WHERE " . $ew_filemanager_column['uid'] . "=" . $redif_uid[$i];
			$dbconn->Execute($sql);
		} else {
			$sql = "UPDATE " . $pntable['ew_filemanager']
				. " SET " . $ew_filemanager_column['path'] . " = '" . $redif_path[$i] . "'"
				. " WHERE " . $ew_filemanager_column['uid'] . "=" . $redif_uid[$i];
			$dbconn->Execute($sql);
		}
	}


	pnRedirect(pnModURL('ew_filemanager','admin','modifyconfig'));
	return true;

}	

/**
 * preferences
 */

function ew_filemanager_admin_modifyconfig() {

	$output = new pnHTML();   
	$output->SetInputMode(_PNH_VERBATIMINPUT);    
	$html_output = "";

	$wysiwygeditor = pnModGetVar('ew_filemanager', 'wysiwygeditor');
	$maxfilesize = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'maxfilesize'));
	$hddspace = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'hddspace'));
	$hiddenfiles = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'hiddenfiles'));
	$hiddendirs = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'hiddendirs'));
	$editextensions = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'editextensions'));
	$imageextensions = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'imageextensions'));
	$pagespath = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'pagespath'));
	$pagesperlistview = pnVarPrepHTMLDisplay(pnModGetVar('ew_filemanager', 'pagesperlistview'));

	if (!pnModAPILoad('ew_filemanager', 'admin')) {  
        $output->Text(_LOADFAILED); 
        return $output->GetOutput(); 
    } 

	if(!pnSecAuthAction(0, 'ew_filemanager::', '::', ACCESS_ADMIN)) {
		$output->Text(_NOAUTH); 
		return $output->GetOutput(); 
	} 

	$html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tablestart'); 
	$html_output.="<center><a class=\"pn-pagetitle\" href=\""
		.pnModURL('ew_filemanager','admin','manager')."\">"._EWFM_FILEMANAGER."</a></center>";

	$html_output.="<br>"
		. "<form action=\"".pnModURL('ew_filemanager','admin','updateconfig')."\" method=\"post\">"
		. "<TABLE BORDER=\"0\" CELLPADDING=\"1\" CELLSPACING=\"1\" ALIGN=\"CENTER\" VALIGN=\"TOP\" WIDTH=\"100%\">"
		. "<TR>"
		. "<TD>"
			. "<TABLE BORDER=\"0\" CELLPADDING=\"3\" CELLSPACING=\"1\" WIDTH=\"100%\">"
			. "<TR ALIGN=\"LEFT\"><TD ALIGN=\"CENTER\" COLSPAN=\"3\">"
				. "<FONT class=\"pn-pagetitle\">"._EWFM_MODIFYCONFIG."</FONT></TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\"><TD ALIGN=\"CENTER\" COLSPAN=\"3\">"
				. "<FONT class=\"pn-normal\"><I>"._EWFM_MODIFYCONFIG_NOTE."</I></FONT></TD>"
			. "</TR>"
//HEADER
			. "<TR ALIGN=\"LEFT\"><TD ALIGN=\"right\" COLSPAN=\"3\">"
				. "<HR><FONT class=\"pn-pagetitle\"><B>"._EWFM_CONFIG_WYSIWYG."</B></FONT></TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_WYSIWYG_SWITCH."</b>"
				. "</TD>"
				. "<TD colspan=\"2\" ALIGN=\"LEFT\">";
					if ($wysiwygeditor==2) {
						$intro_select=" checked";
						$yes_select="";
						$no_select="";
					} elseif ($wysiwygeditor==1) {
						$intro_select="";
						$yes_select=" checked";
						$no_select="";
					} else {
						$intro_select="";
						$yes_select="";
						$no_select=" checked";
					} 
					$html_output.="<input type=\"radio\" name=\"wysiwygeditor\" value=\"0\""
					. $no_select.">"._NO. "&nbsp;"
//					. "<input type=\"radio\" name=\"wysiwygeditor\" value=\"1\""
//					. $yes_select.">"._EWFM_YES_SUBJECTSWYSIWYG. "<br>"
//					. $yes_select." disabled>"._EWFM_YES_SUBJECTSWYSIWYG. "<br>" 
					. "<input type=\"radio\" name=\"wysiwygeditor\" value=\"2\""
					. $intro_select.">"._YES
					. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_TEXTAREA."</b>"
				. "</TD>"
				. "<TD colspan=\"2\"><INPUT TYPE=\"TEXT\" NAME=\"textareawidth\" SIZE=\"3\" MAXLENGTH=\"3\" "
					. "VALUE=\"".pnModGetVar('ew_filemanager','textareawidth')."\">&nbsp;x&nbsp;"
					. "<INPUT TYPE=\"TEXT\" NAME=\"textareaheight\" SIZE=\"3\" MAXLENGTH=\"3\" "
					. "VALUE=\"".pnModGetVar('ew_filemanager','textareaheight')."\"> "._EWFM_CONFIG_TEXTAREA2
				. "</TD>"
			. "</TR>"

//HEADER
			. "<TR ALIGN=\"LEFT\"><TD ALIGN=\"right\" COLSPAN=\"3\">"
				. "<HR><FONT class=\"pn-pagetitle\"><B>"._EWFM_CONFIG_FILEMANAGER."</B></FONT></TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_MAXFILESIZE."</b>"
				. "</TD>"
				. "<TD colspan=\"2\"><INPUT TYPE=\"TEXT\" NAME=\"maxfilesize\" SIZE=\"15\" MAXLENGTH=\"30\" "
					. "VALUE=\"".$maxfilesize."\"> bytes"
				. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_MAXDISKSPACE."</b>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"hddspace\" SIZE=\"15\" MAXLENGTH=\"30\" "
					. "VALUE=\"".$hddspace."\"> bytes"
				. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_HIDDENFILES."</b><br>"
					. "<I>"._EWFM_CONFIG_USECOMMAS."</I>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"hiddenfiles\" SIZE=\"30\" MAXLENGTH=\"255\" "
					. "VALUE=\"".$hiddenfiles."\">"
				. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_HIDDENDIRS."</b><br>"
					. "<I>"._EWFM_CONFIG_USECOMMAS."</I>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"hiddendirs\" SIZE=\"30\" MAXLENGTH=\"255\" "
					. "VALUE=\"".$hiddendirs."\">"
				. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_EDITABLEEXT."</b><br>"
					. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"editextensions\" SIZE=\"30\" MAXLENGTH=\"100\" "
					. "VALUE=\"".$editextensions."\">"
				. "</TD>"
			. "</TR>"
			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_IMAGESEXT."</b>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"imageextensions\" SIZE=\"50\" MAXLENGTH=\"100\" "
					. "VALUE=\"".$imageextensions."\">"
				. "</TD>"
			. "</TR>"
//HEADER
			. "<TR ALIGN=\"LEFT\"><TD ALIGN=\"right\" COLSPAN=\"3\">"
				. "<HR><FONT class=\"pn-pagetitle\"><B>"._EWFM_CONFIG_USERCONFIG."</B></FONT></TD>"
			. "</TR>"

			. "<TR ALIGN=\"LEFT\">"
				. "<TD>"
					. "<b>"._EWFM_CONFIG_PATHTOPAGESDIR."</b>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"pagespath\" SIZE=\"50\" MAXLENGTH=\"100\" "
					. "VALUE=\"".$pagespath."\">"
				. "</TD>"
			. "</TR>";

	// Get database setup
	pnModDBInfoLoad('ew_filemanager'); 
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $users_column = $pntable['users_column'];

    $sql = "SELECT ". $users_column['uid'] . ", " . $users_column['uname']
		. " FROM " . $pntable['users']
		. " WHERE " . $users_column['uname'] . "!='Anonymous'"
		. " ORDER BY " . $users_column['uname'];
    $result=$dbconn->Execute($sql);

    // Check for an error, and if so set an appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: " . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg() . $sql);
        return false;
    }
	
    for (; !$result->EOF; $result->MoveNext()) {
        list($uid, $uname) = $result->fields;
        $pn_users[$uid]['uid'] = $uid;
        $pn_users[$uid]['uname'] = $uname;
        $pn_users[$uid]['disabled'] = 0;
	}

	$result->Close();

    $ew_filemanager_column = $pntable['ew_filemanager_column'];
    $sql = "SELECT ". $ew_filemanager_column['uid'] 
			. ", " . $ew_filemanager_column['path']
			. ", " . $users_column['uname']
		. " FROM " . $pntable['ew_filemanager']
		. " LEFT JOIN ".$pntable['users']." ON ".$ew_filemanager_column['uid']."=".$users_column['uid']
		. " ORDER BY " . $users_column['uname'];
    $result=$dbconn->Execute($sql);
    // Check for an error, and if so set an appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: " . $dbconn->ErrorNo().": ".$dbconn->ErrorMsg() . $sql);
        return false;
    }

	$num_redefines=0;
    for (; !$result->EOF; $result->MoveNext()) {
        list($uid, $path, $uname) = $result->fields;
		$num_redefines++;
		$html_output.= ""
			. "<TR ALIGN=\"LEFT\">"
				. "<TD ALIGN=\"RIGHT\">"
					. _EWFM_CONFIG_USERPATH."<b>".$uname."</b>:"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"redif_path[".$num_redefines."]\" SIZE=\"50\" MAXLENGTH=\"100\" "
						. "VALUE=\"".$path."\">" . "&nbsp;&nbsp;("
					. "<INPUT TYPE=\"CHECKBOX\" NAME=\"redif_del[".$num_redefines."]\" VALUE=\"1\">"
					. "<INPUT TYPE=\"HIDDEN\" NAME=\"redif_uid[".$num_redefines."]\" VALUE=\"".$uid."\">"
					. "&nbsp;" . _EWFM_CONFIG_USERUNSET . ")"
				. "</TD>"
			. "</TR>";

		$pn_users[$uid]['disabled']=1;
	}

	$result->Close();

	$html_output.= ""
			. "<TR ALIGN=\"LEFT\">"
				. "<TD ALIGN=\"right\">"
					. "<b>" . _EWFM_CONFIG_USERPATH . "</b>"
					. "<select name=\"adduser\">"
						. "<option selected></option>";
	
	foreach ($pn_users as $pnuser) 
		if ($pnuser['disabled']==0)
			$html_output.="<option value=\"".$pnuser['uid']."\">".$pnuser['uname']."</option>";
		
	$html_output.= ""
					. "</select> <b>:</b>"
				. "</TD>"
				. "<TD colspan=\"2\">"
					. "<INPUT TYPE=\"TEXT\" NAME=\"addpath\" SIZE=\"50\" MAXLENGTH=\"255\" "
						. "VALUE=\"\">"
					. "<INPUT TYPE=\"HIDDEN\" NAME=\"num_redefines\" VALUE=\"".$num_redefines."\">"

				. "</TD>"
			. "</TR>";


	$html_output.= "<TR ALIGN=\"LEFT\">"
				. "<TD ALIGN=\"CENTER\" COLSPAN=\"3\"><HR><br><br>"
					. "<input type=\"radio\" name=\"actiontype\" value=\"Save\" checked>&nbsp;"
						._EWFM_CONFIG_SAVECHANGES."&nbsp;"
					. "<input type=\"radio\" name=\"actiontype\" value=\"RestoreDefaults\">&nbsp;"
						._EWFM_CONFIG_RESTOREDEFAULTS."<br><br>"
					. "<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\""._EWFM_CONFIG_SUBMIT."\">"
				. "</TD>"
			. "</TR>"
			. "</TABLE>"

		. "</TD></TR>"
		. "</TABLE>"
		. "</form>";

	$html_output.=pnModAPIFunc('ew_filemanager', 'admin', 'tableend');			
	$output = new pnHTML();  
	$output->SetInputMode(_PNH_VERBATIMINPUT);  
	$output->Text($html_output);  
	return $output->GetOutput();  
}
?>
