<?php // $Id: pninit.php,v 1.1.1.1 2004/05/06 03:54:25 dyksjare Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Filename: modules/ew_filemanager/pninit.php
// Original Author of file: EasyWeb Team (EWT)
// Support:	Russian - http://www.postnuke.ru
//			English - http://home.postnuke.ru
// Purpose of file:  Initialisation functions for ew_filemanager module
// ----------------------------------------------------------------------

function ew_filemanager_init()
{
	// Get database setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $column = $pntable['ew_filemanager_column'];

    // Create the table
    $sql = "CREATE TABLE $pntable[ew_filemanager] (
            $column[uid] int(11) NOT NULL,
            $column[path] varchar(255) NOT NULL default 'slash/ended/path/to/files/',
            PRIMARY KEY(uid))";
    $dbconn->Execute($sql);

    // Check for an error, and if so set an appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: "
       			. $dbconn->ErrorNo().": ".$dbconn->ErrorMsg() 
       			. "<br>Query:</b><br>" . $sql);
        return false;
    }

    // Set up an initial value for a module variable.
	pnModSetVar('ew_filemanager', 'wysiwygeditor', 0);
	pnModSetVar('ew_filemanager', 'maxfilesize', 100000000);
	pnModSetVar('ew_filemanager', 'hddspace', 1000000000);
	pnModSetVar('ew_filemanager', 'hiddenfiles', '.htaccess');
	pnModSetVar('ew_filemanager', 'hiddendirs', '');
	pnModSetVar('ew_filemanager', 'editextensions', 'htm,html,txt');
	pnModSetVar('ew_filemanager', 'imageextensions', 'jpg,jpeg,png,bmp,gif');
	pnModSetVar('ew_filemanager', 'pagespath', '/absolute/path/to/your/files/store/');
	pnModSetVar('ew_filemanager', 'textareawidth', 80);
	pnModSetVar('ew_filemanager', 'textareaheight', 20);

    return true;
}

function ew_filemanager_upgrade($oldversion) {
    return true;
}

function ew_filemanager_delete()
{
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

    $sql = "DROP TABLE $pntable[ew_filemanager]";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', "DB Error: "
       			. $dbconn->ErrorNo().": ".$dbconn->ErrorMsg() 
       			. "<br>Query:</b><br>" . $sql);
        return false;
    } 
    // Delete any module variables
	pnModDelVar('ew_filemanager', 'wysiwygeditor');
	pnModDelVar('ew_filemanager', 'maxfilesize');
	pnModDelVar('ew_filemanager', 'hddspace');
	pnModDelVar('ew_filemanager', 'hiddenfiles');
	pnModDelVar('ew_filemanager', 'hiddendirs');
	pnModDelVar('ew_filemanager', 'editextensions');
	pnModDelVar('ew_filemanager', 'imageextensions');
	pnModDelVar('ew_filemanager', 'pagespath');
	pnModDelVar('ew_filemanager', 'textareawidth');
	pnModDelVar('ew_filemanager', 'textareaheight');


    return true;
}
?>