<?php
// $Id: common.php,v 1.1.1.1 2004/05/06 03:56:41 dyksjare Exp $

define('photoshareGroupRead',  0);
define('photoshareGroupWrite', 1);
define('photoshareUserRead',   2);
define('photoshareUserWrite',  3);

define('photoshareFolderAccessPrivate',   0);
define('photoshareFolderAccessViewByAll', 1);
define('photoshareFolderAccessEditByAll', 2);
define('photoshareFolderAccessSpecific',  3);
define('photoshareFolderAccessPassword',  4);

define('photoshareAccessRequirementView',  0);
define('photoshareAccessRequirementEdit',  1);
define('photoshareAccessRequirementAdmin', 2);

define('photoshareGroupSetupKind', 0);
define('photoshareUserSetupKind',  1);

define('photosharePageSize', 10);

function photoshareModGetName()
{
  // Since pnModGetName() returns the wrong module name when calling photoshare from hooks or similar
  // we simply hardcode the name into the system.
  return 'photoshare';
}


// -----------------------------------------------------------------------
// Error handling
// -----------------------------------------------------------------------

function photoshareErrorPage($file, $line, $msg)
{
  if ($file == null  ||  !pnSecAuthAction(0, 'photoshare::', "::", ACCESS_ADMIN))
    $text = $msg;
  else
    $text = "$file($line): $msg";

  pnSessionSetVar('errormsg', $msg);
  return $text;
}

function photoshareErrorAPI($file, $line, $msg, $setSession=true)
{
  global $photoshareErrorMessageAPI;

  if ($file == null  ||  !pnSecAuthAction(0, 'photoshare::', "::", ACCESS_ADMIN))
    $photoshareErrorMessageAPI = $msg;
  else
    $photoshareErrorMessageAPI = "$file($line): $msg";

  if ($setSession)
    pnSessionSetVar('errormsg', $photoshareErrorMessageAPI);

  return false;
}


function photoshareErrorAPIGet()
{
  global $photoshareErrorMessageAPI;
  return $photoshareErrorMessageAPI;
}


function photoshareLog($msg)
{
  $tmpdir = pnModGetVar('photoshare', 'tmpdirname');
  $filename = $tmpdir . "/photoshare-log.txt";
  $f = @fopen($filename, "a");
  if ($f)
  {
    fwrite($f, "$msg\n");
    fclose($f);
  }
}


// -----------------------------------------------------------------------
//  Inserting a special stylesheet for Photoshare
// -----------------------------------------------------------------------

function photoshareGetMainStyleSheetLink()
{
    // Try using stylesheet for theme - if this does not exist then default to "photoshare".

  $cssURL = "modules/photoshare/themes/" . pnVarPrepForOS(pnUserGetTheme()) . "/style.css";

  if (!@file_exists($cssURL))
    $cssURL = "modules/photoshare/themes/photoshare/style.css";

  return "<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">";
}

function photoshareAddMainStyleSheet()
{
    // Use PostNuke variable for insertion of special HTML header tags to add standard style sheet
  global $additional_header;
  if (!is_array($additional_header))
    $additional_header = array();

    // Try using stylesheet for theme - if this does not exist then default to "photoshare".

  $additional_header[] = photoshareGetMainStyleSheetLink();
}


// -----------------------------------------------------------------------
// Various PN interfaces
// -----------------------------------------------------------------------

function photosharePNGetTopics($currentTopic)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $topicsTable  = $pntable['topics'];
  $topicsColumn = $pntable['topics_column'];

  $sql = "SELECT   $topicsColumn[tid],
                   $topicsColumn[topictext]
          FROM     $topicsTable
          ORDER BY $topicsColumn[topictext]";

  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, '"PNGetTopics" failed: ' . $dbconn->errorMsg() . " while executing: $sql");

  $topics = array();

     // Used directly in pnHTML so do not change 'name' to 'text' (although it is topic-text)
  $topics[] = array('id'        => -1,
                    'name'      => _PSNOTOPIC,
                    'selected'  => 0);

  for (; !$result->EOF; $result->MoveNext())
  {
    $topics[] = array('id'        => $result->fields[0],
                      'name'      => $result->fields[1],
                      'selected'  => ($result->fields[0] == $currentTopic));
  }

  $result->Close();

  return $topics;
}


// =======================================================================
// Searching
// =======================================================================

class PhotoshareSearchCallback
{
  function start() {}

  function found($folderID, $imageID, $folderTitle, $imageTitle, $url) {}

  function stop() {}
};


// -----------------------------------------------------------------------
// Other
// -----------------------------------------------------------------------

function photoshareDrawPager(&$output, $page, $moreImages, $imageCount, $folderID, $func, $urlExtra = array())
{
  if ($page > 0)
  {
    $url = pnModURL('photoshare', 'user', $func, array('fid' => $folderID, 'page' => $page-1) + $urlExtra);
    $output->URL($url, _PSPREVPAGE);
  }

  for ($p=0, $pageCount=ceil($imageCount/photosharePageSize); $p<$pageCount; ++$p)
  {
    $url = pnModURL('photoshare', 'user', $func, array('fid' => $folderID, 'page' => $p) + $urlExtra);
    $output->Text(' ');
    if ($p != $page)
      $output->URL($url, $p+1);
    else
      $output->Text($p+1);
    $output->Text(' ');
  }

  if ($moreImages)
  {
    if ($page > 0)
      $output->Text(' ');

    $url = pnModURL('photoshare', 'user', $func, array('fid' => $folderID, 'page' => $page+1) + $urlExtra);
    $output->URL($url, _PSNEXTPAGE);
  }

  $output->LineBreak(2);
}


?>