<?php
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

class NestedList
{
  function NestedList()
  {
    $this->columnCount = 0;
  }


    // Return the version of the template interface that this template supports.
  function getVersion()
  {
    return 1;
  }

  function getTitle()
  {
    return "Nested";
  }

  function usesStyleSheet()
  {
    return true;
  }

  function isNested()
  {
    return true;
  }

  function startList(&$output, $folderInfo, $listHelper)
  {
    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);

    $title    = $folderInfo['title'];
    $folderID = $folderInfo['id'];

    $menuHide = array( _PSMENUTHISFOLDER     => (($folderID == -1) || 
                                                 !photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, '')),
                       _PSMENUADDFOLDER      => true,
                       _PSMENUADDIMAGES      => true,
                       _PSMENUFOLDEREDIT     => true,
                       _PSMENUVIEWFOLDER     => ($folderID == -1),
                       _PSMENUFOLDERDELETE   => true,
                       _PSMENUPUBLISHALBUM   => true,
                       _PSMENUVIEWALLFOLDERS => true,
                       _PSMENUMYFOLDERS      => false);

    photoshareMakeMainMenu($output, $folderID, $menuHide, array('gotoCurrentFolder' => true), NULL, false, 'viewallfolders');

    if ($folderID != -1)
    {
      $imageURL = pnModUrl('photoshare', 'user', 'viewimage', array('iid' => $folderInfo['mainImage']));
      $folderURL  = pnModUrl('photoshare', 'user', 'showimages', array('fid' => $folderInfo['id']));

      $output->Text("<table><tr>\n");

      if (isset($folderInfo['mainImage'])  &&  $folderInfo['mainImage'] != NULL)
        $output->Text("<td valign=\"top\"><a href=\"$folderURL\"><img src=\"$imageURL\" height=\"150\" align=\"left\" border=\"0\" alt=\"$folderInfo[title]\" title=\"$folderInfo[title] - "  . _PSLIST_CLICKTOVIEW . "\"></a></td>");

      $output->Text("<td valign=\"top\">");
      $output->Text("<a href=\"$folderURL\"><b>" . pnVarPrepForDisplay($folderInfo['title']) . "</b></a><br>\n");

      if ($folderInfo['description'] != "")
        $output->Text(pnVarPrepHTMLDisplay("$folderInfo[description]\n") . "<br>\n");

      $output->Text(_PSLIST_BY . " " . pnVarPrepForDisplay($folderInfo['ownername']));
      $output->Text(" " . _PSLIST_BYDATE . " " . pnVarPrepForDisplay($folderInfo['createdDate']));
      $output->Text(" (" . $folderInfo['imageCount'] . " " . _PSLIST_ITEMS . ")\n");
      if ($folderInfo['subFolderCount'] > 0)
        $output->Text("<br>$folderInfo[subFolderCount] " . _PSLIST_FOLDERS);
      $output->Text("</td>");
      $output->Text("</tr><table>\n");
    }

    $output->Text('<div class="photoshare-heading">' . _PSLIST_SUBFOLDERS . ":</div>\n");

    $output->Text("<table class=\"photoshare-nested\">\n");
    $output->Text("<tr>\n");

    $output->SetInputMode($oldMode);
  }


  function showList(&$output, $folderInfo, $listHelper)
  {
    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);

    $output->Text("<td valign=\"top\">\n");

    if ($folderInfo['subFolderCount'] == 0)
      $folderURL  = pnModUrl('photoshare', 'user', 'showimages', array('fid' => $folderInfo['id']));
    else
      $folderURL  = pnModUrl('photoshare', 'user', 'viewallfolders', array('fid' => $folderInfo['id']));

    if (isset($folderInfo['mainImage'])  &&  $folderInfo['mainImage'] != NULL)
    {
      $imageURL  = pnModUrl('photoshare', 'user', 'viewimage', array('iid' => $folderInfo['mainImage'], 'thumbnail' => 1));
      $folderHTML = "<a href=\"$folderURL\"><img alt=\"$folderInfo[title]\" src=\"$imageURL\" title=\"" . _PSVIEWFOLDER . "\" border=\"0\"></a>";
    }
    else
    {
      $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

      $folderHTML = "<a href=\"$folderURL\"><img src=\"$imageDir/folder.gif\" title=\"" . _PSVIEWFOLDER . "\" border=\"0\"></a>";
    }

    $output->Text("$folderHTML<br><b>$folderInfo[title]</b><br>\n$folderInfo[imageCount] " . _PSLIST_IMAGES);
    if ($folderInfo['subFolderCount'] > 0)
      $output->Text("<br>$folderInfo[subFolderCount] " . _PSLIST_FOLDERS);

    $output->Text("</td>\n");
    
    if ((++$this->columnCount) % 4 == 0)
    {
      $output->Text("</tr>\n");
      $output->Text("<tr>\n");
    }

    $output->SetInputMode($oldMode);
  }


  function endList(&$output, $folderInfo, $listHelper)
  {
    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("</tr>\n");
    $output->Text("</table>\n");
    $output->SetInputMode($oldMode);
  }

  var $columnCount;
}


function photoshare_list_nested()
{
  return new NestedList;
}


?>
