<?php
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

class OriginalList
{
    // Return the version of the template interface that this template supports.
  function getVersion()
  {
    return 1;
  }


  function getTitle()
  {
    return "Original";
  }


  function usesStyleSheet()
  {
    return true;
  }


  function isNested()
  {
    return true;
  }


  function startList(&$output, $folderInfo, $listHelper)
  {
    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);

    $title    = $folderInfo['title'];
    $folderID = $folderInfo['id'];

    $menuHide = array( _PSMENUTHISFOLDER     => (($folderID == -1) || 
                                                 !photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, '')),
                       _PSMENUADDFOLDER      => true,
                       _PSMENUADDIMAGES      => true,
                       _PSMENUFOLDEREDIT     => true,
                       _PSMENUVIEWFOLDER     => ($folderID == -1),
                       _PSMENUFOLDERDELETE   => true,
                       _PSMENUPUBLISHALBUM   => true,
                       _PSMENUVIEWALLFOLDERS => true,
                       _PSMENUMYFOLDERS      => false);

    photoshareMakeMainMenu($output, $folderID, $menuHide, array('gotoCurrentFolder' => true), NULL, false, 'viewallfolders');

    $output->Text("<table class=\"photoshare-albumlist\">\n");
    $output->Text("<tr><td></td><td>" . _PSOWNER . "</td><td>" . _PSCREATEDATE . "<td>" 
                  . _PSFOLDERTOPIC . "</td><td>" . _PSIMAGECOUNT . "</td></td></tr>\n");

    $output->SetInputMode($oldMode);
  }


  function showList(&$output, $folder, $listHelper)
  {
    $folderURL  = pnModUrl('photoshare', 'user', 'showimages', array('fid' => $folder['id']));

    if (isset($folder['mainImage'])  &&  $folder['mainImage'] != NULL)
    {
      $imageURL  = pnModUrl('photoshare', 'user', 'viewimage', array('iid' => $folder['mainImage'], 'thumbnail' => 1));
      $folderHTML = "<a href=\"$folderURL\"><img src=\"$imageURL\" title=\"" . _PSVIEWFOLDER . "\" border=\"0\"></a>";
    }
    else
    {
      $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

      $folderHTML = "<a href=\"$folderURL\"><img src=\"$imageDir/folder.gif\" border=\"0\"></a>";
    }

      // First row contains image, title and description
    $html = "<tr valign=\"top\" class=\"upper\">\n<td rowspan=\"2\">$folderHTML</td>";
    $html .= "<td colspan=\"4\"><a href=\"$folderURL\" border=\"0\"><b>" . pnVarPrepForDisplay($folder[title]) . "</b></a><br>\n";
    $html .= pnVarPrepHTMLDisplay("$folder[description]\n") . "</td></tr>\n";

      // Second row is additional information
    $html .= "<tr class=\"lower\">";
    $html .= "<td>" . pnVarPrepForDisplay($folder[ownername]) . "</td>";
    $html .= "<td>" . pnVarPrepForDisplay($folder[createdDate]) . "</td>\n";
    $html .= "<td>" . pnVarPrepForDisplay($folder[topicText]) . "</td><td>$folder[imageCount]</td></tr>\n";

    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text($html);
    $output->SetInputMode($oldMode);
  }


  function endList(&$output)
  {
    $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("</table>\n");
    $output->SetInputMode($oldMode);
  }
}


function photoshare_list_original()
{
  return new OriginalList;
}


?>
