<?php
// $Id: pnadmin.php,v 1.1.1.1 2004/05/06 03:56:42 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/photoshare/common.php");

photoshareAddMainStyleSheet();

// =======================================================================
// 
// =======================================================================
function photoshare_admin_main()
{
  $output = new pnHTML();

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'admin'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Add title and heading
  photoshareAdminMenu($output);

  $output->FormStart( pnModUrl('photoshare', 'admin', 'update_settings') );
  $output->FormHidden('authid', pnSecGenAuthKey());

  $output->TableStart('', array(), 0, '');

    // php.ini - file_uploads info
  if (!ini_get('file_uploads'))
  {
    $output->TableRowStart();
    $output->TableColStart(2, 'left', 'top');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text('<font color="#FF0000"><em>'._PSUPLOADNOTENABLED.'</em></font>');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();
  }

  $output->TableRowStart();
  $output->TableColStart(2, 'left', 'top');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<em>php.ini: post_max_size = ' . ini_get('post_max_size') 
                . ', upload_max_filesize = ' . ini_get('upload_max_filesize')
                . ', file_uploads = ' . ini_get('file_uploads') . '</em>');
  $output->Text("<hr>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

  
    // Use image directory
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSUSEIMAGEDIR);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormCheckbox('useimagedirectory', pnModGetVar('photoshare', 'useImageDirectory'), 1, 'radio');
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSUSEIMAGEDATABASE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormCheckbox('useimagedirectory', !pnModGetVar('photoshare', 'useImageDirectory'), 0, 'radio');
  $output->TableColEnd();
  $output->TableRowEnd();

    // Optional info about basedir
  $openbasedir = ini_get('open_basedir');
  if (!empty($openbasedir))
  {
    $output->TableRowStart();
    $output->TableColStart(1, 'left');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<i> " . _PSBASEDIRSET . "</i>:");
    $output->TableColEnd();
    $output->TableColStart(1, 'left');
    $output->Text("<i>$openbasedir</i>");
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();

    $output->TableRowStart();
    $output->TableColStart(1, 'left');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<i> " . _PSBASEDIRFIX . "</i>");
    $output->TableColEnd();
    $output->TableRowEnd();
  }

    // Current directory
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<i> " . _PSCURRENTDIR . "</i>");
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->Text("<i>" . dirname(__FILE__) . "</i>");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();


    // Optional image directory
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSIMAGEDIRNAME);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $imagedirname = pnModGetVar('photoshare', 'imagedirname');
    
  $output->FormText('imagedirname', $imagedirname, 70, 255);
  $output->TableColEnd();
  $output->TableRowEnd();

  if (pnModGetVar('photoshare', 'useImageDirectory'))
  {
    photoshareGetWriteableDirs($imagedirname, $openbasedir, $msg);
    $output->TableRowStart();
    $output->TableColStart(2, 'left', 'top');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text($msg);
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();
  }

    // Tmp directory
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSTEMPDIRNAME);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $tmpdirname = pnModGetVar('photoshare', 'tmpdirname');
  photoshareGetWriteableDirs($tmpdirname, $openbasedir, $msg);
  
  $output->FormText('tmpdirname', $tmpdirname, 70, 255);
  $output->TableColEnd();
  $output->TableRowEnd();
  $output->TableRowStart();
  $output->TableColStart(2, 'left', 'top');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
 	$output->Text($msg);
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Thumbnail size
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSTHUMBNAILSIZE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormText('thumbnailsize', pnModGetVar('photoshare', 'thumbnailsize'), 20, 20);
  $output->TableColEnd();
  $output->TableRowEnd();

    // V4B 26-01-2004 TS start
    // Maximum display width - 0 for not defined
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSMAXDISPLAYWIDTH);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormText('maxdisplaywidth', pnModGetVar('photoshare', 'maxdisplaywidth'), 20, 20);
  $output->TableColEnd();
  $output->TableRowEnd();
  
    // Maximum display height - 0 for not defined
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSMAXDISPLAYHEIGHT);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormText('maxdisplayheight', pnModGetVar('photoshare', 'maxdisplayheight'), 20, 20);
  $output->TableColEnd();
  $output->TableRowEnd();
	// V4B 26-01-2004 TS end
  
    // Size limit of single image
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSIMAGESIZELIMITSINGLE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormText('imageSizeLimitSingle', pnModGetVar('photoshare', 'imageSizeLimitSingle'), 20, 20);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Total summarized size limit for user
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSIMAGESIZELIMITTOTAL);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormText('imageSizeLimitTotal', pnModGetVar('photoshare', 'imageSizeLimitTotal'), 20, 20);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Default folder access
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSDEFAULTFOLDERACCESS);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormCheckbox('defaultfolderaccess', pnModGetVar('photoshare', 'defaultfolderaccess'), 1);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Allow access per user
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSALLOWACCESSPERUSER);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormCheckbox('allowaccessperuser', pnModGetVar('photoshare', 'allowaccessperuser'), 1);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Allow users to remove PN frame
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSALLOWFRAMEREMOVE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormCheckbox('allowframeremove', pnModGetVar('photoshare', 'allowframeremove'), 1);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Default topic
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSDEFAULTTOPIC);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormSelectMultiple('defaultTopic', photosharePNGetTopics(pnModGetVar('photoshare', 'defaultTopic')));
  $output->TableColEnd();
  $output->TableRowEnd();

    // Default template
  $templates = pnModAPIFunc('photoshare',
                            'user',
                            'get_templates',
                            array('currentTemplate' => pnModGetVar('photoshare','defaultTemplate')) );

  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSDEFAULTTEMPLATE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormSelectMultiple('defaultTemplate', $templates);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Default main folder list
  $lists = pnModAPIFunc('photoshare',
                        'user',
                        'get_lists',
                        array('currentList' => pnModGetVar('photoshare','mainlist')) );

  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSMAINFOLDERLIST);
  $output->TableColEnd();
  $output->TableColStart(1, 'left', 'top');
  $output->FormSelectMultiple('mainlist', $lists);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableEnd();

  $output->FormSubmit(_PSSUBMITUPDATE);
  $output->FormEnd();

  return $output->GetOutput();
}


function photoshareGetWriteableDirs($dirname, $openbasedir, &$msg)
{
  if (!is_dir($dirname) || !is_writable($dirname) || !$dirname)
  {
    $msg = '<font color="#FF0000">'._PSNONSUITABLEDIR.'</font>';
  } else {
    $msg = _PSDIROK;
  }
}


function photoshare_admin_update_settings()
{
    // Check resend of input
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

   // V4B 26-01-2004 TS start
   // added maxdisplaywidth and maxdisplayheight
  list($useimagedirectory,
       $imagedirname,
       $tmpdirname, 
       $thumbnailsize,
       $maxdisplaywidth,
       $maxdisplayheight,
       $imageSizeLimitSingle,
       $imageSizeLimitTotal,
       $defaultfolderaccess,
       $allowaccessperuser,
       $allowframeremove,
       $defaultTopic,
       $defaultTemplate,
       $mainlist)        = pnVarCleanFromInput('useimagedirectory', 
                                               'imagedirname', 
                                               'tmpdirname', 
                                               'thumbnailsize',
                                               'maxdisplaywidth',
                                               'maxdisplayheight',
                                               'imageSizeLimitSingle',
                                               'imageSizeLimitTotal',
                                               'defaultfolderaccess',
                                               'allowaccessperuser',
                                               'allowframeremove',
                                               'defaultTopic',
                                               'defaultTemplate',
                                               'mainlist');

  pnModSetVar('photoshare', 'useimagedirectory', $useimagedirectory);
  pnModSetVar('photoshare', 'imagedirname', $imagedirname);
  pnModSetVar('photoshare', 'tmpdirname', $tmpdirname);
  pnModSetVar('photoshare', 'thumbnailsize', $thumbnailsize);
  pnModSetVar('photoshare', 'maxdisplaywidth', $maxdisplaywidth);
  pnModSetVar('photoshare', 'maxdisplayheight', $maxdisplayheight);
  pnModSetVar('photoshare', 'imageSizeLimitSingle', $imageSizeLimitSingle);
  pnModSetVar('photoshare', 'imageSizeLimitTotal', $imageSizeLimitTotal);
  pnModSetVar('photoshare', 'defaultfolderaccess', $defaultfolderaccess);
  pnModSetVar('photoshare', 'allowaccessperuser', $allowaccessperuser);
  pnModSetVar('photoshare', 'allowframeremove', $allowframeremove);
  pnModSetVar('photoshare', 'defaultTopic', $defaultTopic);
  pnModSetVar('photoshare', 'defaultTemplate', $defaultTemplate);
  pnModSetVar('photoshare', 'mainlist', $mainlist);
   // V4B 26-01-2004 TS end

  pnRedirect(pnModURL('photoshare', 'admin', 'main'));
  return true;
}


// -----------------------------------------------------------------------
// Storage setup
// -----------------------------------------------------------------------

function photoshare_admin_storage_setup()
{
  $output = new pnHTML();

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'admin'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Add title and heading
  photoshareAdminMenu($output);

  $groups = pnModFunc('photoshare', 'userapi', 'getallgroups', array('getStorageLimit' => true));
  $users = pnModFunc('photoshare', 'userapi', 'getallusers', array('getStorageLimit' => true));

  $output->FormStart( pnModUrl('photoshare', 'admin', 'update_storage_setup') );
  $output->FormHidden('authid', pnSecGenAuthKey());
  $output->FormHidden('usrnum', sizeof($users));
  $output->FormHidden('grpnum', sizeof($groups));

  photoshareAdminDumpSetupHTML($output, _PSGROUPS, 'grp', $groups);
  photoshareAdminDumpSetupHTML($output, _PSUSERS, 'usr', $users);
  
  $output->FormSubmit(_PSSUBMITUPDATE);
  $output->FormEnd();

  return $output->GetOutput();
}


function photoshareAdminDumpSetupHTML(&$output, $title, $prefix, $list)
{
  $output->TableStart($title,
                      array(_PSNAME, _PSSTORAGE),
                      0,
                      '');

  for ($i=0,$size=sizeof($list); $i<$size; ++$i)
  {
    $item = $list[$i];
    $output->TableRowStart();

    $output->TableColStart(1, 'left');
    $output->Text($item['name']);
    $output->TableColEnd();

    $output->TableColStart(1, 'left');
    $output->FormText("${prefix}size$i", $item['storage']);
    $output->TableColEnd();

    $output->FormHidden("${prefix}id$i", $item['id']);

    $output->TableRowEnd();
  }
  $output->TableEnd();
}


function photoshare_admin_update_storage_setup()
{
  $output = new pnHTML();

    // Check resend of input
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();
  $setupTable = $pntable['photoshare_setup'];
  $setupColumn = $pntable['photoshare_setup_column'];

    // First delete all existing entries
  if (!photoshareAdminDeleteStorageSetup($dbconn, $setupTable, $setupColumn))
    return photoshareErrorAPIGet();

  if (!photoshareAdminUpdateSetup($dbconn, $setupTable, $setupColumn, 'grp'))
    return photoshareErrorAPIGet();

  if (!photoshareAdminUpdateSetup($dbconn, $setupTable, $setupColumn, 'usr'))
    return photoshareErrorAPIGet();

  pnRedirect(pnModURL('photoshare', 'admin', 'storage_setup'));
  return true;
}


function photoshareAdminUpdateSetup(&$dbconn, $setupTable, $setupColumn, $prefix)
{
  $ok = true;

  $num = pnVarCleanFromInput("${prefix}num");
  for ($i=0; $i<$num; ++$i)
  {
    $id = pnVarCleanFromInput("${prefix}id$i");

    if ($id != '') // Just a precaution against a faked input
    {
      $size = pnVarCleanFromInput("${prefix}size$i");

        // Then if admin changed something do insert
      if ($size != '')
        $ok = $ok && photoshareAdminSetStorageSetup($dbconn, $setupTable, $setupColumn, $id,
                                                    ($prefix == 'grp' ? photoshareGroupSetupKind : photoshareUserSetupKind),
                                                    $size);
    }
  }

  return $ok;
}


function photoshareAdminDeleteStorageSetup(&$dbconn, $setupTable, $setupColumn)
{
  $sql = "DELETE FROM $setupTable";

  $dbconn->Execute($sql);

  if ($dbconn->ErrorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, 'Delete storage setup failed: ' . $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

  return true;
}


function photoshareAdminSetStorageSetup(&$dbconn, $setupTable, $setupColumn, $id, $kind, $size)
{
  $sql = "INSERT INTO $setupTable 
            ($setupColumn[kind], $setupColumn[storage], $setupColumn[id])
          VALUES
            (" . pnVarPrepForStore($kind) . "," . pnVarPrepForStore($size) . "," . pnVarPrepForStore($id) . ")";

  $dbconn->Execute($sql);

  if ($dbconn->ErrorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, 'Update storage setup failed: ' . $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

  return true;
}


// -----------------------------------------------------------------------
// Storage setup
// -----------------------------------------------------------------------

function photoshare_admin_recalc_sizes()
{
    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'admin'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $count = pnModAPIFunc('photoshare',
                        'admin',
                        'countZeroSizedImages');

  $render = new pnRender();
  $render->caching = false;
  $render->assign('imagesLeft', $count['missing']);
  $render->assign('imagesTotal', $count['total']);

  return $render->fetch('photoshare_admin_recalc_sizes.html');
}


function photoshare_admin_do_recalc_sizes()
{
    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'admin'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $ok = pnModAPIFunc('photoshare',
                     'admin',
                     'recalc_sizes');

  $render = new pnRender();
  $render->caching = false;

  if ($ok)
    $render->assign('message', _PSRECALCSIZESOK);
  else
    $render->assign('message', photoshareErrorAPIGet());

  return $render->fetch('photoshare_admin_do_recalc_sizes.html');
}


// -----------------------------------------------------------------------
// Admin menu
// -----------------------------------------------------------------------

function photoshareAdminMenu(&$output)
{
  $mainSetupURL = pnModUrl('photoshare', 'admin', 'main');
  $storageSetupURL = pnModUrl('photoshare', 'admin', 'storage_setup');
  $recalculateURL = pnModUrl('photoshare', 'admin', 'recalc_sizes');

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<div class="photoshare-pagetitle">' . _PSPHOTOSHARESETUP . '</div>');
  $output->Text("\n<hr>\n");
  $output->Text("<a href=\"" . $mainSetupURL . "\">" . _PSSETUPMAIN . "</a>");
  $output->Text("&nbsp;|&nbsp;<a href=\"" . $storageSetupURL . "\">" . _PSSETUPSTORAGE . "</a>");
  $output->Text("&nbsp;|&nbsp;<a href=\"" . $recalculateURL . "\">" . _PSSETUPRECALCULATE . "</a>");
  $output->Text("\n<hr>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);
}


// -----------------------------------------------------------------------
// Error handling
// -----------------------------------------------------------------------

function photoshareAdminGetError()
{
  return pnSessionGetVar('errormsg');
}


?>