<?php
// $Id: pnadminapi.php,v 1.1.1.1 2004/05/06 03:56:42 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2003.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/photoshare/common.php");


/*=======================================================================
  Recalculate sizes
=======================================================================*/

function photoshare_adminapi_countZeroSizedImages($args)
{
    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorAPI(__FILE__, __LINE__, _PSNOAUTH);

  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $imagesTable   = $pntable['photoshare_images'];
  $imagesColumn  = $pntable['photoshare_images_column'];

    // Calculate mising

  $sql = "SELECT COUNT(*) FROM $imagesTable WHERE $imagesColumn[xSize] = 0";

  $result = $dbconn->Execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, "Recalculation failed: " . $dbconn->errorMsg() . " while executing: $sql");

  $missing = $result->fields[0];

  $result->Close();

    // Calculate total

  $sql = "SELECT COUNT(*) FROM $imagesTable";

  $result = $dbconn->Execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, "Recalculation failed: " . $dbconn->errorMsg() . " while executing: $sql");

  $total = $result->fields[0];

  $result->Close();

  return array('missing' => $missing, 'total' => $total);
}


function photoshare_adminapi_recalc_sizes($args)
{
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorAPI(__FILE__, __LINE__, _PSAPILOADFAILED);

  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $imagesTable   = $pntable['photoshare_images'];
  $imagesColumn  = $pntable['photoshare_images_column'];

  $sql = "SELECT $imagesColumn[id] FROM $imagesTable WHERE $imagesColumn[xSize] = 0";

  $result = $dbconn->Execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareErrorAPI(__FILE__, __LINE__, "Recalculation failed: " . $dbconn->errorMsg() . " while executing: $sql");

  for (; !$result->EOF; $result->MoveNext())
  {
    $imageID = $result->fields[0];
    
    photoshareLog("Recalculating size for image ID '$imageID'");

    $sizeInfo = pnModAPIFunc('photoshare',
                             'user',
                             'recalc_size',
                             array('imageID' => $imageID));

    if ($sizeInfo !== false)
    {
      photoshareLog("Got sizeinfo for $imageID ($sizeInfo[xSize],$sizeInfo[ySize])- now update");

      $sql = "UPDATE $imagesTable
                SET $imagesColumn[xSize] = $sizeInfo[xSize],
                    $imagesColumn[ySize] = $sizeInfo[ySize]
              WHERE $imagesColumn[id] = " . pnVarPrepForStore($imageID);

      $dbconn->Execute($sql);

      if ($dbconn->errorNo() != 0)
        return photoshareErrorAPI(__FILE__, __LINE__, "Recalculation failed: " . $dbconn->errorMsg() . " while executing: $sql");
    }
    else
      photoshareLog("Failed to get size info for '$imageID' - " . photoshareErrorAPIGet());
  }

  $result->Close();

  return true;
}

?>