<?php
// $Id: common.php,v 1.1.1.1 2004/05/06 03:56:53 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

global $photoshareBlockErrorMsg;


  // Find all folders accessible by current user and return an array suitable for pnHTML::FormSelectMultiple
function photoshareBlockGetFolderSelectList($currentFolderID)
{
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareBlockError("Failed to load Photoshare user API");

  $user    = pnUserGetVar('uid');
  $folders =  pnModAPIFunc('photoshare',
                           'user',
                           'get_accessible_folders',
                           array('user'       => $user,
                                 'getForList' => true) );

  if (is_bool($folders)  &&  $folders == false)
    return photoshareBlockErrorAPI();

  $folderSelectList = array();

  if (is_array($folders))
  {
    foreach ($folders as $folder)
    {
      $folderSelectList[] = array('id'        => $folder['id'],
                                  'name'      => $folder['title'],
                                  'selected'  => ($folder['id'] == $currentFolderID));
    }
  }

  return $folderSelectList;
}


  // This is actually a duplicate of a function in pnuser.php, but since I find that a block should be
  // a stand-alone unit I choosed to copy it into here. Besides that I did not want to modify pnuser.php
  // (for instance by making the function API compliant) since pnuser.php at this time of writing is
  // in beta testing.
function photoshareBlockGetTopics($currentTopic)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $topicsTable  = $pntable['topics'];
  $topicsColumn = $pntable['topics_column'];

  $sql = "SELECT   $topicsColumn[tid],
                   $topicsColumn[topictext]
          FROM     $topicsTable
          ORDER BY $topicsColumn[topictext]";

  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareBlockError('"GetTopics" failed: ' . $dbconn->errorMsg() . " while executing: $sql");

  $topics = array();

  for (; !$result->EOF; $result->MoveNext())
  {
    $topics[] = array('id'   => $result->fields[0],
                      'name' => $result->fields[1], // Used directly in pnHTML so do not change to 'text'
                      'selected' => ($result->fields[0] == $currentTopic));
  }

  $result->Close();

  return $topics;
}


  // Verify access to specific folder
function photoshareBlockAccessFolder($folderID, $accessLevel)
{
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareBlockError("Failed to load Photoshare user API");

  return pnModAPIFunc('photoshare', 'user', 'get_folder_access', array('folderID'    => $folderID,
                                                                       'accessLevel' => $accessLevel,
                                                                       'viewKey'     => "") );
}


function photoshareBlockError($msg)
{
  global $photoshareBlockErrorMsg;
  $photoshareBlockErrorMsg = $msg;
  return false;
}


function photoshareBlockErrorApi()
{
  global $photoshareApiErrorMsg;
  return photoshareBlockError("Error in API: $photoshareApiErrorMsg");
}


function photoshareBlockGetError()
{
  global $photoshareBlockErrorMsg;
  return $photoshareBlockErrorMsg;
}


?>