<?php
// $Id: pninit.php,v 1.1.1.1 2004/05/06 03:56:43 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/photoshare/common.php");


// -----------------------------------------------------------------------
// Module initialization
// -----------------------------------------------------------------------
function photoshare_init()
{
    // Verify that we have the GD extension installed
  if (!extension_loaded('gd')) 
  {
      pnSessionSetVar('errormsg', _PSNOGDEXTENSION);
      return false;
  }

    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

    // It's good practice to name the table and column definitions you
    // are getting - $table and $column don't cut it in more complex
    // modules

    // Folder creation

  $folderTable = $pntable['photoshare_folders'];
  $folderColumn = &$pntable['photoshare_folders_column'];

    // Create the table
  $sql = "CREATE TABLE $folderTable (
          $folderColumn[id] INT NOT NULL AUTO_INCREMENT,
          $folderColumn[owner] INT NOT NULL,
          $folderColumn[createdDate] DATETIME NOT NULL,
          $folderColumn[modifiedDate] TIMESTAMP NOT NULL,
          $folderColumn[title] VARCHAR(255),
          $folderColumn[description] TEXT,
          $folderColumn[topic] INT NOT NULL,
          $folderColumn[template] VARCHAR(255) NOT NULL DEFAULT 'slideshow',
          $folderColumn[blockfromlist] BOOL NOT NULL DEFAULT '0',
          $folderColumn[hidepnframe] BOOL NOT NULL DEFAULT '0',
          $folderColumn[parentFolder] INT NOT NULL,
          $folderColumn[accessLevel] SMALLINT NOT NULL,
          $folderColumn[viewKey] VARCHAR(32),
          $folderColumn[mainImage] INT DEFAULT NULL,
          PRIMARY KEY(ps_id))";
  $dbconn->Execute($sql);

  // Check for an error with the database code, and if so set an
  // appropriate error message and return
  if ($dbconn->ErrorNo() != 0)
  {
      pnSessionSetVar('errormsg', _PSCREATETABLEFAILED . ': ' . 
                      $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);
      return false;
  }

    // Image creation

  $imagetable = $pntable['photoshare_images'];
  $imagecolumn = &$pntable['photoshare_images_column'];

    // Create the table
  $sql = "CREATE TABLE $imagetable (
          $imagecolumn[id] INT NOT NULL AUTO_INCREMENT,
          $imagecolumn[owner] INT NOT NULL,
          $imagecolumn[filename] VARCHAR(255) NOT NULL,
          $imagecolumn[mimeType] VARCHAR(255) NOT NULL,
          $imagecolumn[createdDate] DATETIME NOT NULL,
          $imagecolumn[modifiedDate] TIMESTAMP NOT NULL,
          $imagecolumn[title] VARCHAR(255),
          $imagecolumn[description] TEXT,
          $imagecolumn[parentFolder] INT NOT NULL,
          $imagecolumn[imageData] LONGBLOB NOT NULL,
          $imagecolumn[thumbnailData] BLOB NOT NULL,
          $imagecolumn[xSize] SMALLINT NOT NULL,
          $imagecolumn[ySize] SMALLINT NOT NULL,
          $imagecolumn[byteSize] INT NOT NULL,
          $imagecolumn[position] INT NOT NULL,
          PRIMARY KEY(ps_id))";
  $dbconn->Execute($sql);

  // Check for an error with the database code, and if so set an
  // appropriate error message and return
  if ($dbconn->ErrorNo() != 0)
  {
    pnSessionSetVar('errormsg', _PSCREATETABLEFAILED . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);
    return false;
  }


    // Access control creation

  $accessTable = $pntable['photoshare_access'];
  $accesscolumn = &$pntable['photoshare_access_column'];

    // Create the table
  $sql = "CREATE TABLE $accessTable (
          $accesscolumn[accessID] INT NOT NULL AUTO_INCREMENT,
          $accesscolumn[folder] INT NOT NULL,
          $accesscolumn[kind] TINYINT NOT NULL,
          $accesscolumn[access] TINYINT NOT NULL,
          $accesscolumn[id] INT NOT NULL,
          PRIMARY KEY(ps_accessID))";
  $dbconn->Execute($sql);

  // Check for an error with the database code, and if so set an
  // appropriate error message and return
  if ($dbconn->ErrorNo() != 0)
  {
    pnSessionSetVar('errormsg', _PSCREATETABLEFAILED . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);
    return false;
  }

  if (!photoshareCreateSetupTable($pntable, $dbconn))
    return false;

  $sql = "ALTER TABLE $accessTable ADD INDEX (ps_folder)";
  $dbconn->execute($sql);
  if ($dbconn->errorNo() != 0)
  {
    pnSessionSetVar('errormsg', _PSCREATETABLEFAILED . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);
    return false;
  }

    // Initialize global variables

  if (!pnModSetVar('photoshare', 'tmpdirname', '*'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': tmpdirname');
    return false;
  }

  if (!pnModSetVar('photoshare', 'imagedirname', '*'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': imageRepository');
    return false;
  }

  if (!pnModSetVar('photoshare', 'useImageDirectory', '1'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': thumbnailsize');
    return false;
  }

  if (!pnModSetVar('photoshare', 'thumbnailsize', '80'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': thumbnailsize');
    return false;
  }

   // V4B 26-01-2004 TS start
  if (!pnModSetVar('photoshare', 'maxdisplaywidth', '0'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': maxdisplaywidth');
    return false;
  }
  
  if (!pnModSetVar('photoshare', 'maxdisplayheight', '0'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': maxdisplayheight');
    return false;
  }
   // V4B 26-01-2004 TS end

  if (!pnModSetVar('photoshare', 'imageSizeLimitSingle', 250000))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': imageSizeLimitSingle');
    return false;
  }

  if (!pnModSetVar('photoshare', 'imageSizeLimitTotal', 5000000))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': imageSizeLimitTotal');
    return false;
  }

  if (!pnModSetVar('photoshare', 'allowframeremove', false))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': imageRepository');
    return false;
  }

  if (!photoshareSetDefaultTopic())
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': default topic');
    return false;
  }

  if (!photoshareSetDefaultTemplate())
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': default template');
    return false;
  }

  if (!pnModSetVar('photoshare', 'mainlist', 'flat'))
    return photoshareInitError(_PSSETMODVARFAILED . ': mainlist');

    // Initialisation successful
  return true;
}


function photoshareSetDefaultTopic()
{
  $topics = photosharePNGetTopics(NULL);
  if ($topics === false  ||  sizeof($topics) == 0)
    return pnModSetVar('photoshare', 'defaultTopic', '');
  else
    return pnModSetVar('photoshare', 'defaultTopic', $topics[0]['id']);
}


function photoshareSetDefaultTemplate()
{
    // It is not possible to load photoshare before it is installed, so just set uknown template if load fails
  if (!pnModAPILoad('photoshare', 'user'))
    return pnModSetVar('photoshare', 'defaultTemplate', 'unknown');

  $templates = pnModAPIFunc('photoshare',
                            'user',
                            'get_templates',
                            array('currentTemplate' => '') );

  if ($templates === false || sizeof($templates) == 0)
    return pnModSetVar('photoshare', 'defaultTemplate', 'unknown');
  else
    return pnModSetVar('photoshare', 'defaultTemplate', $templates[0]['id']);
}


function photoshareCreateSetupTable($pntable, &$dbconn)
{
  $setupTable = $pntable['photoshare_setup'];
  $setupColumn = $pntable['photoshare_setup_column'];

    // Create the table
  $sql = "CREATE TABLE $setupTable (
          $setupColumn[setupID] INT NOT NULL AUTO_INCREMENT,
          $setupColumn[kind] TINYINT NOT NULL,
          $setupColumn[storage] INT NOT NULL,
          $setupColumn[id] INT NOT NULL,
          PRIMARY KEY(ps_setupid))";
  $dbconn->Execute($sql);

  if ($dbconn->ErrorNo() != 0)
    return photoshareInitError(_PSCREATETABLEFAILED . ': ' . $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

    // Create table index for speed
  $sql = "ALTER TABLE $setupTable ADD INDEX (ps_kind,ps_storage)";
  $dbconn->execute($sql);
  if ($dbconn->errorNo() != 0)
    return photoshareInitError("Alter table failed: " . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


// -----------------------------------------------------------------------
// Module upgrade
// -----------------------------------------------------------------------
function photoshare_upgrade($oldversion)
{
  $ok = true;

    // Upgrade dependent on old version number
  switch($oldversion)
  {
    case '1.0.0':
      $ok = $ok && photoshare_upgrade_to_1_1_0($oldversion);
    case '1.1.0':
      $ok = $ok && photoshare_upgrade_to_1_1_1($oldversion);
    case '1.1.1':
    case '1.1.2':
      $ok = $ok && photoshare_upgrade_to_1_1_3($oldversion);
    case '1.1.3':
    case '1.2.0':
      $ok = $ok && photoshare_upgrade_to_1_2_1($oldversion);
    case '1.2.1':
      // nil
    case '1.2.2':
    case '1.2.3':
    case '2.0.0':
      // nil
    case '2.1.0':
      $ok = $ok && photoshare_upgrade_to_2_2_0($oldversion);
    case '2.2.0':
      $ok = $ok && photoshare_upgrade_to_2_2_1($oldversion);
    case '2.2.1':
      $ok = $ok && photoshare_upgrade_to_2_2_2($oldversion);
    case '2.2.2':
      $ok = $ok && photoshare_upgrade_to_2_2_3($oldversion);
    case '2.2.3':
    case '3.0.0':
    case '3.0.1':
    case '3.1.0':
    case '3.1.1':
    case '3.2.0':
      // nil
    case '3.3.0':
      $ok = $ok && photoshare_upgrade_to_3_4_0($oldversion);
    case '3.4.0':
      $ok = $ok && photoshare_upgrade_to_3_4_1($oldversion);
    case '3.4.1':
    case '3.5.0':
    case '4.0.0':
      // nil
    case '4.0.1':
      // future
  }

    // Update successful
  return $ok;
}


function photoshare_upgrade_to_1_1_0($oldVersion)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $foldersTable  = $pntable['photoshare_folders'];
  $foldersColumn = $pntable['photoshare_folders_column'];

    // Add extra "template" field to folder table
  if (!photoshareAddDatabaseField($dbconn, $oldVersion, "1.1.0", $foldersTable, 
                                  "ps_template VARCHAR(255) NOT NULL DEFAULT 'slideshow' AFTER ps_topic"))
    return false;

    // Add extra "blockfromlist" field to folder table
  if (!photoshareAddDatabaseField($dbconn, $oldVersion, "1.1.0", $foldersTable, 
                                  "ps_blockfromlist BOOL NOT NULL DEFAULT 0 AFTER ps_template"))
    return false;

    // Add extra "hidepnframe" field to folder table
  if (!photoshareAddDatabaseField($dbconn, $oldVersion, "1.1.0", $foldersTable, 
                                  "ps_hidepnframe BOOL NOT NULL DEFAULT 0 AFTER ps_blockfromlist"))
    return false;

  return true;
}


function photoshare_upgrade_to_1_1_1($oldVersion)
{
    // Do not know if necessary (some other part of PN might have done it - but better be sure)
	srand(((double)microtime())*1000000);

  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $foldersTable  = $pntable['photoshare_folders'];
  $foldersColumn = $pntable['photoshare_folders_column'];

    // Add extra "viewKey" field to folder table
  if (!photoshareAddDatabaseField($dbconn, $oldVersion, "1.1.1", $foldersTable, 
                                  "ps_viewkey VARCHAR(32) AFTER ps_accesslevel"))
    return false;

    // Create a viewkey for all existing entries
  $sql = "update $foldersTable set $foldersColumn[viewKey] = round(rand()*9000000000000 + 1000000000000)";
  $dbconn->execute($sql);
  if ($dbconn->errorNo() != 0)
    return photoshareInitError("Upgrade from $oldVersion to 1.1.1 failed: " . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


function photoshare_upgrade_to_1_1_3($oldVersion)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $accessTable  = $pntable['photoshare_access'];
  $accessColumn = $pntable['photoshare_access_column'];

    // Add database indecies

  $sql = "ALTER TABLE $accessTable ADD INDEX (ps_folder)";
  $dbconn->execute($sql);
  if ($dbconn->errorNo() != 0)
    return photoshareInitError("Upgrade from $oldVersion to 1.1.3 failed: " . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


function photoshare_upgrade_to_1_2_1($oldVersion)
{
  if (!pnModSetVar('photoshare', 'allowframeremove', false))
    return photoshareInitError(_PSSETMODVARFAILED . ': imageRepository');

  return true;
}


function photoshare_upgrade_to_2_2_0($oldVersion)
{
  if (!photoshareSetDefaultTopic())
    return photoshareInitError(_PSSETMODVARFAILED . ': default topic');

  if (!photoshareSetDefaultTemplate())
    return photoshareInitError(_PSSETMODVARFAILED . ': default template');

  return true;
}


function photoshare_upgrade_to_2_2_1($oldVersion)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();
  
  return photoshareCreateSetupTable($pntable, $dbconn);
}


function photoshare_upgrade_to_2_2_2($oldVersion)
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();
  
  $foldersTable  = $pntable['photoshare_folders'];
  $foldersColumn = $pntable['photoshare_folders_column'];

  if (!photoshareAddDatabaseField($dbconn, $oldVersion, "2.2.2", $foldersTable, 
                                  "ps_mainimage INT DEFAULT NULL AFTER ps_viewkey"))
    return false;

  return true;
}


function photoshare_upgrade_to_2_2_3($oldVersion)
{
  if (!pnModSetVar('photoshare', 'mainlist', 'nested'))
    return photoshareInitError(_PSSETMODVARFAILED . ': imageRepository');

  return true;
}


function photoshare_upgrade_to_3_4_0($oldVersion)
{
   // V4B 26-01-2004 TS start
  if (!pnModSetVar('photoshare', 'maxdisplaywidth', '0'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': maxdisplaywidth');
    return false;
  }
  
  if (!pnModSetVar('photoshare', 'maxdisplayheight', '0'))
  {
    pnSessionSetVar('errormsg', _PSSETMODVARFAILED . ': maxdisplayheight');
    return false;
  }
   // V4B 26-01-2004 TS end

  return true;
}


function photoshare_upgrade_to_3_4_1($oldVersion)
{
  pnModSetVar('photoshare', 'defaultfolderaccess', false);
  pnModSetVar('photoshare', 'allowaccessperuser', false);

  return true;
}


function photoshareAddDatabaseField(&$dbconn, $odlVersion, $newVersion, $tableName, $fieldInitString)
{
  $sql = "ALTER TABLE $tableName ADD $fieldInitString";

  $dbconn->Execute($sql);

  if ($dbconn->errorNo() != 0)
    return photoshareInitError("Upgrade from $oldVersion to $newVersion failed: " . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


// -----------------------------------------------------------------------
// Module delete
// -----------------------------------------------------------------------
function photoshare_delete()
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

    // Drop the folders table

  $sql = "DROP TABLE $pntable[photoshare_folders]";
  $dbconn->Execute($sql);

    // Check for an error with the database code
  if ($dbconn->ErrorNo() != 0)
    pnSessionSetVar('errormsg', 'Drop table failed ' . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

    // Drop the images table

  $sql = "DROP TABLE $pntable[photoshare_images]";
  $dbconn->Execute($sql);

    // Check for an error with the database code
  if ($dbconn->ErrorNo() != 0)
    pnSessionSetVar('errormsg', 'Drop table failed '  . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

    // Drop the access control table

  $sql = "DROP TABLE $pntable[photoshare_access]";
  $dbconn->Execute($sql);

    // Check for an error with the database code
  if ($dbconn->ErrorNo() != 0)
    pnSessionSetVar('errormsg', 'Drop table failed ' . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

    // Drop the setup table

  $sql = "DROP TABLE $pntable[photoshare_setup]";
  $dbconn->Execute($sql);

    // Check for an error with the database code
  if ($dbconn->ErrorNo() != 0)
    pnSessionSetVar('errormsg', 'Drop table failed '  . ': ' . 
                    $dbconn->ErrorMsg() . _PSWHILEEXECUTING . $sql);

    // Delete optional image files on disc
  if (pnModGetVar('photoshare', 'useImageDirectory'))
  {
    $dirName = pnModGetVar('photoshare', 'imagedirname');
    $dirHandle = opendir($dirName);
    if ($dirHandle != false)
    {
      while (($filename=readdir($dirHandle)) !=  false)
        if (substr($filename,0,3) == 'img'  ||  substr($filename,0,3) == 'tmb')
          unlink($dirName . '/' . $filename);
      closedir($dirHandle);
    }
  }

  pnModDelVar('photoshare', 'tmpdirname');
  pnModDelVar('photoshare', 'imagedirname');
  pnModDelVar('photoshare', 'useImageDirectory');
  pnModDelVar('photoshare', 'thumbnailsize');
  pnModDelVar('photoshare', 'imageSizeLimitSingle');
  pnModDelVar('photoshare', 'imageSizeLimitTotal');
  pnModDelVar('photoshare', 'allowframeremove');
  pnModDelVar('photoshare', 'defaultTemplate');
  pnModDelVar('photoshare', 'defaultTopic');
   // V4B 26-01-2004 TS start
  pnModDelVar('photoshare', 'maxdisplaywidth');
  pnModDelVar('photoshare', 'maxdisplayheight');
   // V4B 26-01-2004 TS end
  pnModDelVar('photoshare', 'defaultfolderaccess');
  pnModDelVar('photoshare', 'allowaccessperuser');

  // Deletion successful
  return true;
}


// -----------------------------------------------------------------------
// Error handling
// -----------------------------------------------------------------------

function photoshareInitError($msg)
{
  pnSessionSetVar('errormsg', $msg);

  return false;
}

?>