<?php
// $Id: photoshare.php,v 1.1.1.1 2004/05/06 03:56:55 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/photoshare/common.php");

$currentlang = pnUserGetLang();
include("modules/photoshare/pnlang/$currentlang/userapi.php");

  // Inform PostNuke search framework of the functions this module uses
$search_modules[] = array( 'title'       => 'Photoshare images',
                           'func_search' => 'search_photoshare',
                           'func_opt'    => 'search_photoshare_opt'
                         );

  // Define a callback class suitable for PostNuke/Photoshare standard search
class PhotosharePNSearchCallback extends PhotoshareSearchCallback
{
  var $count;
  var $html;

  function PhotosharePNSearchCallback()
  {
    $this->count = 0;
    $this->html = '';
  }


  function start()
  {
    $this->count = 0;
    $this->html = "Photoshare:<ul>\n";
  }


  function found($folderID, $imageID, $folderTitle, $imageTitle, $url)
  {
    $this->html .= "<li>$folderTitle: <a href=\"$url\">$imageTitle</a></li>\n";
    ++$this->count;
  }


  function stop()
  {
    if ($this->count == 0)
      $this->html = _PSSEARCHNONEFOUND . '<br>';
    else
      $this->html .= "</ul>\n";
  }
};


  // "Print" search form in advanced search
function search_photoshare_opt()
{
  global $bgcolor2;

  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_READ))
    return;

  return   "<table border=\"0\" width=\"100%\"><tr bgcolor=\"$bgcolor2\"><td>"
         . "<input type=\"checkbox\" name=\"active_photoshare\" id=\"active_photoshare\" value=\"1\" checked>&nbsp;"
         . "<label for=\"active_photoshare\">" . _PSSEARCH . "</label></td></tr></table>";
}


  // Do the searching (or rather - let the API do it)
function search_photoshare()
{
  list($query,
       $bool,
       $startnum,
       $total,
       $active_photoshare) = pnVarCleanFromInput('q',
                                                 'bool',
                                                 'startnum',
                                                 'total',
                                                 'active_photoshare');

  if (empty($active_photoshare))
    return;

  if (empty($query))
    return _PSSEARCHNONEFOUND . '<br>';

  if (!isset($startnum) || !is_numeric($startnum))
    $startnum = 1;

  if (isset($total) && !is_numeric($total))
    unset($total);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, 'Failed to load Photoshare user API');

  $callback = new PhotosharePNSearchCallback;
  $ok = pnModAPIFunc( 'photoshare',
                      'user',
                      'search',
                      array('query'    => $query,
                            'match'    => $bool,
                            'callback' => &$callback) );

  if (!$ok)
    return photoshareErrorAPIGet();

  return $callback->html;
}




?>