<?php
// $Id: pntables.php,v 1.1.1.1 2004/05/06 03:56:43 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

/**
 * This function is called internally by the core whenever the module is
 * loaded.  It adds in information about the tables that the module uses.
 */
function photoshare_pntables()
{
  $pntable = array();

    // Folder table setup

  $tableName = pnConfigGetVar('prefix') . '_photoshare_folders';

  $pntable['photoshare_folders'] = $tableName;

  $pntable['photoshare_folders_column'] = array('id'            => $tableName . '.ps_id',
                                                'owner'         => $tableName . '.ps_owner',
                                                'createdDate'   => $tableName . '.ps_createddate',
                                                'modifiedDate'  => $tableName . '.ps_modifieddate',
                                                'title'         => $tableName . '.ps_title',
                                                'description'   => $tableName . '.ps_description',
                                                'topic'         => $tableName . '.ps_topic',
                                                'template'      => $tableName . '.ps_template',
                                                'blockfromlist' => $tableName . '.ps_blockfromlist',
                                                'hidepnframe'   => $tableName . '.ps_hidepnframe',
                                                'parentFolder'  => $tableName . '.ps_parentfolder',
                                                'accessLevel'   => $tableName . '.ps_accesslevel',
                                                'viewKey'       => $tableName . '.ps_viewkey',
                                                'mainImage'     => $tableName . '.ps_mainimage');

    // Image table setup

  $tableName = pnConfigGetVar('prefix') . '_photoshare_images';

  $pntable['photoshare_images'] = $tableName;

  $pntable['photoshare_images_column'] = array('id'            => $tableName . '.ps_id',
                                               'owner'         => $tableName . '.ps_owner',
                                               'filename'      => $tableName . '.ps_filename',
                                               'mimeType'      => $tableName . '.ps_mimetype',
                                               'createdDate'   => $tableName . '.ps_createddate',
                                               'modifiedDate'  => $tableName . '.ps_modifieddate',
                                               'title'         => $tableName . '.ps_title',
                                               'description'   => $tableName . '.ps_description',
                                               'parentFolder'  => $tableName . '.ps_parentfolder',
                                               'imageData'     => $tableName . '.ps_imagedata',
                                               'thumbnailData' => $tableName . '.ps_thumbnaildata',
                                               'xSize'         => $tableName . '.ps_xsize',
                                               'ySize'         => $tableName . '.ps_ysize',
                                               'byteSize'      => $tableName . '.ps_bytesize',
                                               'position'      => $tableName . '.ps_position');

    // Access table setup

  $tableName = pnConfigGetVar('prefix') . '_photoshare_access';

  $pntable['photoshare_access'] = $tableName;

  $pntable['photoshare_access_column'] = array('accessID'     => $tableName . '.ps_accessid', // Unique ID
                                               'folder'       => $tableName . '.ps_folder',  // folder ID to which access applies
                                               'kind'         => $tableName . '.ps_kind',    // 0: Group, 1: User
                                               'access'       => $tableName . '.ps_access',  // 0: Read, 1: Write
                                               'id'           => $tableName . '.ps_id');     // User or group id

    // Setup table setup

  $tableName = pnConfigGetVar('prefix') . '_photoshare_setup';

  $pntable['photoshare_setup'] = $tableName;

  $pntable['photoshare_setup_column'] = array('setupID' => $tableName . '.ps_setupid',   // Unique ID
                                              'kind'    => $tableName . '.ps_kind',      // 0: group, 1: user
                                              'storage' => $tableName . '.ps_storage',   // Storage limit
                                              'id'      => $tableName . '.ps_id');       // User or group id this applies to

  return $pntable;
}

?>