<?php
// $Id: pnuser.php,v 1.1.1.1 2004/05/06 03:56:47 dyksjare Exp $
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/photoshare/common.php");

photoshareAddMainStyleSheet();

function photoshare_user_main()
{
  return photoshare_user_viewallfolders();
}

// -----------------------------------------------------------------------
//  Folder editing (main user window)
// -----------------------------------------------------------------------

function photoshare_user_view()
{
  $page = pnVarCleanFromInput('page');

  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnUserLoggedIn())
  {
    $output->Text(_PSMUSTBELOGGEDIN);
    return $output->GetOutput();
  }

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $user   = pnUserGetVar('uid');
  $folder = pnModAPIFunc('photoshare',
                         'user',
                         'get_folder_info',
                         array( 'folderID' => $folderID ));

  if ($folder === false)
    return photoshareErrorAPIGet();

  $folderTitle = (is_bool($folder) ? _PSTOPFOLDERNAME : $folder['title']);

  $thumbnailSize = pnModGetVar('photoshare', 'thumbnailsize');

    // Make sure current thumbnail size finds it way into the stylesheet
  global $additional_header;
  $additional_header[] = "<style>td.thumbnail { width: {$thumbnailSize}px; height: {$thumbnailSize}px; text-align: center; border: 1px solid black; }</style>";


    // Add JavaScript code
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<script language="JavaScript" src="modules/' . photoshareModGetName() . "/pnjavascript/editimages.js\"></script>\n");
  $output->Text('<script language="JavaScript" src="modules/' . photoshareModGetName() . "/pnjavascript/psmenu.js\"></script>\n");
  $output->Text("\n<script language=\"JavaScript\">\n" .
                "  var translations = { selectImage: \"" . _PSSELECTTARGETIMAGE . "\",\n" .
                "    tooManyImages: \"" . _PSMOVEONLYONE . "\",\n" .
                "    confirmDelete: \"" . _PSCONFIRMMULTIDELETE . "\" };\n" .
                "</script>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

    // Add user menu
  $menuHide = array( _PSMENUADDIMAGES    => (is_bool($folder)),
                     _PSMENUPUBLISHALBUM => (is_bool($folder))  ||  $user != $folder['owner'],  // Allow only owner to change access
                     _PSMENUFOLDEREDIT   => (is_bool($folder)),
                     _PSMENUFOLDERDELETE => (is_bool($folder)),
                     _PSMENUVIEWFOLDER   => (is_bool($folder)),
                     _PSMENUTHISFOLDER   => true);
  $menuSettings = array();
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEMYFOLDERS, true, null);

    // Create list of folders

  $owner   = pnUserGetVar('uid');
  $folders =  pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_list',
                           array('folderID' => $folderID) );
  
  $pos = 0;
  $hasEndTag = true;

  $output->TableStart('', '', 0, '');

    // Add "back" folder
  if ($folderID != -1)
  {
    $output->TableRowStart('center', 'top');

    $output->TableColStart(1, 'center', 'top');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text( photoshareGetFolderUpHTML($folder['parentFolder']) );
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();

    $pos = 1;
  }

  photoshareDrawFolders($output, $folders, $pos, $folderID, $hasEndTag);

  $images =  pnModAPIFunc('photoshare',
                          'user',
                          'get_image_list',
                           array('folderID'     => $folderID,
                                 'owner'        => $owner,
                                 'page'         => $page,
                                 'usePageCount' => true ) );
  $moreImages = $images['moreImages'];
  $images = $images['images'];

  photoshareDrawImages($output, $images, $pos, $folderID, $folder['mainImage']);

  $output->TableEnd();

  photoshareDrawPager($output, $page, $moreImages, $folder['imageCount'], $folderID, 'view');

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshareMakeEditIcons(&$output, $folderID)
{
  $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<tr class=\"photoshare-header-icons\"><td>");

  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

    // Create (hidden) menu for image clicking
  $output->Text( photoshareGetImageMenu($folderID) );

    // Create a hidden form in which we can submit the selected images
  $output->Text('<form'
                . ' action="' . pnModURL('photoshare', 'user', 'modifyimages') . '"'
                . ' name="commandForm"'
                . ' method="post"'
                . ' enctype="application/x-www-form-urlencoded">' . "\n");
  $output->Text('<input type="hidden" name="authid" value="' . pnSecGenAuthKey() . '">');
  $output->Text('<input type="hidden" name="fid" value="' . $folderID . '">');
  $output->Text('<input type="hidden" name="command" value="">');
  $output->Text('<input type="hidden" name="imageids" value="">');
  $output->Text("\n</form>\n");

  $output->Text("<table class=\"photoshare-toolbar-main\"><tr>\n");

  $output->Text("<td><table class=\"photoshare-toolbar\"><tr>\n");
  $output->Text("<td><img src=\"$imageDir/delete.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('delete',true)\" title=\"" . _PSSELECTEDDELETE . "\"></td>\n");
  $output->Text("<td><img src=\"$imageDir/rotatec.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('rotatec',true)\" title=\"" . _PSSELECTEDROTATEC . "\"></td>\n");
  $output->Text("<td><img src=\"$imageDir/rotatecc.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('rotatecc',true)\" title=\"" . _PSSELECTEDROTATECC . "\"></td>\n");
  $output->Text("</tr></table></td>\n");

  if (photoshareGetClipboard() == false  ||  $folderID < 0)
    $pasteImage = "<img src=\"$imageDir/paste_dimmed.gif\">";
  else
    $pasteImage = "<img src=\"$imageDir/paste.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('paste',false)\" title=\"" . _PSSELECTEDPASTE . "\">";

  $output->Text("<td><table class=\"photoshare-toolbar\"><tr>\n");
  $output->Text("<td><img src=\"$imageDir/copy.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('copy',true)\" title=\"" . _PSSELECTEDCOPY . "\"></td>\n");
  $output->Text("<td><img src=\"$imageDir/cut.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('cut',true)\" title=\"" . _PSSELECTEDCUT . "\"></td>\n");
  $output->Text("<td>$pasteImage</td>\n");
  $output->Text("</tr></table></td>\n");

  $output->Text("<td><table class=\"photoshare-toolbar\"><tr>\n");
  $output->Text("<td><img src=\"$imageDir/recalc.gif\" class=\"photoshare-button\" onclick=\"handleOnClickCommand('recalc',true)\" title=\"" . _PSSELECTEDRECALC . "\"></td>\n");
  $output->Text("</tr></table></td>\n");

  $output->Text("<td></td></tr></table>\n");

  $output->Text("</td></tr>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

  $output->SetInputMode($oldMode);
}


function photoshareGetImageMenu($folderID)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';
  $menu = array( array( 'title' => _PSVIEWIMAGE,     'image' => 'magnify.gif' ), 
                 array( 'title' => _PSEDITIMAGE,     'image' => 'setting.gif' ), 
                 array( 'title' => _PSDELETEIMAGE,   'image' => 'delete.gif' ), 
                 array( 'title' => _PSROTATECIMAGE,  'image' => 'rotatec.gif' ), 
                 array( 'title' => _PSROTATECCIMAGE, 'image' => 'rotatecc.gif' ), 
                 array( 'title' => _PSSETMAINIMAGE,  'image' => 'greendot.gif' ) );
    
    // Menu HTML setup
  $menuHTML = "<div class=\"psmenu\" id=\"psmenu-image\" onmouseout=\"psmenu.onMouseOutDiv(this)\">\n"
              . "<table>\n";

    // One table row for each menu item
  foreach ($menu as $menuItem)
    $menuHTML .= "<tr class=\"psmenu-menuItem\" onmouseover=\"psmenu.onMouseOver(this)\" onmouseout=\"psmenu.onMouseOut(this)\""
                 . " onmousedown=\"psmenu.onMouseDown(this)\">\n"
                 . "<td class=\"psmenu-icon\"><img src=\"$imageDir/$menuItem[image]\"></td>"
                 . "<td class=\"psmenu-title\"><nobr>$menuItem[title]</nobr></td>\n"
                 . "</tr>\n";

    // End menu HTML
  $menuHTML .= "</table>\n"
               . "</div>\n";

    // Add URL for click action
  $viewURL      = pnModUrl('photoshare', 'user', 'showimages',    array('fid' => $folderID, 'template' => 'slideshow'));
  $editURL      = pnModUrl('photoshare', 'user', 'editimage',     array('fid' => $folderID));
  $deleteURL    = pnModUrl('photoshare', 'user', 'deleteimage',   array('fid' => $folderID));
  $rotatecURL   = pnModUrl('photoshare', 'user', 'rotateimage',   array('fid' => $folderID, 'dir' => 'c'));
  $rotateccURL  = pnModUrl('photoshare', 'user', 'rotateimage',   array('fid' => $folderID, 'dir' => 'cc'));
  $setMainURL   = pnModUrl('photoshare', 'user', 'setmainimage',  array('fid' => $folderID));

  $menuHTML .= "<script>\n";
  $menuHTML .= "contextmenu.actionURLs = [\"$viewURL\",\"$editURL\",\"$deleteURL\",\"$rotatecURL\",\"$rotateccURL\",\"$setMainURL\"];";
  $menuHTML .= "</script>\n";

  return $menuHTML;
}


function photoshareGetThumbnailHTML($title, $id, $pos, $isLast, $folderID, $isMainImage)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $targetHTML = photoshareThumbnailTargetHTML($imageDir, $pos);

  $lastTargetHTML = "";
  if ($isLast)
    $lastTargetHTML = "<td>" . photoshareThumbnailTargetHTML($imageDir, $pos+1) . "</td>";

  $imageURL   = pnModUrl('photoshare', 'user', 'viewimage', array('iid' => $id, 'thumbnail' => 1));
  $imageHTML  = "<img src=\"$imageURL\" id=\"$id\" title=\"" . _PSSELECTIMAGE . 
                "\" class=\"photoshare-unselected\"" .
                " onmousedown=\"handleOnMouseDownImage(this, event)\">";

  if ($isMainImage)
    $mainImageHTML = "<img src=\"$imageDir/greendot.gif\" title=\"" . _PSISMAINIMAGE . "\" border=\"0\">";
  else
    $mainImageHTML = '';

  $menuIconImageHTML = "<img src=\"$imageDir/imagemenuicon.gif\" border=\"0\" class=\"photoshare-clickable\""
                       . " onmousedown=\"contextmenu.onMouseDown('$id', event, 'psmenu-image')\""
                       . " onmouseover=\"this.src='$imageDir/imagemenuicon_hover.gif'\""
                       . " onmouseout=\"this.src='$imageDir/imagemenuicon.gif'\">";

  $html = "<table class=\"photoshare-image\"><tr><td align=\"center\">$targetHTML</td>"
          . "<td align=\"center\" valign=\"top\">"
          . "<table><tr><td class=\"thumbnail\">$imageHTML</td><td valign=\"top\" align=\"center\">"
          . "$menuIconImageHTML<br><br>$mainImageHTML</td></tr></table>"
          . "</td>$lastTargetHTML</tr>\n";

  $html .= "<tr><td></td><td class=\"title\" align=\"center\">" . pnVarPrepForDisplay($title) . "</td></tr>\n";

  $html .= "</table>\n";

  return $html;
}


function photoshareThumbnailTargetHTML($imageDir, $pos)
{
  return "<img src=\"$imageDir/target_dimmed.gif\" id=\"$pos\" title=\"" . _PSMOVEIMAGETOTARGET . 
         "\" onClick=\"handleOnClickTarget(this)\" onMouseOver=\"this.src='$imageDir/target.gif'\"" .
         "  onMouseOut=\"this.src='$imageDir/target_dimmed.gif'\">";

}


function photoshareDrawFolders(&$output, $folders, &$pos, $parentFolderID, &$hasEndTag)
{
  foreach ($folders as $folder)
  {
    if ($pos % 4 == 0)
      $output->TableRowStart();

    $output->TableColStart(1, 'left', 'top');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text( photoshareGetFolderHTML($folder['title'], $folder['id'], $parentFolderID) );
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();

    if ($pos % 4 == 3)
    {
      $output->TableRowEnd();
      $hasEndTag = true;
    }
    else
      $hasEndTag = false;

    ++$pos;
  }
}


function photoshareDrawImages(&$output, $images, $pos, $folderID, $mainImageID)
{
    // Position not counting folders
  $imagePosition = 0;
  $lastImage = count($images)-1;

  foreach ($images as $image)
  {
    if ($pos % 4 == 0)
      $output->TableRowStart();

    $output->TableColStart(1, 'center', 'top');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text( photoshareGetThumbnailHTML($image['title'], $image['id'], $imagePosition, 
                                              $lastImage==$imagePosition, $folderID, $mainImageID == $image['id']) );
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();

    if ($pos % 4 == 3)
    {
      $output->TableRowEnd();
      $hasEndTag = true;
    }
    else
      $hasEndTag = false;

    ++$pos;
    ++$imagePosition;
  }

  if (!$hasEndTag)
    $output->TableRowEnd();
}


// -----------------------------------------------------------------------
//  Handling command on multiple images
// -----------------------------------------------------------------------

function photoshare_user_modifyimages($args)
{
  list($folderID,
       $command,
       $imageids) = pnVarCleanFromInput('fid',
                                        'command',
                                        'imageids');

    // Note: no delete confirmation since this is done using JavaScript
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Expand id list into array, iterate through images and execute command on each of them

  $idList = explode(",", trim($imageids));

  if ($command == "copy")
  {
    $clipboard = array('command'  => 'copy',
                       'imageIDs' => $idList);
    photoshareSetClipboard($clipboard);
    $idList = false;
  }
  else if ($command == "cut")
  {
    $clipboard = array('command'  => 'cut',
                       'imageIDs' => $idList);
    photoshareSetClipboard($clipboard);
    $idList = false;
  }
  else if ($command == "paste"  &&  $folderID >= 0)  // Do not paste into root
  {
    $clipboard = photoshareGetClipboard();

      // Overwrite URL command and image list with args from clipboard
    $command = $clipboard['command'];
    $idList  = $clipboard['imageIDs'];

      // Clear clipboard afterwards
    photoshareSetClipboard(false);
  }

  if ($idList != false)
  {
    foreach ($idList as $imageID)
    {
      if ($command == "delete")
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'delete_image',
                           array( 'imageID' => $imageID ));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
      else if ($command == "rotatec")
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'rotate_image',
                           array( 'imageID' => $imageID,
                                  'direction' => 'c' ));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
      else if ($command == "rotatecc")
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'rotate_image',
                           array( 'imageID' => $imageID,
                                  'direction' => 'cc' ));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
      else if ($command == 'copy')
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'copy_image_to_folder',
                           array( 'imageID'  => $imageID,
                                  'folderID' => $folderID));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
      else if ($command == 'cut')
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'move_image_to_folder',
                           array( 'imageID'  => $imageID,
                                  'folderID' => $folderID));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
      else if ($command == 'recalc')
      {
        $ok = pnModAPIFunc('photoshare',
                           'user',
                           'recalc_thumbnail',
                           array( 'imageID'  => $imageID,
                                  'folderID' => $folderID));

        if (!$ok)
          return photoshareErrorAPIGet();
      }
    }
  }

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


function photoshareGetClipboard()
{
  return pnSessionGetVar('photoshareClipboard');
}


function photoshareSetClipboard($clipboard)
{
  pnSessionSetVar('photoshareClipboard', $clipboard);
}


// -----------------------------------------------------------------------
// Add/edit folder
// -----------------------------------------------------------------------

function photoshare_user_addfolder()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get parent folder info (ignore unknown parent => this means we add a top most folder)
  $folder = pnModAPIFunc('photoshare',
                          'user',
                          'get_folder_info',
                          array( 'folderID' => $folderID ));

  if ($folder === false)
    return photoshareErrorAPIGet();

  $parentFolderTitle = ($folder === true ? _PSNONE : $folder['title']);

    // Add top menu
  $menuHide = false;
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEADDFOLDER, false, null);

  $actionURL = pnModURL('photoshare', 'user', 'createfolder', array('fid' => $folderID));
  $texts     = array( 'submit'    => _PSSUBMITADD,
                      'topic'     => pnModGetVar('photoshare', 'defaultTopic'),
                      'template'  => pnModGetVar('photoshare', 'defaultTemplate') );
  
  photoshareDumpFolderEditHTML($output, $actionURL, $folderID, $folderID, $parentFolderTitle, $texts, true /* for add */);

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshare_user_createfolder()
{
  list($parentFolderID,
       $title,
       $description,
       $topic,
       $template,
       $hidepnframe,
       $blockfromlist,
       $submit) = pnVarCleanFromInput('pid',
                                      'title',
                                      'description',
                                      'topic',
                                      'template',
                                      'hidepnframe',
                                      'blockfromlist',
                                      'submit');
  if ($submit == _PSCANCEL)
  {
      // This function generated no output, and so now it is complete we redirect
      // the user to an appropriate page for them to carry on their work
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $parentFolderID)));
    return true;
  }

    // Deny user ability to disable frames if admin says so
  if (!pnModGetVar('photoshare', 'allowframeremove'))
    $hidepnframe = false;

  $output = new pnHTML();

    // Check access
  if (!photoshareAccessFolder($parentFolderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $newFolderID = pnModAPIFunc('photoshare',
                              'user',
                              'create_folder',
                              array('parentFolderID' => $parentFolderID,
                                    'title'          => $title,
                                    'description'    => $description,
                                    'topic'          => $topic,
                                    'template'       => $template,
                                    'hidepnframe'    => $hidepnframe,
                                    'blockfromlist'  => $blockfromlist) );

  if ($newFolderID === false)
    return photoshareErrorAPIGet();

    // Set default folder access to "read by all" if requested in admin panel
  if (pnModGetVar('photoshare', 'defaultfolderaccess'))
  {
    $ok = pnModAPIFunc('photoshare',
                       'user',
                       'update_access',
                       array( 'folderID'         => $newFolderID,
                              'accessLevel'      => photoshareFolderAccessViewByAll,
                              'groupReadAccess'  => array(),
                              'groupWriteAccess' => array(),
                              'userReadAccess'   => array(),
                              'userWriteAccess'  => array() ));

    if ($ok === false)
      return photoshareErrorAPIGet();
  }

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $newFolderID)));
  return true;
}


function photoshare_user_editfolder()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder info
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  $parentFolderID = pnVarCleanFromInput('pid');

  if (is_bool($folder))
    if ($folder == false)
      return photoshareErrorAPIGet();
    else
      return photoshareErrorPage(__FILE__, __LINE__, _PSUNKNOWNFOLDER);

  $menuHide = false;
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEEDITFOLDER, false, null);

  $actionURL = pnModURL('photoshare', 'user', 'updatefolder');
  $texts     = array( 'title'         => $folder['title'],
                      'description'   => $folder['description'],
                      'topic'         => $folder['topic'],
                      'template'      => $folder['template'],
                      'hidepnframe'   => $folder['hidepnframe'],
                      'blockfromlist' => $folder['blockfromlist'],
                      'submit'        => _PSSUBMITEDIT );
  
  photoshareDumpFolderEditHTML($output, $actionURL, $folderID, $parentFolderID, NULL, $texts, false /* for edit */);

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshare_user_updatefolder()
{
  list($folderID,
       $parentFolderID,
       $title,
       $description,
       $topic,
       $template,
       $hidepnframe,
       $blockfromlist,
       $submit) = pnVarCleanFromInput('fid',
                                      'pid',
                                      'title',
                                      'description',
                                      'topic',
                                      'template',
                                      'hidepnframe',
                                      'blockfromlist',
                                      'submit');

  if ($submit == _PSCANCEL)
  {
      // This function generated no output, and so now it is complete we redirect
      // the user to an appropriate page for them to carry on their work
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
    return true;
  }

    // Deny user ability to disable frames if admin says so
  if (!pnModGetVar('photoshare', 'allowframeremove'))
    $hidepnframe = false;

  $output = new pnHTML();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'update_folder',
                     array('folderID'      => $folderID,
                           'title'         => $title,
                           'description'   => $description,
                           'topic'         => $topic,
                           'template'      => $template,
                           'hidepnframe'   => $hidepnframe,
                           'blockfromlist' => $blockfromlist) );

  if (!$ok)
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


function photoshareDumpFolderEditHTML(&$output, $actionURL, $folderID, $parentFolderID, $parentFolderTitle, $texts, $forAdd)
{
  $topics = photosharePNGetTopics($texts['topic']);
  if ($topics === false)
  {
    $output->Text(photoshareErrorAPIGet());
    return false;
  }

  $template = pnModAPIFunc('photoshare',
                           'user',
                           'get_templates',
                           array('currentTemplate' => $texts['template']) );
  if ($template === false)
  {
    $output->Text(photoshareErrorAPIGet());
    return false;
  }

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<script language=\"JavaScript\">\n");
  $output->Text("function openHelp()\n".
                "{\n".
                "  var templateName = document.getElementById(\"template\").value;\n".
                "  var url = \"modules/" . pnVarPrepForOS(photoshareModGetName()) . "/templates/\"+templateName+\"/docs/manual.html\";\n".
                "  window.open(url, \"\", \"height=500,width=600\");\n".
                "  return false;\n".
                "}\n");
    
  $output->Text("</script>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

    // Create folder input form
  $output->FormStart($actionURL);

  $output->FormHidden('fid', $folderID);
  $output->FormHidden('pid', $parentFolderID);
  $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a table for the fields
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<table class=\"photoshare-editform\">\n");
  $output->SetInputMode(_PNH_VERBATIMINPUT);

    // New folder title
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSFOLDERTITLE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->tabindex++;
  $output->Text("<input type=\"text\" class=\"photoshare-edittitle\" maxlength=\"255\" name=\"title\" value=\""
                . pnVarPrepForDisplay($texts['title']) . "\" tabindex=\"" . $output->tabindex . "\">");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // New folder description
  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSFOLDERDESCRIPTION);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->tabindex++;
  $output->Text("<textarea class=\"photoshare-editdescription\" name=\"description\" rows=\"4\" tabindex=\"" . $output->tabindex . "\">"
                . pnVarPrepForDisplay($texts['description']) . "</textarea>");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Folder topic
  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSFOLDERTOPIC);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->FormSelectMultiple('topic', $topics);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Folder presentation template
  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSDEFAULTFOLDERTEMPLATE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->FormSelectMultiple('template', $template);
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text(" [ <a href=\"\" onclick=\"return openHelp();\">" . _PSTEMPLATEINFO . "</a> ]" );
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Hide PostNuke frame
  if (pnModGetVar('photoshare', 'allowframeremove'))
  {
    $output->TableRowStart();
    $output->TableColStart(1, 'left', 'top');
    $output->Text(_PSHIDEPNFRAME);
    $output->TableColEnd();
    $output->TableColStart(1, 'left');
    $output->FormCheckbox('hidepnframe', $texts['hidepnframe']);
    $output->TableColEnd();
    $output->TableRowEnd();
  }

    // Block from list
  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSBLOCKFROMLIST);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->FormCheckbox('blockfromlist', $texts['blockfromlist']);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("</table>\n");
  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->tabindex++;
  $output->Text("<input type=\"submit\" name=\"submit\" value=\""
                . pnVarPrepForDisplay($texts['submit']) . "\" tabindex=\"" . $output->tabindex . "\">");
  $output->Text(" ");
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->tabindex++;
  $output->Text("<input type=\"submit\" name=\"submit\" value=\""
                . pnVarPrepForDisplay(_PSCANCEL) . "\" tabindex=\"" . $output->tabindex . "\">");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->FormEnd();

  $output->LineBreak();
}


// -----------------------------------------------------------------------
// Delete folder
// -----------------------------------------------------------------------

function photoshare_user_deletefolder()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder info
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));

  if (is_bool($folder))
    if ($folder == false)
      return photoshareErrorAPIGet();
    else
    {
      $output->Text(_PSUNKNOWNFOLDER);
      return $output->GetOutput();
    }

  $parentFolderID = $folder['parentFolder'];

    // FIXME: show folder info (incl. image count)

  $confirmation = pnVarCleanFromInput('confirmation');
  if (empty($confirmation))
  {
      // No confirmation yet - display a suitable form to obtain confirmation
      // of this action from the user

    $menuHide = array( _PSMENUADDFOLDER    => true,
                       _PSMENUADDIMAGES    => true,
                       _PSMENUFOLDEREDIT   => true,
                       _PSMENUVIEWFOLDER   => true,
                       _PSMENUFOLDERDELETE => true,
                       _PSMENUPUBLISHALBUM => true );
    $menuSettings = array( 'gotoCurrentFolder' => true );
    photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEDELETEFOLDER, false, null);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text( photoshareGetFolderInfoHTML($folder) );
    $output->SetInputMode(_PNH_PARSEINPUT);

      // Add confirmation to output.
    photoshareMultipleConfirmAction($output, 
                                    _PSCONFIRMFOLDERDELETE . " '$folder[title]'.",
                                    pnModURL('photoshare',
                                             'user',
                                             'deletefolder',
                                             array('fid' => $folderID,
                                                   'pid' => $parentFolderID)),
                                    array( _PSCONFIRMFOLDERDELETESINGLE,
                                           _PSCONFIRMFOLDERDELETESUB ));

    photoshareMakeMainFooter($output);

      // Return the output that has been generated by this function
    return $output->GetOutput();
  }

    // If we get here it means that the user has confirmed the action

    // Confirm authorisation code.  This checks that the form had a valid
    // authorisation code attached to it.  If it did not then the function will
    // proceed no further as it is possible that this is an attempt at sending
    // in false data to the system
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $button = pnVarCleanFromInput('button');
  $choice = pnVarCleanFromInput('choice');

    // Get folder info
  $folderID = photoshareGetCurrentFolderID();

    // If user pressed 'OK' then examine selection
  if ($button == _PSOK  &&  ($choice == '0'  ||  $choice == '1'))
  {
    $ok = pnModAPIFunc('photoshare',
                       'user',
                       'delete_folder',
                       array( 'folderID'         => $folderID,
                              'deleteSubFolders' => ($choice == '1')));

    if (!$ok)
      return photoshareErrorAPIGet();
  }


    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  if ($button == _PSOK)
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $parentFolderID)));
  else
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


function photoshareMultipleConfirmAction(&$output, $title, $actionURL, $choices)
{
  $output->FormStart($actionURL);

  $hidden = array('confirmation' => 1,
                  'authid' => pnSecGenAuthKey() );
    
  $output->Text($title);
  $output->LineBreak(2);
  $output->FormHidden($hidden);

  for ($i=0,$size=count($choices) ; $i<$size ; ++$i)
  {
    $output->FormCheckbox('choice', 0, $i, 'radio');
    $output->Text($choices[$i]);
    $output->LineBreak();
  }

  $output->LineBreak();

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<input type="submit" name="button" value="' . _PSOK . '" align="middle">');
  $output->Text('<input type="submit" name="button" value="' . _PSCANCEL . '" align="middle">');
  $output->SetInputMode(_PNH_PARSEINPUT);

  $output->FormEnd();
}

// -----------------------------------------------------------------------
// View all accessible folders
// -----------------------------------------------------------------------

class ListHelper
{
  function folderURL($folderId)
  {
    return pnModUrl('photoshare', 'user', 'showimages', array('fid' => $folderId));
  }
}


function photoshare_user_viewallfolders()
{
  $output = new pnHTML();

    // Check access
  if (!photoshareAccessFolder(-1, photoshareAccessRequirementView, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $order        = pnVarCleanFromInput('order');
  $topFolderID  = photoshareGetCurrentFolderID();
  $user         = pnUserGetVar('uid');

  if (!isset($order))
    $order = 'date';

  $listName = pnModGetVar('photoshare', 'mainlist');
  $listHandler =  pnModAPIFunc('photoshare',
                               'user',
                               'load_list',
                               array( 'listName' => $listName ));
  $listHelper = new ListHelper;

  if ($listHandler->isNested())
    $folders =  pnModAPIFunc('photoshare',
                             'user',
                             'get_accessible_folders',
                             array('user'            => $user,
                                   'getForList'      => true,
                                   'order'           => $order,
                                   'parentFolderID'  => $topFolderID) );
  else
    $folders =  pnModAPIFunc('photoshare',
                             'user',
                             'get_accessible_folders',
                             array('user'       => $user,
                                   'getForList' => true,
                                   'order'      => $order) );
  
  if ($folders === false)
    return photoshareErrorAPIGet();

  if ($topFolderID != -1)
    $topFolderInfo =  pnModAPIFunc('photoshare',
                                   'user',
                                   'get_folder_info',
                                   array('folderID'        => $topFolderID,
                                         'countSubFolders' => true) );
  else
    $topFolderInfo = array( 'id' => -1,
                            'title' => _PSTOPFOLDERNAME );

    // Add "order by" selection (but not for nested listers)
  if (!$listHandler->isNested())
  {
    $titleSelected  = ($order == 'title' ? "selected" : "");
    $ownerSelected  = ($order == 'owner' ? "selected" : "");
    $dateSelected   = ($order == 'date'  ? "selected" : "");
    $topicSelected  = ($order == 'topic' ? "selected" : "");

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $orderURL = pnModURL('photoshare', 'user', 'viewallfolders');
    $output->Text("<div align=\"right\">" ._PSORDERBY . 
                  " <select onChange=\"javascript:window.location='$orderURL&order='+this.value\">\n" .
                  "<option value=\"title\" $titleSelected>" .  _PSORDERBYTITLE . "</option>\n" .
                  "<option value=\"owner\" $ownerSelected>" . _PSORDERBYOWNER . "</option>\n" .
                  "<option value=\"date\" $dateSelected>" . _PSORDERBYDATE . "</option>\n" .
                  "<option value=\"topic\" $topicSelected>" . _PSORDERBYTOPIC . "</option>\n" .
                  "</select></div>\n");
    $output->SetInputMode(_PNH_PARSEINPUT);
  }
  
    // Output link to list specific stylesheet
  if ($listHandler->usesStyleSheet())
  {
    $cssURL = "modules/" . pnVarPrepForOS(photoshareModGetName()) . "/lists/" . pnVarPrepForOS($listName)
              . "/themes/" . pnVarPrepForOS(pnUserGetTheme()) . "/style.css";

      // Use default stylesheet if the theme specific stylesheet do not exist
    if (!@file_exists($cssURL))
      $cssURL = "modules/" . pnVarPrepForOS(photoshareModGetName()) . "/lists/" . pnVarPrepForOS($listName)
                . "/themes/photoshare/style.css";

      // Use PostNuke variable for insertion of special HTML header tags.
    global $additional_header;
    if (!is_array($additional_header))
      $additional_header = array();
    $additional_header[] = "<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">";
  }

  $listHandler->startList($output, $topFolderInfo, $listHelper);

  foreach ($folders as $folder)
  {
    $folderInfo =  pnModAPIFunc('photoshare',
                                'user',
                                'get_folder_info',
                                array('folderID'        => $folder['id'],
                                      'countSubFolders' => true) );
    
    if (is_bool($folderInfo))
      if ($folderInfo == false)
        return photoshareErrorAPIGet();
      else
        photoshareErrorPage(__FILE__, __LINE__, _PSUNKNOWNFOLDER . " ($folder[id])" );

    $listHandler->showList($output, $folderInfo, $listHelper);
  }

  $listHandler->endList($output, $topFolderInfo, $listHelper);


  return $output->GetOutput();
}

// -----------------------------------------------------------------------
// Access control
// -----------------------------------------------------------------------

function photoshare_user_editaccess()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementAdmin, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if (is_bool($folder))
    if ($folder == false)
      return photoshareErrorAPIGet();
    else
    {
      $output->Text(_PSUNKNOWNFOLDER);
      return $output->GetOutput();
    }

    // FIXME: show folder info (incl. current image count)

    // Add top menu
  $menuHide = array( _PSMENUADDFOLDER    => true,
                     _PSMENUADDIMAGES    => true,
                     _PSMENUFOLDEREDIT   => true,
                     _PSMENUVIEWFOLDER   => true,
                     _PSMENUFOLDERDELETE => true,
                     _PSMENUPUBLISHALBUM => true );
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSCHANGEACCESS, false, null);

    // Add folder info
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( photoshareGetFolderInfoHTML($folder) );
  $output->SetInputMode(_PNH_PARSEINPUT);

    // Add selector javascript
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<script language="JavaScript" src="modules/' . photoshareModGetName() . "/pnjavascript/selector.js\">\n</script>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

    // Get current access control lists
  $accessLists = pnModAPIFunc('photoshare',
                              'user',
                              'get_access',
                              array( 'folderID' => $folderID ));
  if ($accessLists === false)
    return photoshareErrorAPIGet();

    // Add the accesss control form

  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $output->FormStart( pnModURL('photoshare', 'user', 'updateaccess') );
  $output->FormHidden('authid', pnSecGenAuthKey());
  $output->FormHidden('fid', $folderID);

  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $mailURL  = pnModUrl('photoshare', 'user', 'setup_mail_folder', array('fid' => $folderID));
  $mailHTML = "<a href=\"$mailURL\"><img src=\"$imageDir/mail.gif\" title=\"" . _PSMAILFOLDERSHORT . "\" border=\"0\"></a>";
  $output->Text("<br><table><tr valign=\"top\"><td>$mailHTML</td><td>" . _PSMAILFOLDER . "</td></tr></table><br>\n");

  $output->Text('<div class="photoshare-heading">' . _PSSELECTACCESS . '</div>');
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->FormCheckbox('accessLevel', $accessLists['accessLevel'] == photoshareFolderAccessPrivate, photoshareFolderAccessPrivate, 'radio');
  $output->Text(_PSACCESSPRIVATE);
  $output->LineBreak();
  $output->FormCheckbox('accessLevel', $accessLists['accessLevel'] == photoshareFolderAccessViewByAll, photoshareFolderAccessViewByAll, 'radio');
  $output->Text(_PSACCESSALLREAD);
  $output->LineBreak();
  $output->FormCheckbox('accessLevel', $accessLists['accessLevel'] == photoshareFolderAccessEditByAll, photoshareFolderAccessEditByAll, 'radio');
  $output->Text(_PSACCESSALLWRITE);
  $output->LineBreak();
  $output->FormCheckbox('accessLevel', $accessLists['accessLevel'] == photoshareFolderAccessSpecific, photoshareFolderAccessSpecific, 'radio');
  $output->Text(_PSACCESSDETAILED);
  $output->LineBreak();
  $output->LineBreak();

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text(_PSPUBLISHHELP);
  $output->SetInputMode(_PNH_PARSEINPUT);

  photoshareMakeSelector($output, 
                         _PSGROUPACCESS, 
                         _PSGROUPS, 
                         "Group", 
                         pnModFunc('photoshare', 'userapi', 'getallgroups'),
                         $accessLists['groupRead'],
                         $accessLists['groupWrite']);

  if (pnModGetVar('photoshare', 'allowaccessperuser'))
  {
    photoshareMakeSelector($output, 
                           _PSUSERACCESS,  
                           _PSUSERS,  
                           "User",  
                           pnModFunc('photoshare', 'userapi', 'getallusers'),
                           $accessLists['userRead'],
                           $accessLists['userWrite']);
  }

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text('<input type="submit" value="' . _CONFIRM . "\" onclick=\"selectorSubmit(['Group','User'])\">\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

  $output->FormEnd();

  return $output->GetOutput();
}


function photoshare_user_updateaccess()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementAdmin, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Confirm authorisation code.  This checks that the form had a valid
    // authorisation code attached to it.  If it did not then the function will
    // proceed no further as it is possible that this is an attempt at sending
    // in false data to the system
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

    // Get folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if (is_bool($folder))
    if ($folder == false)
      return photoshareErrorAPIGet();
    else
    {
      $output->Text(_PSUNKNOWNFOLDER);
      return $output->GetOutput();
    }

/*
  echo "GR: " . pnVarCleanFromInput('GroupValue1') . "<br>\n";
  echo "GW: " . pnVarCleanFromInput('GroupValue2') . "<br>\n";
  echo "UR: " . pnVarCleanFromInput('UserValue1') . "<br>\n";
  echo "UW: " . pnVarCleanFromInput('UserValue2') . "<br>\n";
*/

  $accessLevel      = pnVarCleanFromInput('accessLevel');
  $groupReadAccess  = explode(";", pnVarCleanFromInput('GroupValue1'));
  $groupWriteAccess = explode(";", pnVarCleanFromInput('GroupValue2'));
  $userReadAccess   = explode(";", pnVarCleanFromInput('UserValue1'));
  $userWriteAccess  = explode(";", pnVarCleanFromInput('UserValue2'));

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'update_access',
                     array( 'folderID'         => $folderID,
                            'accessLevel'      => $accessLevel,
                            'groupReadAccess'  => $groupReadAccess,
                            'groupWriteAccess' => $groupWriteAccess,
                            'userReadAccess'   => $userReadAccess,
                            'userWriteAccess'  => $userWriteAccess   ));

  if ($ok === false)
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


function photoshareMakeSelector(&$output, $title, $sourceName, $name, $data, $accessList1, $accessList2)
{
  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->Text("<br><div class=\"photoshare-heading\">$title</div>\n");

  $output->TableStart('', array(), 0, '');

    // Add select box headings
  $output->TableAddRow( array( $sourceName, _PSHASREADACCESS, _PSHASWRITEACCESS) );

  $output->TableRowStart();

    // Data source
  $output->TableColStart();
  $output->Text("\n<select name=\"$name\" id=\"$name\" size=6 multiple=\"1\" style=\"width:150;\">\n");
  foreach ($data as $d)
    if (!$accessList1[$d['id']]  &&  !$accessList2[$d['id']])
      $output->Text("<option value=\"" . htmlspecialchars($d['id']) . "\">" . htmlspecialchars($d['name']) . "</option>\n");
  $output->Text("</select>\n");
  $output->TableColEnd();

    // Read access
  $output->TableColStart();
  $output->Text("\n<select name=\"${name}1\" id=\"${name}1\" size=6 multiple=\"1\" style=\"width:150;\">\n");
  foreach ($data as $d)
    if ($accessList1[$d['id']])
      $output->Text("<option value=\"" . htmlspecialchars($d['id']) . "\">" . htmlspecialchars($d['name']) . "</option>\n");
  $output->Text("</select>\n");
  $output->TableColEnd();

    // Write access
  $output->TableColStart();
  $output->Text("\n<select name=\"${name}2\" id=\"${name}2\" size=6 multiple=\"1\" style=\"width:150;\">\n");
  foreach ($data as $d)
    if ($accessList2[$d['id']])
      $output->Text("<option value=\"" . htmlspecialchars($d['id']) . "\">" . htmlspecialchars($d['name']) . "</option>\n");
  $output->Text("</select>\n");
  $output->TableColEnd();

  $output->TableRowEnd();

  $output->TableRowStart();

    // No button
  $output->TableColStart();
  $output->TableColEnd();

    // Add/remove read button
  $output->TableColStart();
  $output->Text("<input type=\"button\" onclick=\"selectorRemove1('$name')\" value=\"&lt;&lt;\">\n&nbsp;");
  $output->Text("<input type=\"button\" onclick=\"selectorAdd1('$name')\" value=\"&gt;&gt;\">\n");
  $output->TableColEnd();

    // Add/remove write button
  $output->TableColStart();
  $output->Text("<input type=\"button\" onclick=\"selectorRemove2('$name')\" value=\"&lt;&lt;\">\n&nbsp;");
  $output->Text("<input type=\"button\" onclick=\"selectorAdd2('$name')\" value=\"&gt;&gt;\">\n");
  $output->TableColEnd();

  $output->TableRowEnd();

  $output->TableEnd();

  $output->Text("<input type=\"hidden\" name=\"${name}Value1\" id=\"${name}Value1\">\n");
  $output->Text("<input type=\"hidden\" name=\"${name}Value2\" id=\"${name}Value2\">\n");

  $output->SetInputMode(_PNH_PARSEINPUT);
}


// -----------------------------------------------------------------------
// Mail folder to friends
// -----------------------------------------------------------------------

function photoshare_user_setup_mail_folder()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if (is_bool($folder))
    if ($folder == false)
      return photoshareErrorAPIGet();
    else
    {
      $output->Text(_PSUNKNOWNFOLDER);
      return $output->GetOutput();
    }

    // Add top menu
  $menuHide = array( _PSMENUADDFOLDER    => true,
                     _PSMENUADDIMAGES    => true,
                     _PSMENUFOLDEREDIT   => true,
                     _PSMENUVIEWFOLDER   => true,
                     _PSMENUFOLDERDELETE => true,
                     _PSMENUPUBLISHALBUM => true );
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEMAILFOLDER, false, null);

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text(_PSMAILWARNING. "<br>\n");
  $output->SetInputMode(_PNH_PARSEINPUT);

  $output->FormStart( pnModURL('photoshare', 'user', 'mail_folder') );

  $output->FormHidden('fid', $folderID);
  $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a table for the fields
  $output->TableStart();

  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSMAILSENDER);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<input type=\"text\" disabled=\"true\" size=\"40\" value=\"" . pnUserGetVar('email') . "\">\n");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSMAILRECIPIENTS);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->FormTextArea('recipients', '', 5, 40);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSMAILSUBJECT);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->FormText('subject', '', 40);
  $output->TableColEnd();
  $output->TableRowEnd();

  $viewKey = $folder['viewKey'];
  $viewURL = pnModUrl('photoshare', 'user', 'showimages', array('fid'     => $folderID, 
                                                                'viewkey' => $viewKey));
  $output->TableRowStart();
  $output->TableColStart(2, 'left');
  $output->FormTextArea('text', _PSMAILLETTERTEXT . " $viewURL", 20, 80);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableEnd();

  $output->FormSubmit(_PSMAILSUBMIT);
  $output->FormEnd();

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshare_user_mail_folder()
{
  $output = new pnHTML();

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  list($folderID,
       $recipients,
       $subject,
       $text) = pnVarCleanFromInput('fid',
                                    'recipients',
                                    'subject',
                                    'text');

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

    // Do our best to replace newlines with commas (newline representation depends on browser platform)
  $recipients = str_replace("\r\n", ",", $recipients);
  $recipients = str_replace("\n", ",", $recipients);
  $recipients = str_replace("\r", ",", $recipients);

  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/plain; charset=iso-8859-1\r\n";
  $headers .= "From: " . pnUserGetVar('email') . "\r\n";

  $ok = mail($recipients, $subject, $text, $headers);

  if (!$ok)
    return photoshareErrorPage(__FILE__, __LINE__, "Unable to send message using PHP mail function. Sorry");

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


// -----------------------------------------------------------------------
// Add images to folder
// -----------------------------------------------------------------------

function photoshare_user_addimages()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if ($folder === false)
    return photoshareErrorAPIGet();
  else if ($folder === true)
    photoshareErrorPage(__FILE__, __LINE__, _PSUNKNOWNFOLDER);

    // Get user information
  $userInfo = pnModAPIFunc('photoshare',
                           'user',
                           'get_user_info');
  if ($userInfo === false)
    return photoshareErrorAPIGet();

    // Add top menu
  $menuHide = array( _PSMENUADDFOLDER    => true,
                     _PSMENUADDIMAGES    => true,
                     _PSMENUFOLDEREDIT   => true,
                     _PSMENUVIEWFOLDER   => true,
                     _PSMENUFOLDERDELETE => true,
                     _PSMENUPUBLISHALBUM => true );
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEADDIMAGES, false, null);

    // Max. number of images to upload
  $imageNum = 8;

    // Add folder info
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( photoshareGetFolderInfoHTML($folder) );
  $output->SetInputMode(_PNH_PARSEINPUT);

  $output->UploadMode();

    // Add link to file import
  if (pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
  {
    $output->LineBreak(1);
    $importURL = pnModURL('photoshare', 'user', 'importimages', array('fid' => $folderID));
    $output->Text(_PSADMINIMPORTLINK1);
    $output->URL($importURL, _PSADMINIMPORTLINK2);
    $output->Text(".");
    $output->LineBreak(2);
  }

  $upload_max_filesize = ini_get('upload_max_filesize');
  $post_max_size = ini_get('post_max_size');
  if ($upload_max_filesize != '')
  {
    $output->Text(_PSMAXFILESIZEMSG . ": $upload_max_filesize " . _PSBYTES);
    $output->LineBreak(2);
  }
  else if ($post_max_size != '')
  {
    $output->Text(_PSMAXFILESIZEMSG . ": $post_max_size " . _PSBYTES);
    $output->LineBreak(2);
  }

    // Add upload form for the input
  $output->FormStart( pnModURL('photoshare', 'user', 'uploadimages') );

  $output->FormHidden('fid', $folderID);
  $output->FormHidden('imagenum', $imageNum);
  $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a table for the fields
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<table class=\"photoshare-editform\">\n");
  $output->SetInputMode(_PNH_VERBATIMINPUT);

  for ($i=0 ; $i<$imageNum ; ++$i)
  {
      // Note: pnHTML does not allow you to set style - so we have to code input fields our self
      // (since we then self set the tabindex we also have to code the remainnig stuff our self)

      // Image number
    $output->TableRowStart();
    $output->TableColStart(2, 'left');
    $output->BoldText(_PSIMAGENO . ' ' . ($i+1));
    $output->TableColEnd();
    $output->TableRowEnd();

      // Image file
    $output->TableRowStart();
    $output->TableColStart(1, 'left');
    $output->Text(_PSIMAGEFILE);
    $output->TableColEnd();
    $output->TableColStart(1, 'left');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<input type=\"file\" class=\"photoshare-editfile\" name=\"imagefile$i\" />");
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();

      // Image title
    $output->TableRowStart();
    $output->TableColStart(1, 'left');
    $output->Text(_PSIMAGETITLE);
    $output->TableColEnd();
    $output->TableColStart(1, 'left');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<input type=\"text\" class=\"photoshare-edittitle\" maxlength=\"255\" name=\"imagetitle$i\" />");
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();

      // Image description
    $output->TableRowStart('left');
    $output->TableColStart(1, 'left', 'top');
    $output->Text(_PSIMAGEDESCRIPTION);
    $output->TableColEnd();
    $output->TableColStart(1, 'left');
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text("<textarea class=\"photoshare-editdescription\" name=\"imagedescription$i\" rows=\"4\"></textarea>");
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableColEnd();
    $output->TableRowEnd();
    $output->Text("\n");
  }

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("</table>\n");
  $output->Text("<input type=\"submit\" value=\"" . _PSSUBMITIMAGES . "\" />");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->FormEnd();

  $output->LineBreak(2);
  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshare_user_uploadimages()
{
  $output = new pnHTML();

  $folderID = photoshareGetCurrentFolderID();

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get parent folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));

  if ($folder === false)
    return photoshareErrorAPIGet();
  else if ($folder === true)
    photoshareErrorPage(__FILE__, __LINE__, _PSCANNOTADDIMAGESWITHOUTFOLDER);

    // Get user information
  $userInfo = pnModAPIFunc('photoshare',
                           'user',
                           'get_user_info');
  if ($userInfo === false)
    return photoshareErrorAPIGet();

  $totalCapacityUsed = $userInfo['totalCapacityUsed'];

  $menuHide = array();
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEADDINGIMAGES, false, null);

  $imageNum         = intval( pnVarCleanFromInput('imagenum') );
  $folderId         = photoshareGetCurrentFolderID();
  $imageDir         = 'modules/' . photoshareModGetName() . '/pnimages';
  $statusSet        = array();

  for ($i=0; $i < $imageNum; ++$i)
  {
    $imageInfo    = $_FILES["imagefile$i"];
    $title        = pnVarCleanFromInput("imagetitle$i");
    $description  = pnVarCleanFromInput("imagedescription$i");

    if (isset($imageInfo['error'])  &&  $imageInfo['error'] != 0  &&  $imageInfo['name'] != '')
    {
      $statusSet[] = array('ok'      => false,
                           'message' => $imageInfo['name'] . ': ' . photoshareUploadErrorMsg($imageInfo[error]));
    }
    else
    if ($imageInfo['size'] > 0)
    {
      $statusSet = array_merge($statusSet,
                               pnModAPIFunc('photoshare',
                                            'user',
                                            'add_image',
                                            array( 'folderID'      => $folderID,
                                                   'dataFilename'  => $imageInfo['tmp_name'],
                                                   'dataFileSize'  => $imageInfo['size'],
                                                   'imageFilename' => $imageInfo['name'],
                                                   'mimeType'      => $imageInfo['type'],
                                                   'title'         => $title,
                                                   'description'   => $description,
                                                   'isUploaded'    => true )) );
    }
  }

    // Quick count of uploaded images
  $acceptedImageNum = 0;
  foreach ($statusSet as $status)
    if ($status['ok'])
      ++$acceptedImageNum;
  $folder['imageCount'] += $acceptedImageNum; // Update for showing only

  if ($acceptedImageNum == 0)
    $statusSet[] = array('ok'      => false,
                         'message' => _PSNOIMAGES);

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( photoshareGetFolderInfoHTML($folder) );
  $output->LineBreak();
  photoshareDisplayStatusSet($output, $imageDir, $statusSet);
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->LineBreak();

  $viewURL = pnModURL('photoshare', 'user', 'view', array('fid' => $folderID));
  $output->LineBreak();
  $output->FormStart($viewURL);
  $output->FormSubmit(_PSCONTINUE);
  $output->FormEnd();

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshareUploadErrorMsg($error)
{
  switch ($error)
  {
    case 1:
      return _PSUPLOADERROR_INISIZE;
    case 2:
      return _PSUPLOADERROR_FORMSIZE;
    case 3:
      return _PSUPLOADERROR_PARTIAL;
    case 4:
      return _PSUPLOADERROR_NOFILE;
    default:
      return _PSUPLOADERROR_UNKNOWN;
  }
}


function photoshareDisplayStatusSet(&$output, $imageDir, $statusSet)
{
  foreach ($statusSet as $status)
  {
    if ($status['ok'])
    {
      $output->SetInputMode(_PNH_VERBATIMINPUT);
      $output->Text("$status[message] <img src=\"$imageDir/check.gif\">");
      $output->SetInputMode(_PNH_PARSEINPUT);
      $output->LineBreak();
    }
    else
    {
      $output->SetInputMode(_PNH_VERBATIMINPUT);
      $output->Text("$status[message] <img src=\"$imageDir/uncheck.gif\">");
      $output->SetInputMode(_PNH_PARSEINPUT);
      $output->LineBreak();
    }
  }
}

// -----------------------------------------------------------------------
// Image import from local file system
// -----------------------------------------------------------------------

function photoshare_user_importimages($args)
{
  $output = new pnHTML();

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  $folderID = photoshareGetCurrentFolderID();

    // Add top menu
  $menuHide = array( _PSMENUADDFOLDER    => true,
                     _PSMENUADDIMAGES    => true,
                     _PSMENUFOLDEREDIT   => true,
                     _PSMENUVIEWFOLDER   => true,
                     _PSMENUFOLDERDELETE => true,
                     _PSMENUPUBLISHALBUM => true );
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, array(), _PSTITLEADDIMAGES, false, null);

    // Add import form for admin users
  $output->FormStart( pnModURL('photoshare', 'user', 'doimportimages') );
  $output->FormHidden('fid', $folderID);
  $output->FormHidden('authid', pnSecGenAuthKey());
  $output->FormHidden('verify', '1');

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<table class=\"photoshare-editform\">\n");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->SetInputMode(_PNH_VERBATIMINPUT);

    // Heading
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text('<div class="photoshare-heading">' . _PSIMPORTHEADER . '</div>');
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSIMPORTDIRECTORY);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text(_PSCURRENTDIRIS . "<i>" . dirname(__FILE__) . "</i>.");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Image directory
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<input type=\"text\" class=\"photoshare-edittitle\" name=\"directory\" />");
  $output->LineBreak(1);
  $output->Text("<input type=\"submit\" value=\"" . _PSIMPORTSUBMIT . "\" />");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("</table>\n");
  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->FormEnd();

  return $output->GetOutput();
}


function photoshare_user_doimportimages()
{
  $folderID = photoshareGetCurrentFolderID();

    // Check access
  if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_ADMIN))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $output = new pnHTML();

  $verify     = pnVarCleanFromInput('verify');
  $directory  = pnVarCleanFromInput('directory');

  if (pnVarCleanFromInput('kind') == _PSCANCEL)
  {
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
    return true;
  }

  $menuHide = array( _PSMENUADDFOLDER    => true,
                     _PSMENUADDIMAGES    => true,
                     _PSMENUFOLDEREDIT   => true,
                     _PSMENUVIEWFOLDER   => true,
                     _PSMENUFOLDERDELETE => true,
                     _PSMENUPUBLISHALBUM => true );
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, 
                         ($verify ? _PSTITLEVERIFYINGIMPORT : _PSTITLEADDINGIMAGES), false, null);

  $statusSet = pnModAPIFunc('photoshare',
                            'user',
                            'import_images',
                            array( 'folderID'  => $folderID,
                                   'directory' => $directory,
                                   'verify'    => $verify));

  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( photoshareGetFolderInfoHTML($folder) );
  $output->LineBreak();
  if ($verify)
    $output->Text( _PSIMPORTWILLBEIMPORTED );
  $output->LineBreak();
  $output->LineBreak();
  photoshareDisplayStatusSet($output, $imageDir, $statusSet);
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->LineBreak();

  if ($verify)
  {
    $importURL = pnModURL('photoshare', 'user', 'importimages', array('fid' => $folderID, 'verify' => 0));
    $output->LineBreak();
    $output->FormStart($viewURL);
    $output->FormHidden('authid', pnSecGenAuthKey());
    $output->FormHidden('fid', $folderID);
    $output->FormHidden('directory', $directory);
    outputSubmitButton($output, _PSCONTINUE, 'kind');
    outputSubmitButton($output, _PSCANCEL,   'kind');
    $output->FormEnd();
  }
  else
  {
    $viewURL = pnModURL('photoshare', 'user', 'view', array('fid' => $folderID));
    $output->LineBreak();
    $output->FormStart($viewURL);
    $output->FormSubmit(_PSCONTINUE);
    $output->FormEnd();
  }

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


// -----------------------------------------------------------------------
// Edit image
// -----------------------------------------------------------------------

function photoshare_user_editimage()
{
  $output = new pnHTML();

  $imageID = photoshareGetCurrentImageID();

    // Check access
  if (!photoshareAccessImage($imageID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get image info
  $image   = pnModAPIFunc('photoshare',
                           'user',
                           'get_image_info',
                           array( 'imageID' => $imageID ));

  $folderID = photoshareGetCurrentFolderID();

  $menuHide = false;
  $menuSettings = array( 'gotoCurrentFolder' => true );
  photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEEDITIMAGE, false, null);

  if ($image == false)
  {
    $output->Text(_PSUNKNOWNIMAGE);
    return $output->GetOutput();
  }

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( photoshareGetThumbnailInfoHTML($image) );
  $output->SetInputMode(_PNH_PARSEINPUT);

  $actionURL = pnModURL('photoshare', 'user', 'updateimage');
  photoshareDumpImageEditHTML($output, $actionURL, $folderID, $image);

  photoshareMakeMainFooter($output);

  return $output->GetOutput();
}


function photoshare_user_updateimage()
{
  list($imageID,
       $folderID,
       $title,
       $description,
       $submit) = pnVarCleanFromInput('iid',
                                      'fid',
                                      'title',
                                      'description',
                                      'submit');
  if ($submit == _PSCANCEL)
  {
      // This function generated no output, and so now it is complete we redirect
      // the user to an appropriate page for them to carry on their work
    pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
    return true;
  }

  $output = new pnHTML();

  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $imageInfo = $_FILES['imagefile'];

    // Check access
  if (!photoshareAccessImage($imageID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if ($imageInfo['size'] != 0)
  {
      // Get user information
    $userInfo = pnModAPIFunc('photoshare',
                             'user',
                             'get_user_info');
    if ($userInfo === false)
      return photoshareErrorAPIGet();

    $totalCapacityUsed = $userInfo['totalCapacityUsed'] + $imageInfo['size'];

    if ($totalCapacityUsed > $userInfo['imageSizeLimitTotal'])
    {
      $output->Text(_PSERROR . ': ' . _PSCAPACITYLIMITREACHED);
      return $output->GetOutput();
    }

    if ($imageInfo['size'] > $userInfo['imageSizeLimitSingle'])
    {
      $output->Text(_PSERROR . ': ' . _PSIMAGETOOBIG);
      return $output->GetOutput();
    }
  }

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'update_image',
                     array('imageID'       => $imageID,
                           'title'         => $title,
                           'description'   => $description,
                           'dataFilename'  => $imageInfo['tmp_name'],
                           'dataFileSize'  => $imageInfo['size'],
                           'imageFilename' => $imageInfo['name'],
                           'mimeType'      => $imageInfo['type'],
                           'isUploaded'    => true));

  if ($ok === false)
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


function photoshareDumpImageEditHTML(&$output, $actionURL, $folderID, $image)
{
    // Create image input form

  $output->UploadMode();
  $output->FormStart($actionURL);

  $output->FormHidden('authid', pnSecGenAuthKey());
  $output->FormHidden('iid', $image['id']);
  $output->FormHidden('fid', $folderID);

    // Add a table for the fields
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<table class=\"photoshare-editform\">\n");
  $output->SetInputMode(_PNH_VERBATIMINPUT);

    // New image title
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSIMAGETITLE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<input type=\"text\" class=\"photoshare-edittitle\" maxlength=\"255\" name=\"title\" value=\""
                . pnVarPrepForDisplay($image['title']) . "\">");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // New image description
  $output->TableRowStart();
  $output->TableColStart(1, 'left', 'top');
  $output->Text(_PSIMAGEDESCRIPTION);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<textarea name=\"description\" class=\"photoshare-editdescription\" rows=\"4\">"
                . pnVarPrepForDisplay($image['description']) . "</textarea>");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

    // Optional new image
  $output->TableRowStart();
  $output->TableColStart(1, 'left');
  $output->Text(_PSNEWIMAGEFILE);
  $output->TableColEnd();
  $output->TableColStart(1, 'left');
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("<input type=\"file\" class=\"photoshare-editfile\" name=\"imagefile\" />");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->TableColEnd();
  $output->TableRowEnd();

  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text("</table>\n");
  $output->Text("<input type=\"submit\" value=\"" . _PSSUBMITEDIT . "\" />");
  $output->Text("<input type=\"submit\" name=\"submit\" value=\""
                . pnVarPrepForDisplay(_PSCANCEL) . "\" tabindex=\"" . $output->tabindex . "\">");
  $output->SetInputMode(_PNH_PARSEINPUT);
  $output->FormEnd();

  $output->LineBreak();
}


// -----------------------------------------------------------------------
// Move image inside folder
// -----------------------------------------------------------------------

function photoshare_user_moveimage()
{
  list($imageID,
       $position) = pnVarCleanFromInput('iid',
                                        'pos');

  $output = new pnHTML();

    // Check access
  if (!photoshareAccessImage($imageID, photoshareAccessRequirementEdit, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

// FIXME: check authentication of submit

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'move_image',
                     array('imageID'  => $imageID,
                           'position' => $position) );

  if ($ok === false)
    return photoshareErrorAPIGet();

  $imageInfo = pnModAPIFunc('photoshare',
                            'user',
                            'get_image_info',
                            array( 'imageID' => $imageID ));

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $imageInfo['parentFolder'])));
  return true;
}


// -----------------------------------------------------------------------
// Delete image
// -----------------------------------------------------------------------

function photoshare_user_setmainimage()
{
  $imageID  = photoshareGetCurrentImageID();
  $folderID = photoshareGetCurrentFolderID();

    // (Access check in API.)

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  if (!pnModAPIFunc('photoshare',
                    'user',
                    'set_main_image',
                    array( 'imageID' => $imageID )))
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


// -----------------------------------------------------------------------
// Delete image
// -----------------------------------------------------------------------

function photoshare_user_deleteimage()
{
  $output = new pnHTML();

  $imageID  = photoshareGetCurrentImageID();

    // (Access check in API.)

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

    // Get folder info
  $folderID = photoshareGetCurrentFolderID();
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if ($folder === false)
    return photoshareErrorAPIGet();
  else if ($folder === true)
    return photoshareErrorPage(__FILE__, __LINE__, _PSUNKNOWNFOLDER);

    // Get image info
  $image    = pnModAPIFunc('photoshare',
                           'user',
                           'get_image_info',
                           array( 'imageID' => $imageID ));

  if ($image == false)
  {
    $output->Text(_PSUNKNOWNIMAGE);
    return $output->GetOutput();
  }

  $confirmation = pnVarCleanFromInput('confirmation');
  if (empty($confirmation))
  {
      // No confirmation yet - display a suitable form to obtain confirmation
      // of this action from the user

    $menuHide = false;
    $menuSettings = array( 'gotoCurrentFolder' => true );
    photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, _PSTITLEDELETEIMAGE, false, null);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text( photoshareGetThumbnailInfoHTML($image) );
    $output->SetInputMode(_PNH_PARSEINPUT);

      // Add confirmation to output.  Note that this uses a pnHTML helper
      // function to produce the requested confirmation in a standard
      // fashion.
    $output->ConfirmAction(_PSCONFIRMIMAGEDELETE . " '$image[title]'",
                           pnModURL('photoshare',
                                    'user',
                                    'deleteimage',
                                    array('iid' => $imageID,
                                          'fid' => $folderID)),
                           _PSCANCEL,
                           pnModURL('photoshare',
                                    'user',
                                    'view',
                                    array('fid' => $folderID)));

      // Return the output that has been generated by this function
    return $output->GetOutput();

    photoshareMakeMainFooter($output);
  }

    // If we get here it means that the user has confirmed the action

    // Confirm authorisation code.  This checks that the form had a valid
    // authorisation code attached to it.  If it did not then the function will
    // proceed no further as it is possible that this is an attempt at sending
    // in false data to the system
  if (!pnSecConfirmAuthKey())
    return photoshareErrorPage(__FILE__, __LINE__, _PSBADAUTHKEY);

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'delete_image',
                     array( 'imageID' => $imageID ));

  if (!$ok)
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


// -----------------------------------------------------------------------
// Rotate image
// -----------------------------------------------------------------------

function photoshare_user_rotateimage()
{
  $output = new pnHTML();

  $imageID = photoshareGetCurrentImageID();

    // Access check in API.

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $folderID = photoshareGetCurrentFolderID();
  $direction = pnVarCleanFromInput('dir');

  $ok = pnModAPIFunc('photoshare',
                     'user',
                     'rotate_image',
                     array('imageID'   => $imageID,
                           'direction' => $direction));

  if (!$ok)
    return photoshareErrorAPIGet();

    // This function generated no output, and so now it is complete we redirect
    // the user to an appropriate page for them to carry on their work
  pnRedirect(pnModURL('photoshare', 'user', 'view', array('fid' => $folderID)));
  return true;
}


// -----------------------------------------------------------------------
// Show a single image
// -----------------------------------------------------------------------

function photoshare_user_viewimage()
{
  $imageID   = pnVarCleanFromInput('iid');
  $folderID  = pnVarCleanFromInput('fid');
  $topic     = pnVarCleanFromInput('topic');
  $latest    = pnVarCleanFromInput('latest');
  $thumbnail = intval(pnVarCleanFromInput('thumbnail'));

  $output = new pnHTML();

    // Check access
  if ($imageID == 'random')
  {
    if (!pnSecAuthAction(0, 'photoshare::', '::', ACCESS_READ))
      return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);
  }
  else if (!photoshareAccessImage($imageID, photoshareAccessRequirementView, $viewKey))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  if ($imageID == 'random')
  {
    $randomInfo = pnModAPIFunc('photoshare', 'user', 'get_random_image',
                               array('folderID' => $folderID,
                                     'topic'    => $topic,
                                     'latest'   => $latest));

    if ($randomInfo == false)
      return photoshareErrorPage(__FILE__, __LINE__, "Unable to find random image");

    $imageID = $randomInfo['imageID'];

      // Do not cache random images (otherwise you always get the same since the URL does not change)
    $cache = false;
  }
  else
    $cache = true;

  if (!pnModAPIFunc('photoshare', 
                    'user',
                    'dumpimage', 
                    array( 'imageID'   => $imageID,
                           'thumbnail' => $thumbnail,
                           'cache'     => $cache)))
    return photoshareErrorAPIGet();

  return true;
}


function photoshare_user_displayimage()
{
  $imageID  = pnVarCleanFromInput('iid');
  $viewKey  = pnVarCleanFromInput('viewkey');

  $thumbnail = intval(pnVarCleanFromInput('thumbnail'));

    // Check access
  if (!photoshareAccessImage($imageID, photoshareAccessRequirementView, $viewKey))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $imageInfo = pnModAPIFunc('photoshare', 'user', 'get_image_info',
                            array( 'imageID' => $imageID ));

  $imageURL = pnModUrl('photoshare', 'user', 'viewimage', 
                       array('iid'       => $imageID, 
                             'thumbnail' => $thumbnail,
                             'viewkey'   => $viewkey));

  $smarty = new pnRender();
  $smarty->caching = false;
  $smarty->assign('imageURL', $imageURL);
  $smarty->assign($imageInfo);

  echo $smarty->fetch('photoshare_display_image.html');
  return true;
}


// -----------------------------------------------------------------------
// Show images using associated template
// -----------------------------------------------------------------------

  // This template helper class can be used for various functions that
  // a template may need - for instance generating an URL to an image.
class TemplateHelper
{
    // Constructor (instantiate with view key - may be empty string)
  function TemplateHelper($templateData, $viewKey)
  {
      // Extract view keys for image generation
    $this->viewKeys = array();
    $this->makeViewKeys($templateData, $viewKey);
  }


    // Get URL to full image
  function imageUrl($folderID, $imageID)
  {
    return pnModUrl('photoshare', 'user', 'viewimage', array('iid'     => $imageID,
                                                             'viewkey' => $this->viewKeys[$folderID]));
  }

    // Get URL to thumbnail
  function thumbnailUrl($folderID, $imageID)
  {
    return pnModUrl('photoshare', 'user', 'viewimage', array('iid'        => $imageID,
                                                             'thumbnail'  => 1,
                                                             'viewkey'    => $this->viewKeys[$folderID]));
  }

    // Get URL to folder with new template (and viewkey)
  function folderUrl($folderID, $template)
  {
    return pnModUrl('photoshare', 'user', 'showimages', array('fid'        => $folderID,
                                                              'viewkey'    => $this->viewKeys[$folderID],
                                                              'template'   => $template));
  }


  // Private

  function makeViewKeys($templateData, $viewKey)
  {
    $folder = $templateData['folder'];
    if ($viewKey != ''  &&  $folder['viewKey'] == $viewKey)
    {
      $this->viewKeys[$folder['id']] = $viewKey;

      $folders = $templateData['folders'];
      foreach ($folders as $ff)
      {
        $this->makeViewKeys($ff, $ff['folder']['viewKey']);
      }
    }
  }

  var $viewKeys;
};


function photoshare_user_showimages()
{
  list($folderID,
       $imageID,
       $viewKey) = pnVarCleanFromInput('fid',
                                       'iid',
                                       'viewkey');

    // Check access
  if (!photoshareAccessFolder($folderID, photoshareAccessRequirementView, $viewKey))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $output = new pnHTML();

    // Get folder information
  $folder   = pnModAPIFunc('photoshare',
                           'user',
                           'get_folder_info',
                           array( 'folderID' => $folderID ));
  if ($folder === false)
    return photoshareErrorAPIGet();
  else if ($folder === true)
  {
      // Unknown folder => show folder list
    pnRedirect(pnModURL('photoshare', 'user', 'viewallfolders'));
    return true;
  }

  $imageID = photoshareGetCurrentImageID();
  $mayEdit = photoshareAccessFolder($folderID, photoshareAccessRequirementEdit, '');

    // Check for optional template name in the query
  $templateNameOptional = pnVarCleanFromInput('template');
  $templateName = (isset($templateNameOptional) ? $templateNameOptional : $folder['template']);

    // Get template object
  $template = pnModAPIFunc('photoshare',
                           'user',
                           'load_template',
                           array( 'templateName' => $templateName ));
  if ($template === false)
    return photoshareErrorAPIGet();

    // Get folder recursion level
  $folderDepth = $template->getFolderDepth();

    // Retrive folder data for template
  $templateData = pnModAPIFunc('photoshare', 
                               'user',
                               'get_folder_info_rec', 
                               array( 'folderID' => $folderID,
                                      'depth'    => $folderDepth,
                                      'viewKey'  => $viewKey));

  $templateData['initialImageID'] = $imageID;

    // Output standard menu - if required
  if (!$templateData['folder']['hidepnframe'])
  {
    $menuHide = array( _PSMENUADDFOLDER    => true,
                       _PSMENUADDIMAGES    => true,
                       _PSMENUFOLDEREDIT   => true,
                       _PSMENUVIEWFOLDER   => true,
                       _PSMENUFOLDERDELETE => true,
                       _PSMENUPUBLISHALBUM => true,
                       _PSMENUTHISFOLDER   => !$mayEdit);
    $menuSettings = array( 'gotoCurrentFolder' => true );
    photoshareMakeMainMenu($output, $folderID, $menuHide, $menuSettings, NULL, false, 'showimages');
  }

    // Create template specific stylesheet URL.
  if ($template->usesStyleSheet())
  {
    $cssURL = "modules/" . pnVarPrepForOS(photoshareModGetName()) . "/templates/" . pnVarPrepForOS($templateName)
              . "/themes/" . pnVarPrepForOS(pnUserGetTheme()) . "/style.css";

      // Use default stylesheet if the theme specific stylesheet do not exist
    if (!@file_exists($cssURL))
      $cssURL = "modules/" . pnVarPrepForOS(photoshareModGetName()) . "/templates/" . pnVarPrepForOS($templateName)
                . "/themes/photoshare/style.css";
      
    if ($templateData['folder']['hidepnframe'])
    {
        // Manual output of headers (including CSS link) - pretend to do what the theme normaly does
      $pncssURL = "themes/" . pnUserGetTheme() . "/style/style.css";
      echo   "<html>\n"
           . "<head>\n"
           . "<link rel=\"StyleSheet\" href=\"$pncssURL\" type=\"text/css\">\n"
           . photoshareGetMainStyleSheetLink() 
           . "\n<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">\n"
           . "</head>\n"
           . "<body>\n";
    }
    else
    {
        // Use PostNuke variable for insertion of special HTML header tags.
      global $additional_header;
      if (!is_array($additional_header))
        $additional_header = array();
      $additional_header[] = "<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">";
    }
  }
  else
  {
    if ($templateData['folder']['hidepnframe'])
    {
        // Manual output of headers (including CSS link)
      $pncssURL = "themes/" . pnUserGetTheme() . "/style/style.css";
      echo   "<html>\n"
           . "<head>\n"
           . "<link rel=\"StyleSheet\" href=\"$pncssURL\" type=\"text/css\">\n"
           . photoshareGetMainStyleSheetLink() 
           . "\n</head>\n"
           . "<body>\n";
    }
  }

    // Ask the template to render itself (with the use of a template helper)
  $templateHelper = new TemplateHelper($templateData, $viewKey);
  $template->show($output, $templateData, $templateHelper);

  if ($templateData['folder']['hidepnframe'])
  {
    echo $output->GetOutput();
    echo "</body>\n</html>\n";

    return true;
  }

  return $output->GetOutput();
}


// -----------------------------------------------------------------------
// Find image and store in opening window's input element
// -----------------------------------------------------------------------

function photoshare_user_findimage()
{
    // Check access
  if (!photoshareAccessFolder(-1, photoshareAccessRequirementView, ''))
    return photoshareErrorPage(__FILE__, __LINE__, _PSNOAUTH);

  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  $user = pnUserGetVar('uid');
  $targetInputID = pnVarCleanFromInput('targetID');
  $resultURLFormat = pnVarCleanFromInput('url');
  $resultHTMLFormat = pnVarCleanFromInput('html');
  $targetMode = pnVarCleanFromInput('target');

  $folders =  pnModAPIFunc('photoshare',
                           'user',
                           'get_accessible_folders',
                           array('user'       => $user,
                                 'getForList' => false) );
  
  if ($folders === false)
    return photoshareErrorAPIGet();

  $theme = pnVarPrepForOS(pnUserGetTheme());
  $cssURL = "themes/$theme/style/style.css";

  echo   "<html>\n"
       . "<head>\n"
       . "\n<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">\n"
       . "<script src=\"modules/photoshare/pnjavascript/findimage.js\"></script>\n"
       . "</head>\n";
  
  echo "<body onLoad=\"handleOnLoad()\">\n";
  
  $initialFolderID = $folders[0]['id'];
  echo "<script>\n"
       . "var imageInfo = {};\n"
       . "var initialFolderID = $initialFolderID;\n"
       . "var targetInputID = \"$targetInputID\";\n"
       . "</script>\n";

  echo "<h2>" . _PSFINDIMAGE . "</h2>\n"
       . "<table><tr><td><img id=\"previewImage\"></td><td valign=\"top\">\n";
  echo "<table><tr><td>" . _PSFOLDER . ":\n</td><td><select id=\"folderSelect\" onChange=\"handleFolderSelect(this)\">\n";

    // Iterate over folders to print options
  foreach ($folders as $folder)
  {
    $folderInfo =  pnModAPIFunc('photoshare',
                                'user',
                                'get_folder_info',
                                array('folderID'        => $folder['id'],
                                      'countSubFolders' => true) );
    
    if ($folderInfo === false)
      return photoshareErrorAPIGet();
    else if ($folderInfo === true)
      photoshareErrorPage(__FILE__, __LINE__, _PSUNKNOWNFOLDER . " ($folder[id])" );

    echo "<option value=\"$folderInfo[id]\">$folder[title]</option>\n";
  }

  echo "</select></td></tr>\n";
  echo "<script>\n";

  echo "var thumbnailBaseURL = \"" . pnModURL('photoshare', 'user', 'viewimage') . "&thumbnail=1&iid=\";\n";
  echo "var displayImageBaseURL = \"" . pnModURL('photoshare', 'user', 'displayimage') . "&iid=\";\n";
  echo "var folderBaseURL = \"" . pnModURL('photoshare', 'user', 'showimages') . "&fid=\";\n";

    // Iterate over folders to print JavaScript image info
  foreach ($folders as $folder)
  {
    echo "imageInfo[$folder[id]] = [";
    
    $images = pnModAPIFunc('photoshare',
                           'user',
                           'get_image_list',
                           array( 'folderID' => $folder['id'] ) );
    $images = $images['images'];

    $first = true;
    foreach ($images as $image)
    {
      if (!$first)
        echo ",";
      $first = false;
      $title = addcslashes( pnVarPrepForDisplay($image['title']), "\0..\37\"");
      echo "{ id: \"$image[id]\", title: \"$title\" }";
    }

    echo "];\n";
  }

  echo "</script>\n";

  echo "<tr><td>" . _PSIMAGE . ":\n</td><td><select id=\"imageSelector\" onChange=\"handleImageSelect(this)\">\n"
       . "</select></td></tr></table>\n"
       . "</td></tr></table>\n";

  if ($resultHTMLFormat == 'img')
  {
    echo   _PSINSERTIMAGE . "&nbsp;"
         . "<select name=\"htmlFormat\" id=\"htmlFormat\">"
         . "<option value=\"fullImage\">". _PSINSFULLIMAGE . "</option>\n"
         . "<option value=\"thumbnail\">". _PSINSTHUMBNAIL . "</option>\n"
         . "<option value=\"thumbnailPopup\">". _PSINSTHUMBNAILPOPUP . "</option>\n"
         . "<option value=\"fullImageURL\">". _PSINSFULLIMAGEURL . "</option>\n"
         . "<option value=\"fullImageURLPopup\">". _PSINSFULLIMAGEURLPOPUP . "</option>\n"
         . "<option value=\"albumURL\">". _PSINSALBUMURL . "</option>\n"
         . "<option value=\"albumThumbnailURL\">". _PSINSALBUMURLTHUMBNAIL . "</option>\n"
         . "<option value=\"albumURLpopup\">". _PSINSALBUMURLPOPUP . "</option>\n"
         . "<option value=\"albumThumbnailURLpopup\">". _PSINSALBUMURLTHUMBNAILPOPUP . "</option>\n"
         . "</select>\n";
  }

  echo   "<button onClick=\"handleOnClickSelect('$resultURLFormat', '$resultHTMLFormat', '$targetMode')\">" . _PSFINDSELECT . "</button>"
       . "<button onClick=\"handleOnClickCancel()\">" . _PSCANCEL ."</button>\n";

  echo "</body></html>\n";

  return true;
}

// -----------------------------------------------------------------------
// Menu and footer
// -----------------------------------------------------------------------

function photoshareMakeMainMenu(&$output, $folderID, $menuHide, $settings, $title, $addEditIcons, $trailClickCommand)
{
  if (!pnModAPILoad('photoshare', 'user'))
  {
    $output->Text( photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED) );
    return false;
  }

    // Get folder trail information
  $trail = pnModAPIFunc('photoshare',
                        'user',
                        'get_folder_trail',
                        array( 'folderID' => $folderID ));
  if ($trail === false)
  {
    $output->Text( photoshareErrorAPIGet() );
    return false;
  }

    // If any error message available then output it for debugging
  if (pnGetStatusMsg())
  {
    $output->Text(pnGetStatusMsg());
    $output->LineBreak();
  }

  $output->SetOutputMode(_PNH_RETURNOUTPUT);

  $menu  = array();
  $first = true;

  $editFolder = array();
  if ($settings['gotoCurrentFolder'])
    $editFolder['fid'] = $folderID;

  $hasEditAccess = pnSecAuthAction(0, 'photoshare::', '::', ACCESS_EDIT);
  if (!$hasEditAccess)
    $menuHide[_PSMENUMYFOLDERS] = true;

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUMYFOLDERS, 
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'view',
                                            array()),
                                            _PSMENUMYFOLDERS));

 photoshareAddToMenu($menu, $first, $menuHide, _PSMENUTHISFOLDER, 
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'view',
                                            $editFolder),
                                            _PSMENUTHISFOLDER));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUADDFOLDER,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'addfolder',
                                            array('fid' => $folderID)),
                                            _PSMENUADDFOLDER));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUADDIMAGES,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'addimages',
                                            array('fid' => $folderID)),
                                            _PSMENUADDIMAGES));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUFOLDEREDIT,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'editfolder',
                                            array('fid' => $folderID)),
                                            _PSMENUFOLDEREDIT));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUVIEWFOLDER,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'showimages',
                                            array('fid' => $folderID)),
                                            _PSMENUVIEWFOLDER));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUFOLDERDELETE,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'deletefolder',
                                            array('fid' => $folderID)),
                                            _PSMENUFOLDERDELETE));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUPUBLISHALBUM,
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'editaccess',
                                            array('fid' => $folderID)),
                                            _PSMENUPUBLISHALBUM));

  photoshareAddToMenu($menu, $first, $menuHide, _PSMENUVIEWALLFOLDERS, 
                      $output->URL(pnModURL('photoshare',
                                            'user',
                                            'viewallfolders'),
                                            _PSMENUVIEWALLFOLDERS));

  $output->SetOutputMode(_PNH_KEEPOUTPUT);

  $oldMode = $output->SetInputMode(_PNH_VERBATIMINPUT);

    // Start window
  $output->Text("<table class=\"photoshare-header\">\n");

    // Add title and bread crumbs
  $output->Text("<tr class=\"photoshare-header-title\"><td>");
  if ($title != NULL)
    $output->Text('<div class="photoshare-title">' . pnVarPrepForDisplay($title) . '</div>');
  photoshareMakeTrail($output, $trail, $trailClickCommand);
  $output->Text("</td></tr>\n");

  $output->Text("<tr class=\"photoshare-header-menu\"><td>");
  $output->Text('<table><tr>');
  foreach ($menu as $menuItem)
    $output->Text("<td>$menuItem</td>");
  $output->Text("<td>&nbsp;</td></tr></table>\n");
  $output->Text("</td></tr>\n");

  if ($addEditIcons)
    photoshareMakeEditIcons($output, $folderID);

  $output->Text("</table><br>\n");

  $output->SetInputMode($oldMode);
}


function photoshareAddToMenu(&$menu, &$first, $menuHide, $name, $item)
{
  if ($menuHide === false)
    return;

  if (!array_key_exists($name,$menuHide) ||  $menuHide[$name] == false)
  {
    $menu[] = "$item";
    $first = false;
  }
}


  // Draw the "bread crumbs" (trail) showing the path to the current album
function photoshareMakeTrail(&$output, $trail, $trailClickCommand)
{
  if ($trailClickCommand == null)
    $trailClickCommand = 'view';

  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

    // Print the folder titles separated with a small arrow

  $output->Text('<div class="photoshare-trail">');
  for ($size=$i=sizeof($trail)-1; $i>=0 ; --$i)
  {
    $folder = $trail[$i];

    if ($i > 0)
    {
      $folderURL = pnModUrl('photoshare', 'user', $trailClickCommand, array('fid' => $folder['id']));
      $output->Text("<a href=\"$folderURL\">$folder[title]</a>");
    }
    else
      $output->Text("$folder[title]");

    if ($i != 0)
      $output->Text(" <img src=\"$imageDir/trail_arrow.gif\"> ");
  }
  $output->Text('</div>');
}


function photoshareMakeMainFooter(&$output)
{
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( _PSCAPACITYUSED . photoshareCapacityInfoHTML() );
  $output->SetInputMode(_PNH_PARSEINPUT);
}


// -----------------------------------------------------------------------
// HTML for progress-bar
// -----------------------------------------------------------------------

function photoshareCapacityInfoHTML()
{
  $userInfo = pnModAPIFunc('photoshare',
                           'user',
                           'get_user_info');
  if ($userInfo === false)
    return photoshareErrorAPIGet();

  return photoshareProgressbarHTML("MAX", $userInfo['totalCapacityUsed'], $userInfo['imageSizeLimitTotal'], 1000000.0, _PSMEGABYTES);
}


function photoshareProgressbarHTML($title, $size, $maxSize, $scale, $unitTitle)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $leftSize   = intval($maxSize > 0 ? ($size*100)/$maxSize : 100);
  $rightSize = intval($maxSize > 0 ? 100-$leftSize : 0);

  $str = sprintf("%.2f %s %.2f %s", $size/$scale, _PSOF, $maxSize/$scale, $unitTitle);

  return   "<img src=\"$imageDir/bar_left.gif\" height=\"5\" width=\"$leftSize\">"
         . "<img src=\"$imageDir/bar_right.gif\" height=\"5\" width=\"$rightSize\">"
         . " $leftSize% ($str)";
}


// -----------------------------------------------------------------------
// -----------------------------------------------------------------------

  // Return -1 if no current ID exists, otherwise positive integer ID of folder
function photoshareGetCurrentFolderID()
{
  $folderID = pnVarCleanFromInput('fid');
  
  if (is_numeric($folderID))
    return intval($folderID);

  return -1;
}


// Return -1 if no current ID exists, otherwise positive integer ID of image
function photoshareGetCurrentImageID()
{
  $imageID = pnVarCleanFromInput('iid');
  
  if (is_numeric($imageID))
    return intval($imageID);

  return -1;
}


function photoshareGetFolderInfoHTML($folder)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';
  $folderHTML = "<img src=\"$imageDir/folder.gif\">";

  $html = "<table class=\"photoshare-folder-info\"><tr valign=\"top\"><td>$folderHTML</td>\n<td>\n";

  $html .= "<table>\n";
  $html .= '<tr><td>' . _PSFOLDER     . ":</td><td>" . pnVarPrepForDisplay($folder['title']) . "</td></tr>\n";
  $html .= '<tr><td>' . _PSIMAGECOUNT . ":</td><td>$folder[imageCount]</td></tr>\n";
  $html .= '<tr><td>' . _PSOWNER      . ":</td><td>" . pnVarPrepForDisplay($folder['ownername']). "</td></tr>\n";

  $html .= "</table>\n</td></tr></table>\n";

  return $html;
}


function photoshareGetFolderHTML($title, $folderID, $parentID)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $folderURL  = pnModUrl('photoshare', 'user', 'view', array('fid' => $folderID));
  $folderHTML = "<a href=\"$folderURL\"><img src=\"$imageDir/folder.gif\" title=\"" . _PSVIEWFOLDER . "\" border=\"0\"></a>";
  
  $html = "<table class=\"photoshare-folder\"><tr><td>$folderHTML</td></tr>\n";

  $deleteURL  = pnModUrl('photoshare', 'user', 'deletefolder', array('fid' => $folderID, 'pid' => $parentID));
  $deleteHTML = "<a href=\"$deleteURL\"><img src=\"$imageDir/delete.gif\" title=\"" . _PSDELETEFOLDER . "\" border=\"0\"></a>";

  $editURL  = pnModUrl('photoshare', 'user', 'editfolder', array('fid' => $folderID, 'pid' => $parentID));
  $editHTML = "<a href=\"$editURL\" border=\"0\"><img src=\"$imageDir/setting.gif\" title=\"" . _PSEDITFOLDER . "\" border=\"0\"></a>";

  $html .= "<tr><td> <table><tr><td>$editHTML</td><td>$deleteHTML</td></tr></table> </td></tr>\n";

  $html .= "<tr><td width=\"100\">" . pnVarPrepForDisplay($title) . "</td></tr>\n";

  $html .= '</table>';

  return $html;
}


function photoshareGetFolderUpHTML($parentID)
{
  $imageDir = 'modules/' . photoshareModGetName() . '/pnimages';

  $folderURL  = pnModUrl('photoshare', 'user', 'view', array('fid' => $parentID));
  $folderHTML = "<a href=\"$folderURL\" border=\"0\"><img src=\"$imageDir/folder_up.gif\" title=\"" . _PSBACK . "\" border=\"0\"></a>";
  
  $html = "<table><tr><td width=\"100\">$folderHTML</td></tr></table>\n";

  return $html;
}


function photoshareGetThumbnailInfoHTML($image)
{
  $imageURL      = pnModUrl('photoshare', 'user', 'viewimage', array('iid' => $image['id'], 'thumbnail' => 1));
  $imageHTML     = "<img src=\"$imageURL\">";

  $html = "<table class=\"photoshare-image-info\"><tr valign=\"top\"><td>$imageHTML</td>\n<td>\n";

  $html .= "<table>\n";
  $html .= "<tr><td colspan=\"2\">" . pnVarPrepForDisplay($image[title]) . "</td></tr>\n";
  $html .= '<tr><td>' . _PSOWNER      . ":</td><td>" . pnVarPrepForDisplay($image[ownername]) . "</td></tr>\n";

  $html .= "</table>\n</td></tr></table>\n";

  return $html;
}


// -----------------------------------------------------------------------
// Output helper
// -----------------------------------------------------------------------

function outputSubmitButton(&$output, $title, $name)
{
  $output->tabindex++;
  $output->SetInputMode(_PNH_VERBATIMINPUT);
  $output->Text( '<input'
                .' type="submit"'
                .' value="'.pnVarPrepForDisplay($title).'"'
                .' align="middle"'
                ." name=\"$name\""
                .' tabindex="'.$output->tabindex.'"'
                .' />');
  $output->SetInputMode(_PNH_PARSEINPUT);

}


// -----------------------------------------------------------------------
// Access control
// -----------------------------------------------------------------------
function photoshareAccessFolder($folderID, $accessLevel, $viewKey)
{
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  return pnModAPIFunc('photoshare', 'user', 'get_folder_access', array('folderID'    => $folderID,
                                                                       'accessLevel' => $accessLevel,
                                                                       'viewKey'     => $viewKey) );
}


function photoshareAccessImage($imageID, $accessLevel, $viewKey)
{
  if (!pnModAPILoad('photoshare', 'user'))
    return photoshareErrorPage(__FILE__, __LINE__, _PSAPILOADFAILED);

  return pnModAPIFunc('photoshare', 'user', 'get_image_access', array('imageID'     => $imageID,
                                                                      'accessLevel' => $accessLevel,
                                                                      'viewKey'     => $viewKey) );
}


?>