<?php
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2003.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

class GalleryTemplate
{
  function getVersion()
  {
    return 1;
  }


  function getTitle()
  {
    return _PTMP_GALLERY_TITLE;
  }


  function getFolderDepth()
  {
    return 2;
  }


  function usesStyleSheet()
  {
    return true;
  }


  function show(&$output, $templateData, &$templateHelper)
  {
    $folders       = $templateData['folders'];
    $title         = $templateData['folder']['title'];
    $emptyImageURL = "modules/photoshare/templates/gallery/images/empty.gif";
    $thumbnailSize = pnModGetVar('photoshare', 'thumbnailsize');

    if (sizeof($templateData['images']) == 0  &&  sizeof($templateData['folders']) == 0)
    {
      $output->LineBreak();
      $output->Text(_PTMP_GALLERY_EMPTYALBUM);
      return;
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);

      // Add link to javascript for image display
    $output->Text('<script type="text/javascript" src="modules/' 
                  . pnVarPrepForOS(pnModGetName()) . "/templates/gallery/javascript/showimages.js\">\n</script>\n");

      // Add image data
    $output->Text("<script language=\"JavaScript\">\n");
    $output->Text("var imageData = [];\n");
    if (sizeof($templateData['images']) > 0)
    {
      $this->addImageData($output, $templateData, 0, $templateHelper);
      $initialImageURL = $templateHelper->imageURL($templateData['id'], $templateData['images'][0]['id']);
      $folderIndex = 1;
    }
    else if (sizeof($templateData['folders']) > 0)
    {
      $initialImageURL = $templateHelper->imageURL($templateData['folders'][0]['id'], $templateData['folders'][0]['images'][0]['id']);
      $folderIndex = 0;
    }
    foreach ($folders as $folder)
      $this->addImageData($output, $folder, $folderIndex++, $templateHelper);
    $output->Text("</script>\n");

      // Place a div tag surrounding everything - for styling
    $output->Text("<div class=\"psgallery-main\">\n");

	 // V4B 26-01-2004 TS start
	 // prevent the thumbnail folders from jumping, if a maximum height is declared
	 // added valign top to the cell displaying the image and the description too
	$max_y = pnModGetVar('photoshare','maxdisplayheight');
	if ($max_y > 0) $html_height = "height=\"".($max_y+10)."\"";
	else $html_height = "";
      // Add main image placeholder and title+description placeholders
    $output->Text("<table ".$html_height." class=\"psgallery-upper\">\n");
     // V4B 26-01-2004 TS start

    $output->Text("<tr>\n");
    $output->Text("<td valign=\"top\" class=\"psgallery-mainImage\">"
                  . "<img src=\"$initialImageURL\" id=\"mainImage\" class=\"photoshare-clickable\" onClick=\"handleOnClickImage(this)\"></td>\n");
    $output->Text("<td valign=\"top\" class=\"psgallery-mainText\"><table>");
    $output->Text(" <tr><td class=\"psgallery-title\"><span id=\"mainTitle\"></span></td></tr>");
    $output->Text("<tr><td class=\"psgallery-description\"><span id=\"mainDescription\"></span></td></tr></table></td>\n");
    $output->Text("</tr>\n");
    $output->Text("</table>\n");

    $output->Text("<table class=\"psgallery-lower\">\n");

      // Add table tabs
    $output->Text("<tr><td><table class=\"tabs\">\n");
    $output->Text("<tr>\n");
    if (sizeof($templateData['images']) > 0)
    {
      $this->addFolderTab($output, $templateData, 0);
      $folderIndex = 1;
    }
    else
      $folderIndex = 0;
    foreach ($folders as $folder)
      $this->addFolderTab($output, $folder, $folderIndex++);
    $output->Text("</tr>\n");
    $output->Text("</table></td></tr>\n");

      // Add thumbnails part
    $output->Text("<tr><td><div class=\"thumbnails\" id=\"thumbnailsDiv\" style=\"overflow:scroll;\">\n");
    $output->Text("</div></td></tr>\n");

    $output->Text("</table>\n");
    $output->Text("</div>\n");

    $output->Text("<script language=\"JavaScript\">handleOnLoad();</script>\n");

    $output->SetInputMode(_PNH_PARSEINPUT);
  }


  // =====================================
  // End API, start private implementation
  // =====================================

  function addFolderTab(&$output, $folderInfo, $folderIndex)
  {
    $folder = $folderInfo['folder'];
    $className = ($folderIndex == 0 ? "selected" : "unselected");

    $output->Text(  "<td><table class=\"$className\" onClick=\"handleOnClickTab($folderIndex)\" id=\"tab$folderIndex\"><tr>"
                  . "<td class=\"psgallery-tab-left\"></td>"
                  . "<td class=\"psgallery-tab-center\">$folder[title]</td>"
                  . "<td class=\"psgallery-tab-right\"></td></tr></table></td>\n");
  }


  function addImageData(&$output, $folderInfo, $folderIndex, &$templateHelper)
  {
    $folder = $folderInfo['folder'];
    $images = $folderInfo['images'];

    $html = "<table><tr>";
    $info = "[";
    $first = true;
    $pos = 0;

    foreach ($images as $image)
    {
      $title         = addcslashes( pnVarPrepForDisplay($image['title']), "\0..\37\"");
      $description   = addcslashes( pnVarPrepHTMLDisplay($image['description']), "\0..\37\"");
      $imageURL      = $templateHelper->imageURL($folder['id'], $image['id']);
      $thumbnailURL  = $templateHelper->thumbnailURL($folder['id'], $image['id']);
      $imageCURL     = addcslashes( $imageURL, "\0..\37\"" );
      $thumbnailCURL = addcslashes( $thumbnailURL, "\0..\37\"" );

      $html .= "<td><img src=\"$thumbnailURL\" alt=\"$title\" title=\"$title\" onclick=\"handleOnClickThumbnail($pos)\"></td>";

      if (!$first)
        $info .= ",";
      $first = false;

      // V4B 26-01-2004 TS start
	  // Resize image, if needed
      $max_x = pnModGetVar('photoshare','maxdisplaywidth');
      $max_y = pnModGetVar('photoshare','maxdisplayheight');
      $temp_x = $width  = $image['xSize'];
      $temp_y = $height = $image['ySize'];

      while (($width > $max_x) || ($height > $max_y))
      {
          if ($width > $max_x)
          {
             if ($max_x > 0)
			 {
			      $width  = $max_x;
                  $height = intval($temp_y*($width/$temp_x));
             } else {
                  $max_x = $width;
             }
          }
          if ($height > $max_y)
          {
              if ($max_y > 0)
			  {
                  $height  = $max_y;
                  $width   = intval($temp_x*($height/$temp_y));
              } else {
                  $max_y = $height;
              }
          }
      }

      $info .=   "\n  { title:\"$title\", "
               . "description:\"$description\", "
			   . "width:\"$width\", "
			   . "height:\"$height\", "
               . "src:\"$imageCURL\" } ";
      // V4B 26-01-2004 TS end		
       ++$pos;
    }

    $html .= "</tr></table>";
    $info .= "]";

    $output->Text("imageData[$folderIndex] = { rawHTML: \"" . addcslashes($html, "\0..\37\"") . "\",\n");
    $output->Text(" info: $info };\n");
  }

}


function photoshare_template_gallery()
{
  return new GalleryTemplate;
}

?>