<?php
// =======================================================================
// Photoshare by Jorn Lind-Nielsen (C) 2002.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

class SlideShowTemplate
{
    // Return the version of the template interface that this template supports.
  function getVersion()
  {
    return 1;
  }


  function getTitle()
  {
    return _PTMP_SLIDESHOW_TITLE;
  }


  function getFolderDepth()
  {
    return 1;
  }


  function usesStyleSheet()
  {
    return true;
  }


  function show(&$output, $templateData, $templateHelper)
  {
    $folderID       = $templateData['folder']['id'];
    $images         = $templateData['images'];
    $initialImageID = $templateData['initialImageID'];

      // Check for empty album
    if (count($images) > 0)
    {
        // Generate JavaScript info about the images
      $output->SetInputMode(_PNH_VERBATIMINPUT);

      $imageDir = 'modules/' . pnModGetName() . '/templates/slideshow/images';

      $output->Text("\n<script language=\"JavaScript\">\n" .
                    "  var translations = { start: \"" . _PTMP_SLIDESHOW_START . "\", " .
                                           "pause: \"" . _PTMP_SLIDESHOW_PAUSE . "\"};" .
                    "  var photoshareImages =\n  [\n");

      $index = 0;
      $startImageIndex = 0;
      foreach ($images as $image)
      {
        if ($index != 0)
          $output->Text(",\n");

        $title       = addcslashes( pnVarPrepForDisplay($image['title']), "\0..\37\"");
        $description = addcslashes( pnVarPrepHTMLDisplay($image['description']), "\0..\37\"");
        $imageURL    = $templateHelper->imageURL($folderID, $image['id']);

        // V4B 26-01-2004 TS start
	  // Resize image, if needed
      $max_x = pnModGetVar('photoshare','maxdisplaywidth');
      $max_y = pnModGetVar('photoshare','maxdisplayheight');
      $temp_x = $width  = $image['xSize'];
      $temp_y = $height = $image['ySize'];

      while (($width > $max_x) || ($height > $max_y))
      {
          if ($width > $max_x)
          {
             if ($max_x > 0)
			 {
			      $width  = $max_x;
                  $height = intval($temp_y*($width/$temp_x));
             } else {
                  $max_x = $width;
             }
          }
          if ($height > $max_y)
          {
              if ($max_y > 0)
			  {
                  $height  = $max_y;
                  $width   = intval($temp_x*($height/$temp_y));
              } else {
                  $max_y = $height;
              }
          }
      }

		$output->Text("    { title:\"$title\", description:\"$description\", url:\"$imageURL\", image:null, width:\"$width\", height:\"$height\" }");
		// V4B 26-01-2004 TS end		
        if ($image['id'] == $initialImageID)
          $startImageIndex = $index;

        ++$index;
      }
      $output->Text("\n  ];\n");
      $output->Text("var startImageIndex = $startImageIndex; // $initialImageID\n");
      $output->Text("var imageBaseURL = \"$imageDir\";\n");
      $thumbnailsURL = $templateHelper->folderURL($templateData['folder']['id'], 'thumbnails');
      $thumbnailsURL = addcslashes($thumbnailsURL, "\0..\37");
      $output->Text("var thumbnailsURL = \"$thumbnailsURL\";\n");
      $output->Text("</script>\n");

      $output->Text('<script type="text/javascript" src="modules/' 
                    . pnModGetName() . "/templates/slideshow/javascript/showimages.js\">\n</script>\n");

        // Generate the screen
	  $output->Text("<table ".$html_height." class=\"photoshare-show\" width=\"100%\">\n");

        // Add top buttons
      $buttons  = "<tr>\n";
      $buttons .= "<td><table class=\"photoshare-show-buttons\"><tr>\n";
      $buttons .= "<td class=\"photoshare-show-thumbnails\"><img src=\"$imageDir/button_thumbnails.gif\" title=\"" .
                  _PTMP_SLIDESHOW_BUTTONTHUMBNAILS .
                  "\" class=\"photoshare-button\" onClick=\"handleOnClickThumbnails()\" name=\"imageNext\"></td>\n";
      $buttons .= "<td class=\"photoshare-show-play\"><img src=\"$imageDir/button_play.gif\" title=\"" . _PTMP_SLIDESHOW_BUTTONPLAY . 
                  "\" class=\"photoshare-button\" onClick=\"handleOnClickPlay()\" name=\"imagePlay\"></td>\n";
      $buttons .= "<td class=\"photoshare-show-prev\"><img src=\"$imageDir/button_prev.gif\" title=\"" . _PTMP_SLIDESHOW_BUTTONPREVIMG . 
                  "\" class=\"photoshare-button\" onClick=\"handleOnClickPrev()\" name=\"imagePrev\"></td>\n";
      $buttons .= "<td class=\"photoshare-show-next\"><img src=\"$imageDir/button_next.gif\" title=\"" . _PTMP_SLIDESHOW_BUTTONNEXTIMG . 
                  "\" class=\"photoshare-button\" onClick=\"handleOnClickNext()\" name=\"imageNext\"></td>\n";

        // Add speed selector
      $buttons .= "<td>" . _PTMP_SLIDESHOW_SLIDESHOWTIME . " <select onChange=\"handleChangeTime()\" id=\"timeSelector\">\n"
                  . "<option value=\"2\">2 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"4\">4 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"6\">6 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"8\" selected>8 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"10\">10 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"15\">15 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"20\">20 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"30\">30 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "<option value=\"40\">40 " . _PTMP_SLIDESHOW_SEC . "</option>\n"
                  . "</select>\n";
                  
        // Add image count
      $buttons .= "<td class=\"photoshare-show-count\"><span id=\"imageInfoText\"></span></td>\n";
      $buttons .= "</tr></table></td>\n";
      $buttons .= "<tr>\n";
      $buttons .= "<td class=\"photoshare-show-title\"><span id=\"imageTitleText\"></span></td>\n";
      $buttons .= "</tr>\n";
      $buttons .= "<tr>\n";
      $buttons .= "<td class=\"photoshare-show-description\"><span id=\"imageDescriptionText\"></span></td>\n";
      $buttons .= "</tr>\n";
      $output->Text($buttons);

        // V4B 26-01-2004 TS start
        // prevent the thumbnail folders from jumping, if a maximum height is declared
 	      // packed in a table here, because Mozilla & Co ignore the height of a cell
      $max_y = pnModGetVar('photoshare','maxdisplayheight');
      if ($max_y > 0) $html_height = "height=\"".($max_y+20)."\"";
      else $html_height = "";

    $output->Text('<tr width="100%"><td valign="top" align="center" class="photoshare-show-image">');
	  $output->Text('<table '.$html_height.' width="100%"><tr>');
	  $output->Text('<td width="100%" align="center"><img id="imageLocation" name="imageLocation" class="photoshare-clickable" onClick="handleOnClickImage(this)"></td>');
    $output->Text('</tr></table></td></tr>');
        // V4B 26-01-2004 TS end

      $output->Text("</table>\n");

      $output->Text("<script language=\"JavaScript\">\nhandleOnLoad();\n</script>\n");
      $output->SetInputMode(_PNH_PARSEINPUT);
    }
    else
    {
      $output->LineBreak();
      $output->Text(_PTMP_SLIDESHOW_EMPTYALBUM);
    }
  }
}

function photoshare_template_slideshow()
{
  return new SlideShowTemplate;
}


?>