<?php
// File: $Id: pncgroupsinfos.php,v 1.1.1.1 2004/05/06 03:58:11 dyksjare Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Franky Chestnut !
// Purpose of file: Block Infos for the pncGroups AddOn
// ----------------------------------------------------------------------

pnSecAddSchema('pncgroups:pncgroupsinfos:', 'Block title::');

$blocks_modules['pncgroupsinfos'] = array(		'module'			=> 'pncgroups',
												'text_type'			=> 'pncgroupsinfos',
												'text_type_long'	=> 'pncGroups Infos block',
												'func_display' 		=> 'pncgroups_pncgroupsinfos_display',
												'func_edit'			=> 'pncgroups_pncgroupsinfos_modify',
												'func_update'		=> 'pncgroups_pncgroupsinfos_update',
												'allow_multiple'	=> true,
												'form_content'		=> false,
												'form_refresh'		=> false,
												'show_preview'		=> true);

function pncgroups_pncgroupsinfos_display($blockinfo)
{

	if (!pnSecAuthAction(0, 'pncgroups:pncgroupsinfos:', "$blockinfo[title]::", ACCESS_READ)) {
		return;
	}
	
	$vars = pnBlockVarsFromContent($blockinfo['content']);

    // Database information
    pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable =pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];

	$groupresult = $dbconn->Execute("SELECT	$pncgcolumn[gid],
											$pncgcolumn[description],
											$pncgcolumn[gopen],
											$pncgcolumn[gnbumax]
									FROM	$pncgtable
									WHERE	$pncgcolumn[type]!='-1'");

	$output = new pnHTML();
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	
	$output->Text("<center>\n");
	$output->Text("<b>"._SHOWTITLE."</b>\n");
	$output->Text("<br><br>\n");
	
	while(list($gid, $description, $gopen, $gnbumax) = $groupresult->fields) {

		$groupresult->MoveNext();
	    $gcolumn = &$pntable['groups_column'];
		$gnameresult = $dbconn->Execute("	SELECT	$gcolumn[name]
											FROM	$pntable[groups]
											WHERE	$gcolumn[gid]='".pnVarPrepForStore($gid)."'");
	    if($dbconn->ErrorNo()<>0) {
		    echo "DB Error: " . $dbconn->ErrorMsg();
	    }
		
		list($gname) = $gnameresult->fields;
		$querycount = $dbconn->Execute("SELECT count(*)
										FROM $groupmship
										WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($gid)."'");
		list($howmuch) = $querycount->fields;

		if ($howmuch >= $gnbumax) {
			$status = "<font color=red>"._ITSFULLBABY."</font>";
		} elseif ($howmuch < $gnbumax && $gopen == '1') {
			$status = "<font color=green>"._COMEANDGETME."</font>";
		} elseif ($howmuch < $gnbumax && $gopen == '0') {
			$status = "<font color=red>"._ITSCLOSEBABY."</font>";
		} else {
			$status = "";
		}
		
		$output->Text("<a href=\"modules.php?op=modload&name=pncgroups&file=index&showgid=".pnVarPrepForDisplay($gid)."\" title=\"".pnVarPrepForDisplay($description)."\">\n");
		$output->Text(pnVarPrepForDisplay($gname));
		$output->Text("</a>\n");
		$output->Text("<br>\n");
		
		if ($vars['fullinfo'] == "1") {
			$output->Text("<br>\n");
			$output->Text(_HOWMANYOFYOU."".pnVarPrepForDisplay($howmuch).""._MAXOFYOU."".pnVarPrepForDisplay($gnbumax)."<br>\n");
		}
		$output->Text(_DUHSTATUS);
		$output->Text(pnVarPrepHTMLDisplay($status));
		$output->Text("<br><hr><br>\n");
	}
	
	$output->Text("<a href=\"modules.php?op=modload&name=pncgroups&file=index\">");
	$output->Text(_SHOWMEALL);
	$output->Text("</a>");
	$output->Text("</center>");
	
	$output->SetInputMode(_PNH_PARSEINPUT);
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);

}

/**
 * modify block settings
 */
function pncgroups_pncgroupsinfos_modify($blockinfo)
{
    // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    if (empty($vars['fullinfo'])) {
        $vars['fullinfo'] = 1;
    }
	
    // Create row
    $row = array();
	
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
	
	$row[] = $output->Text(_SHOWSTATS);
	
	$fullinfo[] = array('id'	=> 0,
						'name'	=> _GNO);
	$fullinfo[] = array('id'	=> 1,
						'name'	=> _GYES);
	$row[] = $output->FormSelectMultiple(	'fullinfo',
	                                     	$fullinfo,
											0,
	                                        1,
	                                        $vars['fullinfo']);
	
	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	$output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

/**
 * update block settings
 */

function pncgroups_pncgroupsinfos_update($blockinfo)
{
    $vars['fullinfo'] = pnVarCleanFromInput('fullinfo');

    $blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}

?>