<?php
// $Id: pninit.php
// -------------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// -------------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// -------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// -------------------------------------------------------------------------
// Original Author of file: Chestnut ! http://www.pnconcept.com
// Purpose of file:  Initialisation functions for the pncGroups Add-On v0.1
// -------------------------------------------------------------------------

function pncgroups_init()
{
	
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $currentlang = pnUserGetLang();
	
    $pncgtables = $pntable['pncgroups_pending'];
    $pncgcolumn = &$pntable['pncgroups_pending_column'];
    
    $sql = "CREATE TABLE $pncgtables (
            $pncgcolumn[gid] int(11) NOT NULL,
            $pncgcolumn[uid] int(11) NOT NULL)";

    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
        return false;
    }

/////


    $pncgtables = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];

    $sql = "CREATE TABLE $pncgtables (
            $pncgcolumn[gid] int(11) NOT NULL,
            $pncgcolumn[type] varchar(25) NOT NULL default '',
            $pncgcolumn[description] varchar(200) NOT NULL default '',
            $pncgcolumn[gprefix] varchar(25) NOT NULL default '',
            $pncgcolumn[gopen] int(1) NOT NULL default '0',
            $pncgcolumn[gmoderated] int(1) NOT NULL default '1',
            $pncgcolumn[gnbuser] int(11) NOT NULL default '0',
            $pncgcolumn[gnbumax] int(11) NOT NULL default '0',			
            $pncgcolumn[link] int(11) NOT NULL default '0',
            $pncgcolumn[uidmaster] int(11) NOT NULL default '0',
            PRIMARY KEY  (pn_gid))";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        //pnSessionSetVar('errormsg', $dbconn->ErrorMsg().' - '._CREATETABLEFAILED.'<br>'.$pncgtables.'<br>'.$pncgcolumn[gid].'<br>');
		pnSessionSetVar('errormsg', _CREATETABLEFAILED);
        return false;
    }

    $pncgsource = $pntable['groups'];
    $pncgsourcecolumn = &$pntable['groups_column'];

    $sql = "SELECT $pncgsourcecolumn[gid]
			FROM $pncgsource";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
        return false;
    }
	
	while(list($gid) = $result->fields) {
		$result->MoveNext();
		$sql = "INSERT INTO $pncgtables (" . $pncgcolumn[gid] . ", " . $pncgcolumn[type] . ") VALUES ('".pnVarPrepForStore($gid)."', '-1')";
		$result2 = $dbconn->Execute($sql);
	    if ($dbconn->ErrorNo() != 0) {
	        pnSessionSetVar('errormsg', 'Insert Failed');
	        return false;
	    }
	}

    pnModSetVar('pncgroups', 'bold', 0);
    pnModSetVar('pncgroups', 'itemsperpage', 15);
    pnModSetVar('pncgroups', 'pncgadmmsg', 'Welcome to the Groups Settings');

    return true;
}

function pncgroups_delete()
{

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $sql = "DROP TABLE $pntable[pncgroups_pending]";
    $dbconn->Execute($sql);

    $sql = "DROP TABLE $pntable[pncgroups]";
    $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', 'Delete Table Failed');
        return false;
    }

    pnModDelVar('pncgroups', 'itemsperpage');
    pnModDelVar('pncgroups', 'bold');
	pnModDelVar('pncgroups', 'pncgadmmsg');

    return true;
}

?>
