<?php 
// $Id: pninit.php,v 1.1.1.1 2004/05/06 03:58:37 dyksjare Exp $
// ----------------------------------------------------------------------
// Publications module
// Copyright (C) 2004 by Jared Dykstra
// Written by Jared Dykstra
// Get the newest version at http://shef.ca
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

function publications_initmodvars()
{
    // Set up an initial value for a module variable.  
    //pnModSetVar('publications', 'upload_dir_ext', 'UPLOAD_DIRECTORY_SVR');
    //pnModSetVar('publications', 'upload_dir_int', 'UPLOAD_DIRECTORY_INT');

    return true;
}

function publications_delmodvars()
{
    // Delete any module variables
    //pnModDelVar('publications', 'upload_dir_ext');
    //pnModDelVar('publications', 'upload_dir_int');

    return true;
}


/**
 * initialise the template module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function publications_init()
{


    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Create Tables

$sql = "CREATE TABLE $pntable[publications_categories] (
  pn_cid int(11) NOT NULL auto_increment,
  pn_title varchar(50) NOT NULL default '',
  pn_description text NOT NULL,
  PRIMARY KEY  (pn_cid) )";

$dbconn->Execute($sql);

//Just in case the user screws things up, we need to check here
//and figure out if the books database already exists, and if
//it does, which version exists.

  if (mysql_errno() == 1050) {
    pnSessionSetVar('errormsg','You already have a publications database installed -- skipping publications table creation and initializing the publications module');
          publications_initmodvars();
          return true;
  }



$sql = "CREATE TABLE $pntable[publications_downloads] (
  pn_lid int(11) NOT NULL auto_increment,
  pn_cid int(11) NOT NULL default '0',
  pn_sid int(11) NOT NULL default '0',
  pn_title varchar(100) NOT NULL default '',
  pn_url varchar(254) NOT NULL default '',
  pn_description text NOT NULL,
  pn_date datetime default NULL,
  pn_name varchar(100) NOT NULL default '',
  pn_email varchar(100) NOT NULL default '',
  pn_hits int(11) NOT NULL default '0',
  pn_submitter varchar(60) NOT NULL default '',
  pn_ratingsummary double(6,4) NOT NULL default '0.0000',
  pn_totalvotes int(11) NOT NULL default '0',
  pn_totalcomments int(11) NOT NULL default '0',
  pn_filesize int(11) NOT NULL default '0',
  pn_version varchar(10) NOT NULL default '',
  pn_homepage varchar(200) NOT NULL default '',
  PRIMARY KEY  (pn_lid) )";

$dbconn->Execute($sql);


$sql = "CREATE TABLE $pntable[publications_editorials] (
  pn_id int(11) NOT NULL default '0',
  pn_adminid varchar(60) NOT NULL default '',
  pn_timestamp datetime NOT NULL default '0000-00-00 00:00:00',
  pn_text text NOT NULL,
  pn_title varchar(100) NOT NULL default '',
  PRIMARY KEY  (pn_id) )";

$dbconn->execute($sql);


$sql = "CREATE TABLE $pntable[publications_modrequest] (
  pn_requestid int(11) NOT NULL auto_increment,
  pn_lid int(11) NOT NULL default '0',
  pn_cid int(11) NOT NULL default '0',
  pn_sid int(11) NOT NULL default '0',
  pn_title varchar(100) NOT NULL default '',
  pn_url varchar(254) NOT NULL default '',
  pn_description text NOT NULL,
  pn_modifysubmitter varchar(60) NOT NULL default '',
  pn_brokendownload int(3) NOT NULL default '0',
  pn_name varchar(100) NOT NULL default '',
  pn_email varchar(100) NOT NULL default '',
  pn_filesize int(11) NOT NULL default '0',
  pn_version varchar(10) NOT NULL default '',
  pn_homepage varchar(200) NOT NULL default '',
  PRIMARY KEY  (pn_requestid) )";

$dbconn->Execute($sql);


$sql = "CREATE TABLE $pntable[publications_newdownload] (
  pn_lid int(11) NOT NULL auto_increment,
  pn_cid int(11) NOT NULL default '0',
  pn_sid int(11) NOT NULL default '0',
  pn_title varchar(100) NOT NULL default '',
  pn_url varchar(254) NOT NULL default '',
  pn_description text NOT NULL,
  pn_name varchar(100) NOT NULL default '',
  pn_email varchar(100) NOT NULL default '',
  pn_submitter varchar(60) NOT NULL default '',
  pn_filesize int(11) NOT NULL default '0',
  pn_version varchar(10) NOT NULL default '',
  pn_homepage varchar(200) NOT NULL default '',
  PRIMARY KEY  (pn_lid) )";

$dbconn->Execute($sql);



$sql = "CREATE TABLE $pntable[publications_subcategories] (
  pn_sid int(11) NOT NULL auto_increment,
  pn_cid int(11) NOT NULL default '0',
  pn_title varchar(50) NOT NULL default '',
  PRIMARY KEY  (pn_sid) )";

$dbconn->Execute($sql);



$sql = "CREATE TABLE $pntable[publications_votedata] (
  pn_id int(11) NOT NULL auto_increment,
  pn_lid int(11) NOT NULL default '0',
  pn_user varchar(60) NOT NULL default '',
  pn_rating int(11) NOT NULL default '0',
  pn_hostname varchar(60) NOT NULL default '',
  pn_comments text NOT NULL,
  pn_timestamp datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (pn_id) )";

$dbconn->Execute($sql);



    // Set up an initial value for a module variable.  Note that all module
    // variables should be initialised with some value in this way rather
    // than just left blank, this helps the user-side code and means that
    // there doesn't need to be a check to see if the variable is set in
    // the rest of the code as it always will be

    publications_initmodvars();

    // Initialisation successful
    return true;
}

/**
 * upgrade the template module from an old version
 * This function can be called multiple times
 */
function publications_upgrade($oldversion)
{

    pnSessionSetVar('errormsg', 'There is no old version to update');

    // Update successful
    return true;
}

/**
 * delete the template module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function publications_delete()
{

    publications_delmodvars();

    pnSessionSetVar('errormsg', 'Run delete.php in your publications directory to delete the publications database tables from your database.');

    return true;
}

?>
